;!!!!!! Zmieniono include obslugujce LCD wic trzeba sprawdzi czy dobrze wywietla na LCD
;
;
;!!!!!! przychodzca rozmowa jeli ton 400HZ zanikana conajmniej 5 sek.
;       pojawianie sie tonw o czasie trwania 200ms olewa
;!!!!!! Kryterium rozmowy zanik tomu: gdy ton zanika na 5 sek, olewatony trwajce 200ms
;
;---------------------------------------------------------------------------
;Zapis stronami                         przy zapisie konfigu da dodatkowe bajty
; IF FL_IICBUSY=FALSE THEN               aby byo ich 16
;   START_IIC
;   ADRS_IIC
;   DANA_IIC
;   licz16:=#16
; ELSE
;   IF licz16<>0 THEN
;     DEC licz16
;     DANA_IIC
;   ELSE
;     DANA_IIC
;     STOP_IIC
;     WAIT_IIC
;     licz16:=#16
;   END
; END
;
;
; - kod dostpu przy obsudze RS
;   1. Przy init zmienna "wazny_kod"=$00
;   2. po nawizaniu cznoci sprawdzenie zmiennej "wazny_kod"
;      jeli rwna 0 zapytanie o kod
;   3. jeli poprawny (lub zmienna rna od 0) ustawienie zmiennej "wazny_kod"
;      na czas 1 min
;   4. kady znak przychodzcy po RS ustawia t zmienn na 1 min pod warunkiem
;      e bya rna od 0
;   5. zmienna jest zmiejszana co sekund a do osignicia $00
;
; - kopia wywietlacza na RS co daje moliwo szukania nr wywoujcego w bazie komputera)
;   oraz moliwo podczenia zdalnego wywietlacza
;
;---------------- drugorzdne -------------
; - Mona zastosowa kompresj podczas zapisu prefiksu do eeprom i dekompresj
;   podczas odczytu. Wystarczy znaki skrci do szeciu bitw, na tym zaoszczdzimy
;   9znakw * 2bity = 18bitw co daje trzy znaki (3*6=18)
;
; - przy programowaniu czasu,itp nie uywa przesowania kursora w wybran pozycj tylko
;   sekwencji <CR> <RIGHT> ...<RIGNT> "/"
;
; - w include da opcje przesowu kursora
;   <LEFT> <RIGHT> <CR> <UP> <DOWN>
;
; - drukark ser obslugiwa na 4800, komputer na 2400
;
; - Tablica wit i jej edycja
;
; - zapis eeprom stronami po 16 bajtw
;   str_wr_eeprom_16, wr_eeprom_16, end_wr_eeprom_16
;   powinno da si zwikszy prdko transmisji do 4800 i zmiejszy si czas sortowania
;
; - zmiana prdkoci transmisji po rs przy odbiorze (jak w symulatorze)
;
; - rejestrowanie pocze ktre nie doszy do skutku
;   (konfig 0 - nie rejestruje, >0 minimalna liczba cyfr jakie zostan zarejestrowane)
;
; - rejestracja pocze przychodzcych (w konfigu czy wszystkie, odebrane, nieodebrane)
;
; - rejestracja na IRQ (wywietlanie w ptli gwnej (podobniejak rej_alr)
;
; - Przy starcie wysyaj na RS komunikat "Restrart RRRR/MM/DD gg:mm"
;
; - rejestrowa w pamici rozmw reset procesora i przyczyn
;
;----------------------------------------------------------------------------
; 1. To, e podczas rozmowy pojawia si "Nr" i kursor dotyczy (jak Pan pewnie
;    wie) stacjonarnych. Rozmowa z komrki jest ok. (tzn. napis "Rozmowa...".
;    Czyli pewnie sprawa z dekodowaniem CLIP.
;
; 2. To aden bd ale jest: ustawione zaliczanie po czasie - odebranie
;    rozmowy przychodzcej powoduje rozpoczcie naliczania jak dla wychodzcej
;    (po jakim czasie). Pewnie Pan sam bdzie wiedzia jak to zrobi - ja bym
;    da przed rozpoczciem zaliczania po czasie sprawdzenie czy by dzwonek
;    przedtem (w kocu jest jego sprztowe dekodowanie) ale pewnie mona
;    atwiej:)
;
;>>>>>>>>>>>>>>>>>>>>>>>> kompilacja F9 (emu 51-64) <<<<<<<<<<<<<<<<<<<<<<<<

EMU535                  EQU   0               ;!!! 1-dla Emu51-64, 0-dla CPU !!! Nie przeswa tej linii !!!

;----------------------------------------------------------------------------
		        include	'INCL:Global.incl'
		        include	'INCL:8051/55WD.incl'
		        include	'INCL:8051/piny_S8252.incl'

;============================================================================
DEMO_CLIPFSK            equ     NO      ;(YES/NO)
TIMEBACK                equ     YES     ;(YES) - wyswietlanie czasu do zakonczenia impulsu zamiast nazwy taryfy
INIT_TABLICE            equ     YES     ;(YES) - Wyczenie inicjalizacji (twardy reset)
TABLICE_TEL             equ     YES     ;(YES) - Wyczenie programowania tablic z telefonu
WDG55                   equ     NO      ;(NO)  - Wczenie wewnetrzego WDG w AT89C55WD
LIGHT_STANBY            equ     NO      ;(NO)  - Podwietlanie LCD zawsze
FLASH_CLIP              equ     NO      ;(NO)  - Wywietlanie CLIP DTMF przed dzwonkiem

SAA1064                 equ     NO      ;(NO)  - obsluga dodatkowych wyswietlaczy LED i inna organizacja danych na wywietlaczu
ERROR_SAA               equ     NO      ;(NO)  - obsugiwa bdy SAA?
STD_BRIGHT              equ     %01000010

MAREK                   equ     NO      ;(NO)  - proc "print_ostatnie" inny sposb wywietlania danych o rozmowach na LCD````

;============================================================================
VERSJA                  equ     $04             ;Wersja pliku konfiguracji
RSTIMER                 equ     1               ;Dla include nr timera obsugujcego RS
FREQUENCY               equ     2400
IIC_DELAY_CK            equ     1               ;Opnienie dla linii zegarowej IIC
SPEED_0h	        equ     256-78          ;H=256-78 dla 24MHz ; 10ms =  10000[s]*(24/12) =
SPEED_0l	        equ     256-240         ;L=256-32 dla 24MHz ; 20000 cykli = 78*256+32

LcdBus                  equ     0               ;Magistarala LCD typu PIO
DATA_LCD0               equ	P2.0            ;Port danych sterownika LCD
DATA_LCD1        	equ	P2.1
DATA_LCD2        	equ	P2.2
DATA_LCD3        	equ	P2.3
DATA_LCD4        	equ	P2.4
DATA_LCD5        	equ	P2.5
DATA_LCD6        	equ	P2.6
DATA_LCD7        	equ	P2.7
RS_LCD		        equ	P0.6            ;bit RS sterownika LCD
RW_LCD		        equ     P0.5            ;bit RW sterownika LCD
E_LCD		        equ     P0.7            ;bit Enable sterownika LCD
DO_LEWEJ                equ     $80
BEZ_ECHA                equ     $80
FL_8BIT_LCD 		equ     TRUE
H_LCD 		        equ	16
V_LCD 		        equ     2
FL_WAIT_LCD		equ     TRUE
HOME_ASCII	        equ     $fd             ;Powrt w $00
FEED_ASCII              equ     $fc             ;Wysw strony
REPEAT_ASCII            equ     $fb             ;Kod powtrzenia next znaku
CURS_ASCII              equ     $fa


STB_PRT                 equ     Pin38           ;Piny obsugujce Drukark
BUSY_PRT                equ     Pin39
D0_PRT                  equ     Pin28
D1_PRT                  equ     Pin27
D2_PRT                  equ     Pin26
D3_PRT                  equ     Pin25
D4_PRT                  equ     Pin24
D5_PRT                  equ     Pin23
D6_PRT                  equ     Pin22
D7_PRT                  equ     Pin21
CZAS_NAD_PRT            equ     10              ;Maksymalny czas na zgoszeni (BUSY=L) drukarki

SCL                     equ     P0.3            ;linia zegara magistrali IIC
SDA                     equ     P0.4            ;linia danych magistrali IIC

EEPROM_WRITE	        equ	$A0     	;adres WRITE pamici EEPROM
EEPROM_READ	        equ     EEPROM_WRITE+1  ;adres READ pamici EEPROM
ZEGAR_WRITE             equ     %11010000       ;adres WRITE zegara PCF8573
ZEGAR_READ              equ     ZEGAR_WRITE+1   ;adres READ zegara PCF8573
PIO_WRITE               equ     %01000000       ;adres WRITE portu PCF8574
PIO_READ                equ     PIO_WRITE+1     ;adres READ portu PCF8574
SAA1_WRITE              equ     $70             ;adres WRITE SAA1064
SAA1_READ               equ     SAA1_WRITE+1    ;adres READ SAA1064
SAA2_WRITE              equ     $72             ;adres WRITE SAA1064
SAA2_READ               equ     SAA2_WRITE+1    ;adres READ SAA1064
SAA3_WRITE              equ     $74             ;adres WRITE SAA1064
SAA3_READ               equ     SAA3_WRITE+1    ;adres READ SAA1064
SAA4_WRITE              equ     $76             ;adres WRITE SAA1064
SAA4_READ               equ     SAA4_WRITE+1    ;adres READ SAA1064
INT_400HZ               equ     0               ;nr portu wejciowego
AND_400Hz               equ     %00000001       ;maska portu wejciowego
INT_16KHZ               equ     1               ;nr portu wejciowego
AND_16KHZ               equ     %00000010       ;maska portu wejciowego
INT_FSK                 equ     4               ;nr portu wejciowego
AND_FSK                 equ     %00010000       ;maska portu wejciowego
INT_DCF                 equ     5               ;nr portu wejciowego
AND_DCF                 equ     %00100000       ;maska portu wejciowego
INT_WATCHDOG            equ     6               ;nr portu wejciowego
AND_WATCHDOG            equ     %01000000       ;maska portu wejciowego

FSK_M0                  equ     3               ;nr portu wejciowego
FSK_M1                  equ     2               ;nr portu wejciowego
FSK_RXCK                equ     Pin7
FSK_RXD                 equ     Pin8

INIT                    equ     Pin6            ;Ustawienie standardu
PROGRAM                 equ     Pin3            ;Pin przecznika program
WATCHDOG                equ     Pin5
OPT1                    equ     Pin1            ;pin optotriaka 1
OPT2                    equ     Pin2            ;pin optotriaka 2
LIGHT                   equ     Pin37           ;Wyjcioe sterujce podwietlaniem LCD
DZW                     equ     Pin4            ;Wejcie dekodera dzwonka
BLK                     equ     Pin6            ;Sterowanie przekanikiem

ROZMOWA                 equ     $0e             ;Kryterium rozmowy
CYFRA_EMPTY             equ     $0f             ;Pusta cyfra (w buforze odczytanych cyfr)
END_TARYFA              equ     $ff             ;Wskanik ostatniego rekordu taryf
END_PREFIKS             equ     $ff             ;Wskanik ostatniego rekordu prefiksu
END_REJESTR             equ     7               ;Bit wskazujcy ostatni rekord
DAR                     equ     $0B             ;Znacznik darmowej taryfy
JED                     equ     $0C             ;Znacznki rozmowy za 1 impuls

PONIEDZIALEK            equ     1
WTOREK                  equ     2
SRODA                   equ     3
CZWARTEK                equ     4
PIATEK                  equ     5
SOBOTA                  equ     6
NIEDZIELA               equ     0

END_PLIK                equ     "K"             ;Znak okrelajcy koniec wydruku
SNG_PREFIKS             equ     "p"             ;Znak okrelajcy opis prefiksu
SNG_TARYFA              equ     "t"             ;Znak okrelajcy opis taryfy

CYFRA_NEXT              equ     $01             ;W edycji next rekord
CYFRA_PREV              equ     $02             ;         prev rekord
CYFRA_JUMP              equ     $03             ;         skok do wybranego rekordu
CYFRA_EDIT              equ     $04             ;         edycja rekordu
CYFRA_ADD               equ     $05             ;         dodanie rekordu
CYFRA_PRINT             equ     $07             ;         wydrukowanie tablicy
CYFRA_EXIT              equ     $09             ;         wyjcie z programu
CYFRA_DEL               equ     $00             ;         skasowanie rekordu
RETURN_DTMF             equ     $C              ;Kod znaku return w DTMF

LED_0                   equ     $3f             ;Kody znakw wywietlaczy LED
LED_1                   equ     $06
LED_2                   equ     $5b
LED_3                   equ     $4f
LED_4                   equ     $66
LED_5                   equ     $6d
LED_6                   equ     $7d
LED_7                   equ     $07
LED_8                   equ     $7f
LED_9                   equ     $6f
LED_a                   equ     $00
LED_b                   equ     $00
LED_c                   equ     $00
LED_d                   equ     $00
LED_e                   equ     $00
LED_f                   equ     $00

;----------------------------------------------------------------------------
;     Wewntrzna przestrze adresowa procesora
;----------------------------------
;>>> Adresowanie bezporednie i indeksowe
;----------------------------------
;
;       $00-$07 bank 0 rejestrw
;
dcf_start               equ     $08             ;Bufor DCF
dcf_b1                  equ     $09             ;Bufor DCF
dcf_b2                  equ     $0A             ;Bufor DCF
dcf_b3                  equ     $0B             ;Bufor DCF
dcf_b4                  equ     $0C             ;Bufor DCF
dcf_end                 equ     $0D             ;Bufor DCF
buf_pio                 equ     $0E             ;Stan PIO PCF8574
printer_device          equ     $0F             ;Urzdzenie drukujce (drukarka PAR lub SER)
PARALLEL_PRINTER        equ     1
SERIAL_PRINTER          equ     2
out_device              equ     $10             ;Urzdzenie wyjciowe (RS czy drukarka)
prt_pl                  equ     $11             ;Polskie znaki dla drukarki
ser_pl                  equ     $12             ;Polskie znaki dla RS
kod1                    equ     $13             ;Kod dostpu
kod2                    equ     $14             ;Kod dostpu
suma_kontrolna          equ     $15             ;pomocniczy przy obliczniu sumy kontrolnej
len_clip                equ     $16             ;Wskanik znakow odebranych przez CLIP
linia_statusu           equ     $17             ;Linia statusu (pod godzin w stan_by)
STATUS_OK               equ     %00000000       ; ok
STATUS_SUMA_KONFIGU     equ     %00000001       ; za suma kontrolna pliku konfiguracji
STATUS_SUMA_TARYF       equ     %00000010       ; za suma kontrolna tablicy taryf
STATUS_SUMA_PREFIKSOW   equ     %00000100       ; za suma kontrolna tablicy prefiksw
STATUS_WERSJA_KONFIGU   equ     %00001000       ; za wersja pliku
STATUS_BUFOR_FULL       equ     %00010000       ; bufor rozmow peny
STATUS_BUFOR_90         equ     %00100000       ; bufor rozmow zajty w 90%
;
licznik_impulsow_ost_h  equ     $18
licznik_impulsow_ost_l  equ     $19             ;licznik impulsw ostatniego poczenia
;
dcf_wsk                 equ     $1a
dcf_l                   equ     $1b
dcf_h                   equ     $1c             ;licznik czasw bitu DCF
;
end_bufor_l             equ     $1d
end_bufor_h             equ     $1e             ;Adres ostatniej komrki eerpom
;
licz_nad_prt            equ     $1f             ;Licznik oczekiwania na BUSY PRT
licznik_400hz_l         equ     $20             ;Licznik czasu przerwy tonu 400Hz
licznik_400hz_h         equ     $21             ;Licznik czasu tonu 400Hz
pam_400hz_l             equ     $22             ;Wynik pomiaru czasu przerwy tonu 400Hz
pam_400hz_h             equ     $23             ;Wynik pomiaru czasu tonu 400Hz
licznik10_2             equ     $24             ;Dzielnik wstpny
rekord_l                equ     $25             ;Nr rekordu
rekord_h                equ     $26             ;Nr rekordu
max_rekord_l            equ     $27             ;Max pojemno rekordw w rejestratorze
max_rekord_h            equ     $28             ;Max pojemno rekordw w rejestratorze
bright_led              equ     $29             ;Jasno wywietlaczy LED
buf_pioD                equ     $2A             ;Poprzedni stan PIO PCF8574
;...$2b WOLNE ???
;...$2c WOLNE ???
;
;--------- Ponisza deklaracja zajmuje obszar $2D...$2F -------------
FL_IDLE10MS             equ     $6b ; $2d.7     ;Flaga wystpienia przerwania od Timera
FL_PRT_ALL              equ     $6c ; $2e.0     ;Flaga wydruku skasowanych pocze
FL_ZMIANY               equ     $6d ; $2e.1     ;Flaga wprowadzonych zmian przy edycji
FL_BIT_DCF              equ     $72 ; $2e.2     ;Flaga tymczasowa odczytanego bitu
FL_OK_DCF               equ     $73 ; $2e.3     ;Flaga poprawnego odbioru
FL_ERR_DCF              equ     $74 ; $2e.4     ;Flaga bdu odbioru DCF
FL_IIC_BUSY             equ     $75 ; $2e.5     ;Zajto magistrali IIC
FL_HARDWARE             equ     $76 ; $2e.6     ;Znacznik "hardware v2"
FL_TXEMPTY              equ     $77 ; $2e.7     ;Znacznik "bufor nadawczy pusty"
FL_FSK                  equ     $78 ; $2f.0     ;przerwanie od dekodera CLIP
FL_400HZ                equ     $79 ; $2f.1     ;przerwanie od 400Hz
FL_16KHZ                equ     $7a ; $2f.2     ;przerwanie od 16kHz
FL_DTMF                 equ     $7b ; $2f.3     ;przerwanie od DTMF
FL_EQUAL                equ     $7c ; $2f.4     ;Zmienne bitowe dla operacji
FL_BELOW                equ     $7d ; $2f.5     ; arytmetycznych BCD
FL_ABOVE                equ     $7e ; $2f.6
RNERR                   equ     $7f ; $2f.7
;
;--------- Ponisza deklaracja zajmuje obszar $30...$4E -------------
arg1                    equ     $30             ;4-bajtowy adgument dziaania
arg2                    equ     arg1+4          ;4-bajtowy adgument dziaania
resl                    equ     arg2+4          ;4-bajtowy wynik dziaania
resd                    equ     resl+4          ;4-bajtowy bufor reszty z dzielenia
resld                   equ     resd+4          ;10-bajtowy bufor niespakowanego BCD
bufaux                  equ     resld+10        ;5-bajtowy bufor pomocniczy
end_buf_arithm          equ     bufaux+5        ;Pierwsza wolna komrka
;
std_out                 equ     $50             ;Standardowe wyjcie
STD_OUT_LCD             equ     1
STD_OUT_SER             equ     2
STD_OUT_PRT             equ     3
std_pl                  equ     $51             ;Standard polskich znakw
BEZ_PL                  equ     0
AMIGA_PL                equ     1
WINDOWS_PL              equ     2
MAZOWIA_PL              equ     3
;
wsk_fifo_rd:            equ     $52             ;Wskanik FIFO do odczytu
wsk_fifo_wr:            equ     $53             ;Wskanik FIFO do zapisu
licznik_fifo:           equ     $54             ;Licznik bajtw zapisach w FIFO
status_fifo:            equ     $55             ;Status bufora FIFO
ERROR_OK                equ     0               ;Bez bdu
ERROR_FULL              equ     1               ;Bufor peny
;
rej_h                   equ     $56             ;Pami wskanika rejestratora
rej_l                   equ     $57             ;Pami wskanika rejestratora
cena_vat                equ     $58             ;Podatek VAT
cena_zl                 equ     $59
cena_gr                 equ     $5a             ;Cena impulsu
taryfa                  equ     $5b             ;Aktualna taryfa
nr_prefiksu             equ     $5c             ;Aktualny nr prefiksu
licznik_czasu_sek_h     equ     $5d             ;Licznik okresu po
licznik_czasu_sek_l     equ     $5e             ; ktrym ma naspi
licznik_czasu_setne     equ     $5f             ; zwikszenie licznika impulsu
;
FAIL_ROK                equ     %00000001       ;Bit "nieaktualny rok"
PRZESUN_DZIEN           equ     %00000010
dzien_tygodnia          equ     $60             ;Dzie tygodnia
miesiac                 equ     $61             ;Miesic
dzien                   equ     $62             ;Dzie miesica
godzina                 equ     $63             ;Godzina
minuta                  equ     $64             ;Minuta
rok_l                   equ     $65             ;Jednoci/dziesitki lat
rok_h                   equ     $66             ;Setki/tysice lat
;
pref_taryfa             equ     $67             ;Pami taryfy prefiksu
pref_start              equ     $68
pref_c1                 equ     $69             ;Pami cyfr prefiksu
pref_c2                 equ     $6a             ;Pami cyfr prefiksu
pref_c3                 equ     $6b             ;Pami cyfr prefiksu
pref_c4                 equ     $6c             ;Pami cyfr prefiksu
pref_c6                 equ     $6d             ;Pami cyfr prefiksu
pref_c7                 equ     $6e             ;Pami cyfr prefiksu
pref_c8                 equ     $6f             ;Pami cyfr prefiksu
pref_c9                 equ     $70             ;Pami cyfr prefiksu
pref_c10                equ     $71             ;Pami cyfr prefiksu
pref_c11                equ     $72             ;Pami cyfr prefiksu
pref_end                equ     $73             ;Adres koca bufora
czas_rozmowy_godz       equ     $74             ;Czas rozmowy godziny
czas_rozmowy_min        equ     $75             ;Czas rozmowy minuty
czas_rozmowy_sek        equ     $76             ;Czas rozmowy sekundy
licznik_impulsow_h      equ     $77             ; bierzcej rozmowy
licznik_impulsow_l      equ     $78             ;Licznik impulsw
kryterium_rozmowy       equ     $79             ;Kryterium rozmowy i sposb zaliczania
POLARYZACJA             equ     0
IMPULS_16KHZ            equ     1
TON_400HZ               equ     2
polaryzacja_lacza       equ     $7a             ;Polaryzacja cza
czas_prz                equ     $7b             ;czas przerwy
czas_zw                 equ     $7c             ;czas zwarcia
nr_linii_l              equ     czas_zw         ;modszy bajt nr linii
nr_linii_h              equ     czas_prz        ;starszy bajt nr linii
;
licznik10_1             equ     $7d             ;Dzielnik wstpny
overtime                equ     $7e             ;licznik czasu oczekiwania
OVER_CONST              equ     10              ;Czas oczekieania na zanak z RS
poz_wys                 equ     $7f
;
;----------------------------------
;>>> Adresowanie indeksowe
;
wierzch_stosu           equ     $80
dno_stosu               equ     $BF             ;dno stosu i komrka kontrolna stosu
KONT_STOS               equ     'T'             ;bajt kontroli stosu

buf_fifo_str:           equ     $C0             ;Pocztek bufora FIFO
buf_fifo_end:           equ     $DB             ;Koniec bufora FIFO
;
AA                      equ     $dc             ;Rejestry dla wiecznego kalendarza
AA1                     equ     $dd
AA2                     equ     $de
AA3                     equ     $df
PP                      equ     $e0
PP1                     equ     $e1
PP2                     equ     $e2
PP3                     equ     $e3
RRR                     equ     $e4
RRR1                    equ     $e5
RRR2                    equ     $e6
RRR3                    equ     $e7
DD                      equ     $e8
DD1                     equ     $e9
DD2                     equ     $ea
DD3                     equ     $eb
MM                      equ     $ec
MM1                     equ     $ed
MM2                     equ     $ee
MM3                     equ     $ef
;

buf_cyf_str             equ     $f0             ;Adres pocztku bufora
cyfra_2                 equ     $f1             ;Pami cyfry
cyfra_3                 equ     $f2             ;Pami cyfry
cyfra_4                 equ     $f3             ;Pami cyfry
cyfra_5                 equ     $f4             ;Pami cyfry
cyfra_6                 equ     $f5             ;Pami cyfry
cyfra_7                 equ     $f6             ;Pami cyfry
cyfra_8                 equ     $f7             ;Pami cyfry
cyfra_9                 equ     $f8             ;Pami cyfry
cyfra_10                equ     $f9             ;Pami cyfry
cyfra_11                equ     $fa             ;Pami cyfry
buf_cyf_end             equ     $fd             ;Adres koca bufora
cyfra_12                equ     $fb             ;Pami cyfry
cyfra_13                equ     $fc             ;Pami cyfry
cyfra_15                equ     $fe             ;Pami cyfry
cyfra_16                equ     $ff             ;Pami cyfry
;
;============================================================================
                include 'INCL:8051/baud.incl'
		include	'INCL:LCD-ASCII_AmigaPL.incl'

;============================================================================
		org	$0000
		ljmp	start

;----------------------------------------------------------------------------
		org	$03                     ;Int0
                ljmp    irq_pio

;----------------------------------------------------------------------------
		org	$0b                     ;Timer0
		ljmp	irq_timer		;Przerwanie z timera 0

;----------------------------------------------------------------------------
		org	$13                     ;Int1
		ljmp	irq_dtmf		;Przerwanie z MT8870

;----------------------------------------------------------------------------
		org	$23                     ;IntRS
		ljmp	irq_rs  		;Przerwanie z RS'a

;============================================================================
                include	'INCL:LCD-data_PL.incl'
;Wywietlacz LCD
                include 'INCL:8051/LCD_HT44780.incl'
;Obsuga IIC
                include 'INCL:8051/IIC.incl'
;Procedury arytmetyczne
                include 'INCL:8051/arithm.incl'

;----------------------------------------------------------------------------
;Wysya znak na standardowe wyjcie ustawione w zmiennej "std_out"
;We: Acc - kod znaku
;Wy:   C - rezultat (C=0 - OK, C=1 nie wysano znaku (np drukarka niegotowa))
;Zmienia: --
print_char:	push	ACC         			;Gdzie wysya znaki ?
		mov	a,std_out
		cjne	a,#STD_OUT_PRT,print_char_1
		pop	ACC
		push	ACC
		lcall   char_na_prt
		pop	ACC
		ret

print_char_1:	cjne	a,#STD_OUT_SER,print_char_2
		pop	ACC
		push	ACC
		lcall	char_na_ser
		pop	ACC
		ret

print_char_2:	pop	ACC
		lcall   put_lcd
                clr     C                               ;Znacznik, e OK
		ret

;----------------------------------------------------------------------------
;Zalenie od konfigu drukuje na PAR lub SER
;Przed wydrukiem konwersja polskich znakw
;
char_na_prt:    mov     std_pl,prt_pl           ;polskie znaki dla drukarki
                lcall   konw_outPL              ;Konwertuj polskie znaki
                push    ACC                     ;Zapamitaj znak
                mov     a,printer_device        ;Jaki typ drukarki ?
                cjne    a,#SERIAL_PRINTER,char_par
                pop     ACC                     ;Odtwrz znak i na drukark SER
                lcall   char_prt_ser            ; pomijajc konwersj (bya wczeniej)
                clr     C                       ;Znacznik, e OK
                ret

char_par:       pop     ACC                     ;Odtwrz znak i na drukark PAR
                lcall   prt_wait                ;Czeka na gotowo drukarki
                jc      char_na_prt_err         ; - nacinito Esc lub min czas
                lcall   MovAcc_ToPRT            ;Dana z Acc na port PRT
                clr     STB_PRT                 ;Strob na linii STB
                nop                             ;Trzeba da przy 24MHz
                nop
                setb    STB_PRT
char_na_prt_ok: clr     C                       ;Znacznik OK
                ret
char_na_prt_err:setb    C                       ;Wyjcie ze znacznikiem bdu
                ret

;----------------------------------------------------------------------------
;Czeka na gotowo drukarki
;we:--
;wy: C - rezultat (C=0 gotowa, C=1 przekroczono czas oczekiewania)
;
prt_wait:       push    ACC
                mov     licz_nad_prt,#CZAS_NAD_PRT
prt_wait_1:     lcall   reset_watchdog
                jb      BUSY_PRT,prt_wait_2             ;Jeli drukarka niegotowa to skocz
                clr     C                               ;Gotowa wic wyjd z C=0
                pop     ACC
                ret
prt_wait_2:     lcall   czy_break                       ;Czy Esc
                jc      prt_wait_err                    ; - tak nacinito Esc
                mov     a,licz_nad_prt                  ;Czy przekroczono czas ?
                jnz     prt_wait_1                      ; nie wic czekaj dalej
prt_wait_err:   setb    C                               ; tak wic wyjd z bdem
                pop     ACC
                ret


;----------------------------------------------------------------------------
;Dziaa jak rozkaz "mov	PRT,a"
;
MovAcc_ToPRT:   push	ACC				;Zapamitaj ACC
		clr	D0_PRT  			;Zzerowanie portu
		clr	D1_PRT
		clr	D2_PRT
		clr	D3_PRT
		clr	D4_PRT
		clr	D5_PRT
		clr	D6_PRT
		clr	D7_PRT
                jnb	ACC.0,MovAcc_ToPRT_1		;Jeli bit=1
		setb	D0_PRT  			; to go ustaw na porcie
MovAcc_ToPRT_1	jnb	ACC.1,MovAcc_ToPRT_2
		setb	D1_PRT
MovAcc_ToPRT_2  jnb	ACC.2,MovAcc_ToPRT_3
		setb	D2_PRT
MovAcc_ToPRT_3  jnb	ACC.3,MovAcc_ToPRT_4
		setb	D3_PRT
MovAcc_ToPRT_4  jnb	ACC.4,MovAcc_ToPRT_5
		setb	D4_PRT
MovAcc_ToPRT_5  jnb	ACC.5,MovAcc_ToPRT_6
		setb	D5_PRT
MovAcc_ToPRT_6  jnb	ACC.6,MovAcc_ToPRT_7
		setb	D6_PRT
MovAcc_ToPRT_7  jnb	ACC.7,MovAcc_ToPRT_e
		setb	D7_PRT
MovAcc_ToPRT_e  pop	ACC
		ret

;----------------------------------------------------------------------------
;Ustawia status OK
;
init_status:    mov     linia_statusu,#STATUS_OK
                ret

;----------------------------------------------------------------------------
;Opis: Wysya bajt z ACC przez port RS
; - nie czeka na zakoczenie transmisji, ale nie wyle jeli trwa transmisja
;we: ACC - nadawany znak
;wy: --
;zmienia: PSW
;
char_na_ser:    mov     std_pl,ser_pl
                cjne    a,#CLS_ASCII,char_naser_l1      ;Jeli CLS
                mov     a,#LF_ASCII                     ; wydrukuj CR+LF
                lcall   char_prt_ser
                mov     a,#CR_ASCII
                ljmp    char_prt_ser            ;<--- Zstpuje RET
char_naser_l1:  cjne    a,#HOME_ASCII,char_naser_l2     ;Jeli HOME nie drukuj na SER
                ret
char_naser_l2:  cjne    a,#FEED_ASCII,char_naser_l3     ;Jeli FEED nie drukuj na SER
                ret
char_naser_l3:  lcall   konw_outPL                      ;Konwertuj polskie znaki
char_prt_ser:   jnb	FL_TXEMPTY,*           	        ;Czy mona nada znak ?
		mov	SBUF,a                          ;Wylij bajt
                lcall   reset_watchdog
                clr     FL_TXEMPTY                      ;Kasuj znacznik
                ret

;============================================================================
;=                  RESET - inicjalizacja procesora, itp                    =
;============================================================================
start:          mov	SP,#wierzch_stosu   	;Ustawienie stosu
                mov     R0,#dno_stosu           ;Wypenij stos bajtem
start_l1:       mov     @R0,#KONT_STOS          ; kontrolnym przepenienia stosu
                dec     R0                      ; co umoliwi okrelenie
                mov     a,R0                    ; max zuycia stosu
                cjne    a,#wierzch_stosu,start_l1
                lcall   init_status
                lcall   init_dcf
                lcall   init_timer
                lcall   init_fifo               ;Inicjalizacja FIFO
                lcall   init_rs
                lcall   init_16khz
                lcall   init_dtmf
                lcall   init_interput
                lcall	init_lcd                ;Init LCD
                lcall   iic_init
                lcall   init_watchdog
                lcall   init_fsk
                lcall   cls
                lcall   max_bufor               ;Wielko pamici EEprom
                lcall   hardware                ;Okrelenie wersji hardware
                lcall   read_konfig             ;Odczyt konfiguracji z EEPROM
                lcall   zeruj_licznik_impulsow
                lcall   curs_off
                lcall   print_powitanie         ;Take sprawdzenie sum kontrolnych tablic
                jb      INIT,*+6                ;Czy jumper zwarty ?
                lcall   set_standard            ; - tak wic ustaw standard

;============================================================================
;=                       Ptla gwna programu                              =
;============================================================================
        ;-------- Stan oczekiwania ----------------
stan_by:
                lcall   zajetosc_bufora         ;Sprawdza_zajto bufora rozmow
                mov     len_clip,#0             ;Zeruj bufor CLIP
stan_by2:
                lcall   wait_10ms
 IF LIGHT_STANBY=NO
                mov     a,linia_statusu         ;jeli status OK to wyga podwietlanie LCD
                cjne    a,#STATUS_OK,no_light
                clr     LIGHT
no_light:
 ENDI
                setb    BLK                     ;Rozblokowanie przekanika
                mov     std_out,#STD_OUT_LCD    ;"Print" na LCD
                lcall   zeruj_licznik_czasu
                lcall   init_dtmf
                lcall   curs_off
                lcall   sprawdz_rs
                mov     dptr,#msg_scr_data      ;Czyszczenie drgiej linii LCD
                lcall   print_text
                lcall   print_data_czas         ;Wywietl dat i czas
                lcall   print_spc
                lcall   print_spc
                lcall   print_status
                lcall   clip_dtmf               ;Obsuguj dekoder CLIP DTMF
stan_by_l2:     jb      PROGRAM,stan_by_l3      ;Stan przecznika
                setb    LIGHT
                lcall   programowanie           ; - wczony wic programowanie
stan_by_l3:     lcall   zgloszenie              ;Czy suchawka podniesiona ?
                jc      stan_podniesienie       ; - tak wic skocz
                                                ; - nie wic sprawd czy dzwonek
                jnb     F0,stan_by2             ;Jeli nie ma dzwonka "stan_by"
                setb    LIGHT
                mov     dptr,#txt_dzwonek       ;jeli jest dzwonek napis "Dzwonek..."
                lcall   print_text
                lcall   clip_fsk                ;Obsuguj dekoder CLIP FSK
                lcall   wyswietl_clip           ;wywietl CLIP
stan_by_l40:    mov     R0,#50                  ;Ptla czasowa w czasie dzwonienia
stan_by_l4:     lcall   wait_100ms
                lcall   zgloszenie              ;Czy odebrano rozmow?
                jc      stan_czyrozmowa         ; - tak wic skacz
                jb      F0,stan_by_l40          ; - jeli jest dzwonek skacz
                djnz    R0,stan_by_l4           ; nic si nie dzieje wic odliczaj
                ajmp    stan_by                 ;gdy koniec liczenia "stan_by"
stan_czyrozmowa:jnb     FL_HARDWARE,stan_by_rozmowa     ;Dla V2 sprawd czy pojawia si ton
                mov     R0,#40                          ; 400Hz w cigu 4 sekund
stan_czyrozmowa1:
                mov     a,buf_pio
                jnb     Acc+INT_400HZ,stan_podniesienie  ; jeli tak to ab zrezygnowa z dzwonienia
                lcall   wait_100ms
                djnz    R0,stan_czyrozmowa1             ; jeli nie i min czas to oznacza rozmow
stan_by_rozmowa:mov     dptr,#txt_rozmowa       ; - tak wic napis "Rozmowa..."
                lcall   print_text
                lcall   wyswietl_clip           ;wywietl CLIP
stan_by_roz:    lcall   zgloszenie              ;Jeli trwa rozmowa
                jc      stan_by_roz             ; wywietlaj napis i czekaj na
                ajmp    stan_by                 ; odoenie suchawki

stan_podniesienie:
                setb    LIGHT
                lcall   pamietaj_polaryzacje    ;Zapamitaj polaryzacj
                clr     FL_16KHZ                ;Zeruj znacznik 16kHz
                lcall   zeruj_czas_rozmowy      ;Zeruj czas rozmowy
                lcall   init_bufor_cyf
                mov     dptr,#txt_nr            ;napis "Nr: "
                lcall   print_text
                lcall   curs_on

                mov     R0,#buf_cyf_str         ;W R0 pocztek bufora wybranych cyfr
next_liczba:    lcall   licz
                jnc     *+5
                ljmp    stan_by                 ;C=1 wic odoono suchawk ??? bylo ljmp
                cjne    a,#ROZMOWA,next_liczba_l2
                sjmp    rozmowa                 ;ACC=ROZMOWA wic kryterium rozmowy

next_liczba_l2: cjne    R0,#buf_cyf_end+1,next_liczba_l3    ;Czy koniec bufora cyferek ?
                sjmp    next_liczba             ; - tak wic nie zapisuj do bufora

next_liczba_l3: mov     @R0,a                   ; - nie wic zapamitaj cyfr w buforze
                lcall   print_nible_spec__      ;Wywietla wybran cyfr
                inc     R0                      ;Wskanik na next bajt bufora
                sjmp    next_liczba

msg_scr_data:   BYTE    HOME_ASCII,CR_ASCII,LF_ASCII
                STRING  '                '
                BYTE    END_ASCII

;-----------------------------------------------
rozmowa:        lcall   curs_off                ;Rozpoczto rozmow
                lcall   cls
                mov     a,buf_cyf_str           ;Czy wybrono jaki numer ?
                cjne    a,#(CYFRA_EMPTY SHL 4) OR CYFRA_EMPTY,rozmowa_l0
                ljmp    stan_by                 ; - nie wic bd

rozmowa_l0:     mov     dptr,#msg_szukam_tar
                lcall   print_text
                lcall   zeruj_czas_rozmowy      ;Start odliczania
                lcall   start_licznika_impulsow ;Licznik impulsw =0001
                lcall   okresl_taryfe           ;Okreli taryf
                lcall   oblicz_okres_zaliczania ; i na jej podstawie okres zaliczania
                lcall   read_czas               ; wczytaj aktualny czas
                mov     a,#10                   ;Ptla czasowa 1 sek.
                lcall   delay_100ms             ; i zzerowanie flagi
                lcall   clr_flagi_zaliczania    ; aby nie byo podwjnego impulsu

        ;-------- Wywietlanie -----------------
                lcall   curs_off
rozmowa_l1:     lcall   reset_watchdog
                lcall   home                    ;Wywietlaj czas rozmowy
                mov     a,#1                    ;Ptla czasowa
                lcall   delay_100ms
                lcall   print_kasa
 IF TIMEBACK                                    ;Wywietla trayf i miejscowoc lub czas do konca impulsu
                lcall   print_timeback          ;Wywietlaj czas do koca impulsu
 ELSE
                lcall   print_taryfa_miejscowosc;Wywietlaj taryf
 ENDI

        ;-------- dekodowanie odoenia suchawki -------
                lcall   wait_50ms               ;Ptla czasowa
                jnb     OPT1,rozmowa_l1         ;Jeli prd pynie w ktorymkolwiek
                jnb     OPT2,rozmowa_l1         ; kierunku trwa rozmowa
                lcall   wait_50ms               ;Czekaj (olewanie odbi styku)
                jnb     OPT1,rozmowa_l1         ;Jeli nadal pynie to trwa rozmowa
                jnb     OPT2,rozmowa_l1         ; jeli nie to koniec rozmowy

        ;-------- zapis rekordu do EEPROM ------
                lcall   szukaj_free_rekord      ;Szuka wolnego rekordu
                lcall   next_rekord             ;Next rekord
                lcall   get_rejestr_nonext      ; zapisz bajtem koca rejestratora
                setb    Acc+END_REJESTR
                lcall   put_rejestr
                lcall   prev_rekord             ;Ustaw na znaleziony wolny rekord
                mov     suma_kontrolna,#0       ;Suma kontrolna
                mov     a,miesiac               ;Zapisz miesic
                lcall   put_rejestr
                mov     a,dzien
                lcall   put_rejestr

                mov     a,godzina               ;Zapisz czas
                lcall   put_rejestr
                mov     a,minuta
                lcall   put_rejestr

                mov     R7,#(buf_cyf_end-buf_cyf_str)/2 ;Licznik obiegw (liczba cyfr/2)
                mov     R0,#buf_cyf_str         ;Adres bufora cyfr
rozmowa_l4:     mov     a,@R0                   ;Odczytaj cyfr z bufora
                rl      a                       ;Przesu na starszy pbajt
                rl      a
                rl      a
                rl      a
                anl     a,#$f0
                mov     B,a
                inc     R0                      ;Wskanik na next cyfr w buforze
                mov     a,@R0                   ;Odczytaj cyfr
                orl     a,B                     ;Pocz nible w bajt
                lcall   put_rejestr             ;Zapisz poczone nible do eeprom
                inc     R0                      ;Wskanik na next cyfr w buforze
                djnz    R7,rozmowa_l4

                mov     a,czas_rozmowy_godz     ;Zapisz czas trwania rozmowy
                lcall   put_rejestr
                mov     a,czas_rozmowy_min
                lcall   put_rejestr
                mov     a,czas_rozmowy_sek
                lcall   put_rejestr

                mov     a,licznik_impulsow_h    ;Zapisz stan licznika
                mov     licznik_impulsow_ost_h,a
                lcall   put_rejestr
                mov     a,licznik_impulsow_l
                mov     licznik_impulsow_ost_l,a
                lcall   put_rejestr

                mov     a,suma_kontrolna        ;Zapisz sum kontroln
                lcall   put_rejestr

rozmowa_exit:   mov     a,#10                   ;Ptla czasowa 1 sek.
                lcall   delay_100ms
                mov     B,#200                  ;Ptla czasowa 20 sekund
rozmowa_exit_1: lcall   zgloszenie              ;Czy suchawka podniesiona ?
                jnc     rozmowa_exit_2          ; nie wic realizuj ptl czasow
                ljmp    stan_by                 ; - tak wic skocz na pocztek
rozmowa_exit_2: mov     a,#1
                lcall   delay_100ms
                lcall   sprawdz_rs
                djnz    B,rozmowa_exit_1
                ljmp    stan_by

;-----------------------------------------------
txt_dzwonek:    BYTE    CLS_ASCII
                STRING  'Dzwonek..'
                BYTE    0

txt_rozmowa:    BYTE    CLS_ASCII
                STRING  'Rozmowa..'
                BYTE    0

txt_nr:         BYTE    CLS_ASCII
                STRING  'Nr: '
                BYTE    0

msg_szukam_tar: BYTE    CLS_ASCII
                STRING  'Okrelam taryf'
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Jeli wykryje kod DTMF $D (pocztek meldunku) to zapisuje znaki do bufora
;      do czasu gdy napotka kod $C (koniec meldunku), wykryje dzwonek
;      lub minie 6 sekund od ostatniego kodu
;
clip_dtmf:      jnb     FL_DTMF,clip_dtmf_5     ;Czy odebrano kod DTMF ?
                mov     R0,#buf_cyf_str         ; tak wic ustaw pocztek bufora
                lcall   czytaj_z_dtmf           ; odczytaj znak aby skasowac IRQ
                     ;???       push    std_out
     ;          mov     std_out,#STD_OUT_SER    ;DTMF na SER
     ;          mov     dptr,#msg_clip_dtmf
     ;          lcall   print_text

                mov     overtime,#6             ;Czas oczekiwania na dzwonek 6 sekund
clip_dtmf_1:    lcall   reset_watchdog
                jnb     FL_DTMF,clip_dtmf_3     ;Czy odebrano kod DTMF ?
                lcall   czytaj_z_dtmf           ; tak wic czytaj
                add     a,#$30                  ; konwersja do ASCII
 IF FLASH_CLIP                                  ;Czy wywietla clip przed dzwonkiem ?
                setb    LIGHT
                mov     std_out,#STD_OUT_LCD
                lcall   print_char
     ;???       mov     dptr,#msg_clip_dtmf
 ENDI
                mov     overtime,#6             ;Czas oczekiwania na dzwonek 6 sekund
                mov     @R0,a                   ;Zapisz znak do bufora
     ;???       lcall   print_char              ;Znak na SER
                inc     R0                      ;wskanik na next znak w buforze
clip_dtmf_3:    jnb     DZW,clip_dtmf_4         ;jeli wykryto dzwonek to wyjd
                mov     a,overtime              ;jeli nie min czas to czekaj w ptli
                jnz     clip_dtmf_1
                                                ;Min czas, a nie byo dzwonka wic faszywe kody
clip_dtmf_2:    mov     len_clip,#0             ;Nie ma znakw w buforze
                ret

clip_dtmf_4:    mov     a,R0                    ; Obliczenie liczby znakw w buforze
                clr     C                       ; i wyjcie
                subb    a,#buf_cyf_str
                dec     a                       ; korekta na ostatni znak koca danych
                mov     len_clip,a

     ;???       pop     std_out                 ;przywrcenie StdOut
clip_dtmf_5:    ret

;----------------------------------------------------------------------------
init_fsk:       clr     ET0                     ;Przerwanie T0 i EX0jest wyczane
                clr     EX0                     ; poniewarz na irq wystpuj
                                                ; cykle dostpu do IIC
                lcall   iic_start               ;Ustaw tryb upienia dekodera FSK
                mov     a,#PIO_WRITE
                lcall   iic_write
                        ;   GRDFMM14
                        ;   NSCS0160
                        ;   DTFK  k0
                mov     a,#%11111011
                lcall   iic_write
                lcall   iic_stop
                setb    ET0
                setb    EX0

                clr     FSK_RXCK                ;Tryb odbioru synchronicznego
                ret

;----------------------------------------------------------------------------
tryb_odb_fsk:   clr     ET0                     ;Przerwanie T0 i EX0jest wyczane
                clr     EX0                     ; poniewarz na irq wystpuj
                                                ; cykle dostpu do IIC
                lcall   iic_start               ;Ustaw tryb odbioru danych FSK
                mov     a,#PIO_WRITE
                lcall   iic_write
                        ;   GRDFMM14
                        ;   NSCS0160
                        ;   DTFK  k0
                mov     a,#%11110111
                lcall   iic_write
                lcall   iic_stop
                setb    ET0
                setb    EX0
                clr     FSK_RXCK                ;Tryb odbioru synchronicznego
                ret

;----------------------------------------------------------------------------
;Sprawdza czy przyszed znak w FSK
;Jeli znaki przyjd s wysyane na SER oraz zapamitywane w buforach
; "resld" (8-bajtw) - data godzina
; "buf_cyf_str" (16-bajtw) - nr abonenta
; "len_clip" jest ustawiany tylko wtedy gdy odebrane zostan kody FSK
;            w przeciwnym wypadku "len_clip" nie jest ruszany aby nie zepsu
;            efektu ewentualnego dekodowania DTMF
;
clip_fsk:       mov     B,#5                    ;B x 10ms przez ile ma nie by dzwonka
clip_fsk_nodz:  lcall   reset_watchdog          ;Czekaj na koniec dzwonka
                lcall   wait_10ms
                jnb     DZW,clip_fsk
                djnz    B,clip_fsk_nodz

        ;------------ Czeka na jakikolwiek bajt w FSK -----------
                mov     std_out,#STD_OUT_SER
                lcall   tryb_odb_fsk            ;Wczenie dekodera clip FSK
                lcall   wait_100ms              ;Ptla czasowa
                lcall   wait_100ms
                clr     FL_FSK
                lcall   read_rxdfsk             ;Czekanie na znaki FSK
                jc      clip_fsk_sync0
                lcall   read_rxdfsk
                jc      clip_fsk_sync0
                lcall   read_rxdfsk
                jc      clip_fsk_sync0
                lcall   read_rxdfsk
                jc      clip_fsk_sync0
                ljmp    clip_fsk_no
clip_fsk_sync0: mov     dptr,#msg_clip_fsk
                lcall   print_text

        ;------------- Czeka na sygna SMRR ---------------------
clip_fsk_sync1: lcall   read_rxdfsk             ;Czekaj na bajt %01010101
                jnc     clip_fsk_errs
                cjne    a,#%01010101,clip_fsk_sync1

        ;------------- Czeka na bajt rodzaju danych -------------
clip_fsk_sync5: lcall   read_rxdfsk             ;Czekaj na bajt $80
                jnc     clip_fsk_errs
                cjne    a,#$80,clip_fsk_sync5
                mov     R5,#$80                 ;Suma kontrolna do R5
                lcall   read_rxdfsk             ;Bajt dugoci meldunku
                jnc     clip_fsk_brk            ; zapamitaj w R7
                lcall   print_char
                mov     R7,a

        ;------------- Odbir rekordu ----------------
clip_fsk_nextR: lcall   read_rxdfsk             ;Rodzaj danych
                jnc     clip_fsk_brk            ; zapamitaj w R4
                lcall   print_char
                mov     R4,a
                dec     R7
                lcall   read_rxdfsk             ;Dugo danych
                jnc     clip_fsk_brk            ; zapamietaj w R6
                lcall   print_char
                mov     R6,a
                dec     R7
                lcall   clip_rd_rekord          ;Odczytanie rekordu do odpowiedniego obszaru pamici
                jnc     clip_fsk_brk
                mov     a,R7                    ;Czy koniec danych ?
                cjne    a,#0,clip_fsk_nextR     ; nie wic odczytuj nastpny rekord

        ;------------- Sprawdzanie CRC ---------------
                clr     C                       ;Oblicz CRC
                mov     a,#0                    ; i zapamietaj w B
                subb    a,R5
                mov     B,a
                lcall   read_rxdfsk             ;Czytaj CRC
                jnc     clip_fsk_brk            ; jesli CRC niezgodne ustaw len_clip=0
                lcall   print_char
                cjne    a,B,clip_fsk_crc
                lcall   clip_zegar_konw         ; jesli CRC OK to uaktualnij zegar
                mov     miesiac,resld+1
                mov     dzien,resld+3
                mov     godzina,resld+5
                mov     minuta,resld+7
 IF DEMO_CLIPFSK=NO                     ;W wersji DEMO nie synchronizuj zegara
                lcall   write_czas
 ENDI
        ;---------------------------------------
clip_fsk_end:   mov     std_out,#STD_OUT_LCD    ;przywrcenie StdOut
                lcall   init_fsk       ;Init dekodera FSK
clip_fsk_no:    ret

clip_fsk_errs:  lcall   print_err               ;Brak sygnau synchronizacji
                mov     dptr,#msg_fsk_nsync
                lcall   print_text
                sjmp    clip_fsk_end
msg_fsk_nsync:  STRING  'SYNC'
                BYTE    END_ASCII

clip_fsk_brk:   lcall   print_err               ;Brak sygnau synchronizacji
                mov     dptr,#msg_fsk_brk
                lcall   print_text
                sjmp    clip_fsk_end
msg_fsk_brk:    STRING  'BRK'
                BYTE    END_ASCII

                ;??? (wywietlaj CLIP nawet jeli bya za CRC)
clip_fsk_crc:   ;??? mov     len_clip,#0             ;Ze CRC, wytnij clip
                lcall   print_err               ; i wyswietl sumy CRC na SER
                mov     dptr,#msg_crc
                lcall   print_text
                push    ACC
                mov     a,B
                lcall   print_hex
                pop     ACC
                lcall   print_hex
                sjmp    clip_fsk_end
msg_crc:        STRING  'CRC $'
                BYTE    END_ASCII

        ;---------------------------------------
clip_zegar_konw:mov     R0,#resld               ;Konwertuj znaki z bufora "resld" (data i czas)
                mov     R7,#4                   ; z Ascii na BCD
clip_zeg_konw1: mov     a,@R0                   ;Starszy pobajt po konwersji z Ascii
                clr     C                       ; zapamitaj w B
                subb    a,#$30
                mov     B,a
                inc     R0
                mov     a,@R0                   ;Modszy pobajt po konwersji z Ascii
                clr     C                       ; zapamitaj w ACC
                subb    a,#$30
                lcall   prog_nible_zloz         ;Zrz pbajty
                mov     @R0,a                   ; i zapamitaj
                inc     R0
                djnz    R7,clip_zeg_konw1
                ret

;-----------------------------------------------
;Zaleznie od typu danych (R4) zapis do rnych obszarw RAM
;WE: R4 - typ danych
;    R5 - CRC (do obliczania)
;    R6 - dugo rekordu
;    R7 - dugo caego meldunku
;WY: R5 - CRC
;    C  - status (C=1-OK, C=0-nieprzyszed znak)
;Zmienia: Acc, R0, R5, R6, R7
;
clip_rd_rekord: mov     a,R4                    ;typ danych
                cjne    a,#$02,clip_rd_tim      ;Jeli TYP=02 (nr abonenta)
                mov     len_clip,R6             ; zapamitaj dugo
 ;??? jeli dugo rekordu wiksza ni 16 znakw to zapisz tylko 16
                mov     R0,#buf_cyf_str         ; poczatek bufora na nr
clip_rd_nr:     lcall   read_rxdfsk             ;Odbierz dan
                jnc     clip_rd_err
 IF DEMO_CLIPFSK=YES                        ;Jeli demo to ostatnie cztery cyfry zastepuj gwiazdki
                push    ACC                     ;Dana na stos
                mov     a,R6                    ; jeli ostatnie cztery znaki
                cjne    a,#5,*+3
                jnc     clip_rd_nr1
                pop     ACC                     ; to na stos weprchnij symbol gwiazdki
                mov     a,#'*'
                push    ACC
clip_rd_nr1:    pop     ACC
 ENDI
                lcall   print_char              ;wyslij na RS
                mov     @R0,a                   ; zapisz dana w buforze
                inc     R0
                dec     R7
                djnz    R6,clip_rd_nr
                setb    C                       ;Znacznik OK
                ret

        ;-----------------------------------------------
clip_rd_tim:    cjne    a,#$01,clip_rd_rek      ;Jeli TYP=01 (data i czas)
                mov     len_clip,R6             ; zapamitaj dugo
 ;??? jeli dugo rekordu wiksza ni 16 znakw to zapisz tylko 16
                mov     R0,#resld               ; poczatek bufora na nr
clip_rd_tim1:   lcall   read_rxdfsk             ;Odbierz dan
                jnc     clip_rd_err
                lcall   print_char              ;wyslij na RS
                mov     @R0,a                   ; zapisz dana w buforze
                inc     R0
                dec     R7
                djnz    R6,clip_rd_tim1
                setb    C                       ;Znacznik OK
                ret

        ;-----------------------------------------------
clip_rd_rek:    lcall   read_rxdfsk             ;Odbierz dan
                jnc     clip_rd_err
                lcall   print_char              ;wyslij na RS
                dec     R7
                djnz    R6,clip_rd_rek
                setb    C                       ;Znacznik OK
clip_rd_err:    ret

;----------------------------------------------------------------------------
;Opis: Odczytuje osiem bitw z dekodera FSK
;WE: R5  - suma kontrolna
;WY: Acc - odebrany bajt
;    R5  - suma kontrolna
;    C   - status (C=1 - jest znak, C=0 - znak nierzyszed w odpowiednim czasie)
;Zmienia: Acc, R5
;
read_rxdfsk:    push    B
                mov     B,#0                    ;czekaj na przerwanie (przy 1200db transmisja bajtu=8ms)
read_rxdfsk1:   lcall   reset_watchdog
             ;   jb      FL_FSK,read_rxdfsk2     ; Jeli jest przerwanie skacz
                lcall   read_pio                 ;???
                jnb     ACC+INT_FSK,read_rxdfsk2 ;???
                lcall   wait_1ms
                djnz    B,read_rxdfsk1          ; Jeli niemin czas skacz
                pop     B
                clr     C                       ;Min czas wyjd z bdem
                ret
read_rxdfsk2:   pop     B

                clr     FL_FSK                  ;Kasuj przerwanie
                push    B
                mov     B,#8                    ;Liczba bitw
read_rxdfsk3:   mov     C,FSK_RXD               ; z RXD do C
                rrc     a                       ; skadanie bajtu
                setb    FSK_RXCK                ;Zegar aktywny
                nop
                nop
                clr     FSK_RXCK                ; zegar nieaktywny
                djnz    B,read_rxdfsk3          ; jeli niewszystkiw bity to bierz next
                push    ACC                     ;Dodaj CRC
                add     a,R5
                mov     R5,a
                pop     ACC
                setb    C                       ;Ustaw flag OK
                pop     B
                ret

;----------------------------------------------------------------------------
;???
read_pio:       clr     ET0                     ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                     ; poniewarz na irq wystpuj
                lcall   iic_start
                mov     a,#PIO_WRITE
                lcall   iic_write
                lcall   iic_start
                mov     a,#PIO_READ
                lcall   iic_write
                lcall   iic_read_np             ;Odczyt bajtu
                setb    EX0
                setb    ET0
                ret

;----------------------------------------------------------------------------
;Opis: Wywietla zdekodowany CLIP
;      wywietlanie ma miejsce jeli wskanik "len_clip" wskazuje warto
;      rn od 0
;
wyswietl_clip:  push    std_out
                mov     std_out,#STD_OUT_LCD    ;Wywietl CLIP na LCD
                lcall   wyswietl_clip0
                mov     std_out,#STD_OUT_SER    ;Wywietl CLIP na SER
                mov     dptr,#msg_clip
                lcall   print_text
                lcall   print_data_czas         ;Wywietl dat i czas
                lcall   print_spc
                lcall   wyswietl_clip0
                pop     std_out
                ret

;-----------------------------------------------
wyswietl_clip0: mov     a,len_clip              ;Jei jest CLIP to wywietl
                jz      print_clip_end
                mov     a,std_out               ;Jeli StdOut=LCR
                cjne    a,#STD_OUT_LCD,print_clip0
                lcall   print_crlf              ; przejd do drgiej linii wywietlacza
print_clip0:    mov     R0,#buf_cyf_str         ;Poczatek bufora
                mov     R7,len_clip             ;Odtwarzamy liczb znakw w buforze
print_clip3:    mov     a,@R0                   ;Czy znak rny od $30 ?
                cjne    a,#$30,print_clip4      ; tak wic nie jest zastrzeony w DTMF
                inc     R0                      ;next znak z bufora
                djnz    R7,print_clip3          ;czy koniec znakw ?
print_clip31:   mov     dptr,#txt_zastrzezony   ; tak wic nr zastrzeony (same zera)
                ljmp    print_text
                                ;<--- Zastpuje RET
print_clip4:    cjne    a,#80,print_clip5       ;Czy rny od 80
                sjmp    print_clip31            ;- nie wic zastrzezony w FSK
print_clip5:    cjne    a,#79,print_clip6       ;Czy rny od 79
                mov     dptr,#txt_niedostep     ;- nie wic niedostepny
                ljmp    print_text
                                ;<--- Zastpuje RET
print_clip6:    mov     R7,len_clip             ;Odtwarzamy liczb znakw w buforze
                mov     R0,#buf_cyf_str
print_clip:     mov     a,@R0
                lcall   print_char
                inc     R0
                djnz    R7,print_clip
print_clip_end: ret


txt_zastrzezony:STRING  'Anonim'
                BYTE    END_ASCII

txt_niedostep:  STRING  'Niedostpny'
                BYTE    END_ASCII

msg_clip_fsk:   BYTE    CR_ASCII,LF_ASCII
                STRING  '#FSK '
                BYTE    END_ASCII

msg_clip_dtmf:  BYTE    CR_ASCII,LF_ASCII
                STRING  '#DTMF '
                BYTE    END_ASCII

msg_clip:       BYTE    CR_ASCII,LF_ASCII
                STRING  '#Clip: '
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Odczytuje bajt rekordu z rejestratora (ustawia wskanik w eeprom na next bajt)
;we: "rej_l" - modszy modszy wskanika
;    "rej_h" - starszy starszy wskanika
;wy: ACC     - odczytany bajt
;      C     - status (C=1 - koniec danych)
;    "rej_l" - wskanik na kolejny bajt
;    "rej_h" - wskanik na kolejny bajt
;zmienia: PSW, ACC, "rej_l", "rej_h"
;
get_rejestr:
                push    DPH
                push    DPL
                lcall   get_rejestr_nonext
                push    PSW                             ;Zachowaj wskanik C
                mov     DPL,rej_l                       ;Wskanik do DPTR
                mov     DPH,rej_h
                inc     dptr                            ;Next adres
                mov     rej_l,DPL                       ;Zapamitanie wskanika
                mov     rej_h,DPH
                pop     PSW
                pop     DPL
                pop     DPH
                ret

;----------------------------------------------------------------------------
;Opis: Odczytuje bajt rekordu z rejestratora (nie zmienia wskanika w eeprom)
;we: "rej_l" - modszy modszy wskanika
;    "rej_h" - starszy starszy wskanika
;wy: ACC     - odczytany bajt
;
get_rejestr_nonext:
                push    DPH
                push    DPL

                mov     DPL,rej_l                       ;Wskanik do DPTR
                mov     DPH,rej_h
                lcall   read_eeprom
                push    ACC                             ;Zapamitaj dan
                lcall   dodaj_sume                      ;oblicz sum kotroln
                pop     ACC                             ;Odtwrz dan

                pop     DPL
                pop     DPH

                jnb     Acc+END_REJESTR,get_rej_ok      ;Czy koniec danych ?
                setb    C
                ret
get_rej_ok:     clr     C
                ret

;----------------------------------------------------------------------------
;Opis: Odczytuje dan z eeprom z pod adresu w dptr
;we: DPTR - adres bajtu w eeprom
;wy: ACC  - odczytana dana
;zmienia: Acc
;
read_eeprom:    lcall   reset_watchdog
                push    B                               ;Zachowaj rejestry
                push    DPH
                push    DPL
                clr     ET0                             ;Przerwanie T0 i EX0jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   konwertuj_adres_eeprom
                lcall   iic_start                       ;Odczyt danej z 24C64
                mov     a,#EEPROM_WRITE
                orl     a,B                             ; poczenie adresu ze skonwertowanycm
                lcall   iic_write
                jc      error_eeprom
                mov     a,DPH
                lcall   iic_write
                mov     a,DPL
                lcall   iic_write
                lcall   iic_start
                mov     a,#EEPROM_READ
                orl     a,B                             ; poczenie adresu ze skonwertowanycm
                lcall   iic_write
                jc      error_eeprom
                lcall   iic_read_np                     ;Odczyt jednego bajtu
                lcall   iic_stop
                setb    ET0
                setb    EX0
                pop     DPL
                pop     DPH
                pop     B
                ret

;----------------------------------------------------------------------------
error_eeprom:   mov     std_out,#STD_OUT_LCD
                lcall   print_err
                mov     dptr,#txt_error_eeprom   ;Wywietlenie napisu
                lcall   print_text
                ljmp    wait_error       ;<--- zastpuje RET
txt_error_eeprom:
                STRING  'EEprom'
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Zapisuje dan do eeprom z pod adres w dptr
;we: ACC  - dana do zapisu
;    DPTR - adres bajtu w eeprom
;wy: --
;zmienia: --
;
write_eeprom:   lcall   reset_watchdog
                push    B                               ;Zachowaj rejestry
                push    DPH
                push    DPL
                push    ACC
                clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   konwertuj_adres_eeprom
                lcall   iic_start
                mov     a,#EEPROM_WRITE
                orl     a,B                             ; poczenie adresu ze skonwertowanycm
                lcall   iic_write
                jc      error_eeprom
                mov     a,DPH
                lcall   iic_write
                mov     a,DPL
                lcall   iic_write
                pop     ACC                             ;Odtwrz ACC
                push    ACC                             ; i znw zapamitaj
                lcall   iic_write                       ;Zapisz dan
                lcall   iic_stop
                mov     a,#EEPROM_READ                  ;czekaj na koniec zapisu bajtu
                orl     a,B                             ; poczenie adresu ze skonwertowanycm
                lcall   iic_wait
                setb    ET0
                setb    EX0
                pop     ACC
                pop     DPL
                pop     DPH
                pop     B
                ret

;----------------------------------------------------------------------------
;Opis: Kowertuje adres eeprom z formatu 16-bit w dptr na
;      3-bity adres eeprom i 13-bitw adres w eeprom
;we: dptr - adres do odczytu/zapisu
;wy: dptr - adres w eeprom
;    B    - adres eeprom (bity A0...A3 w IIC)
;Zmienia: Acc,B, dptr
;
konwertuj_adres_eeprom:
                mov     a,DPH                           ;oblicz bity A0...A3 adresu
                rr      a                               ; eeprom IIC 24C64
                rr      a
                rr      a
                rr      a
                anl     a,#%00001110
                mov     B,a
                mov     a,DPH                           ;Obetnij adres w dptr
                anl     a,#%00011111                    ; do wielkoci adresowej
                mov     DPH,a                           ; pamici 24C64
                ret

;----------------------------------------------------------------------------
;Opis: Zapisuje bajt rekordu do rejestratora
;we: ACC     - bajt do zapisu
;    "rej_l" - modszy bajt adresu w pamici
;    "rej_h" - starszy bajt adresu w pamici
;wy: "rej_l" - wskanik na kolekny bajt
;    "rej_h" - wskanik na kolekny bajt
;zmienia: ACC, "rej_l", "rej_h"
;
put_rejestr:    push    ACC
                push    DPH
                push    DPL
                push    B

                mov     B,a                             ;Zapamitaj ACC
                mov     DPL,rej_l                       ;Adres do DPTR
                mov     DPH,rej_h
                lcall   write_eeprom                    ;Zapis do 24C64
                lcall   dodaj_sume                      ;Oblicza sum kontroln w B
                inc     dptr                            ;Next adres
                mov     rej_l,DPL                       ;Zapamitanie wskanika
                mov     rej_h,DPH

                pop     B
                pop     DPL
                pop     DPH
                pop     ACC
                ret

;----------------------------------------------------------------------------
;Opis: Szuka pierwszej wolnej komrki pamici rejestratora
;we: --
;wy: "rekord_l" - nr wolmego rekordu
;    "rekord_h" - nr wolmego rekordu
;    "rej_l"    - adres rekordu w eeprom
;    "rej_h"    - adres rekordu w eeprom
;zmienia: PSW, ACC
;
szukaj_free_rekord:
                lcall   set_rekord_0            ;Rekord nr 0
szukaj_1:       lcall   get_rejestr_nonext      ;Odczyt pamici rejestratora
                jc      szukaj_2                ;Jeli C=1 to koniec danych
                lcall   next_rekord             ;Next rekord
        ;??? Jeli wyjcie z C=1 to nie znaleziono wolnego rekordu
        ; a to oznacza bd bo conajmniej jeden musi by wolny
                sjmp    szukaj_1
szukaj_2:       ret

;----------------------------------------------------------------------------
;Opis: Ustawia wkanik na rekord rejestratora
;we: DPTR    - nr rekordu
;wy: "rekord_l" - nr rekordu
;    "rekord_h" - nr rekordu
;    "rej_l" - modszy wskanika
;    "rej_h" - starszy wskanika
;zmienia: PSW, ACC
;
set_rekord_0:   mov     rekord_l,#0             ;Ustawia rekord nr 0
                mov     rekord_h,#0
                sjmp    oblicz_wskaznik

;----------------------------------------------------------------------------
;Opis: Przeswa wskanik "rej_l" i "rej_h" na nastpny rekord
;      Jeli wskanik by ustawiony na ostatni rekord to nastpi ustawienie na
;      rekord nr 0
;we: "rekord_l" - nr rekordu
;    "rekord_h" - nr rekordu
;wy: C       - (C=0 ok, C=1 nastpio przewinicie)
;    "rej_l" - modszy wskanika
;    "rej_h" - starszy wskanika
;Zmienia: Acc
;
next_rekord:    mov     a,rekord_l              ;Sprawdzenie czy ostatni rekord
                cjne    a,max_rekord_l,next_rekord_1
                mov     a,rekord_h
                cjne    a,max_rekord_h,next_rekord_1
                lcall   set_rekord_0            ; ostatni wic ustaw zerowy
                setb    C                       ; i ustaw znacznik C
                ret
next_rekord_1:  mov     a,rekord_l              ;next rekord
                add     a,#1
                mov     rekord_l,a
                mov     a,rekord_h
                addc    a,#0
                mov     rekord_h,a
                lcall   oblicz_wskaznik
                clr     C
                ret

;----------------------------------------------------------------------------
;Opis: Przeswa wskanik "rej_l" i "rej_h" na poprzedni rekord
;      Jeli wskanik by ustawiony na zerowy rekord to nastpi ustawienie na
;      rekord ostatni
;we: "rekord_l" - nr rekordu
;    "rekord_h" - nr rekordu
;wy: C       - (C=0 ok, C=1 nastpio przewinicie)
;    "rej_l" - modszy wskanika
;    "rej_h" - starszy wskanika
;Zmienia: Acc
;
prev_rekord:    mov     a,rekord_l              ;Sprawdzenie czy zerowy rekord
                jnz     prev_rekord_1
                mov     a,rekord_h
                jnz     prev_rekord_1
                mov     rekord_l,max_rekord_l   ;Zerowy wic ustaw ostatni
                mov     rekord_h,max_rekord_h   ; i ustaw znacznik C
                lcall   oblicz_wskaznik
                setb    C
                ret
prev_rekord_1:  clr     C                       ;prev rekord
                mov     a,rekord_l
                subb    a,#1
                mov     rekord_l,a
                mov     a,rekord_h
                subb    a,#0
                mov     rekord_h,a
                lcall   oblicz_wskaznik
                clr     C
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia wkanik na rekord rejestratora
;we: "rekord_l" - nr rekordu
;    "rekord_h" - nr rekordu
;wy: "rej_l" - modszy wskanika
;    "rej_h" - starszy wskanika
;zmienia: PSW, ACC
;
oblicz_wskaznik:push    DPH
                push    DPL

                mov     DPL,rekord_l            ;Nr rekordu do przemnoenia
                mov     DPH,rekord_h

                mov     a,DPL                   ;Mnoymy przez 2
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 4)
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 8)
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 16)
                rlc     a
                anl     a,#%11110000
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a

                mov     a,DPL                   ;Dodajemy ofset
                add     a,#LOW bufor
                mov     DPL,a
                mov     a,DPH
                addc    a,#HIGH bufor
                mov     DPH,a

                mov     rej_l,DPL               ;Zapamitanie wskanika
                mov     rej_h,DPH

                pop     DPL
                pop     DPH
                ret

;============================================================================
;=               Procedury programowania rejestratora                       =
;============================================================================
;Opis: Wywietla cyklicznie menu z tablicy (od "tab_txtm" do "tab_txtm_end")
;      ostatni tekst jest wykrywany automatycznie
;
programowanie:  lcall   curs_off
                lcall   print_liczniki
                mov     out_device,#STD_OUT_PRT ;Wydruki na drukark
       ;???         lcall   wait_100ms              ;Ptla czasowa
       ;         lcall   wait_100ms
menu_wait:      lcall   curs_off
                lcall   zgloszenie              ;Czeka na podniesienie suchawki
                jc      prog_kod
                jnb     PROGRAM,menu_wait       ;Suchawka odoona
prog_exit:      mov     dptr,#txtm_wyjscie      ; komunikat i czekanie na konic PROG
                lcall   print_text
prog_exit_1:    lcall   zgloszenie              ;Jeli suchawka podniesiona
                jc      prog_menu               ; to znw programuj
                jnb     PROGRAM,prog_exit_1     ;jeli odoona i wyczony wycznik
                setb    BLK                     ;Wycz przekanik
                ret                             ; to wyjd

prog_kod:       clr     BLK                     ;Wcz przekanik
                mov     a,#1                    ;Ptla czasowa 100ms
                lcall   delay_100ms
 IF SAA1064=NO ;--- dla SAA1064 nie ma czekania na kod rejestratora ---
                lcall   wait_kod                ;Czeka na kod dostpu
                jb      F0,prog_exit            ;Jei odorzono suchawk to wychodzi
                jc      prog_kod                ;jeli kod niezgodny to czeka znowu
 ENDI

prog_menu:      lcall   curs_off
                mov     R1,#0                   ;Wskanik na tekst nr 0
prog_l2:        lcall   wys_txt_menu            ;wywietl tekst
                jc      prog_menu               ;Jeli koniec tekstu to skocz
                lcall   wait_cyfra              ;Czekaj 2 sekundy
                jb      F0,prog_exit            ; - skocz jeli odoono suchawk
                jnc     prog_wybral             ; - skocz jeli wybrano cyfr
                inc     R1                      ;Nastpny tekst
                sjmp    prog_l2                 ;i ptla

prog_wybral:    lcall   cls                     ;Czy wywietlacz
                lcall   curs_on
                mov     B,a                     ; i zapamitaj w B
                lcall   print_nible_spec__      ;Wywietl pierwsz wybran cyfr
                lcall   wait_cyfra              ;Czekaj na drug
                jb      F0,prog_exit            ; - skocz jeli odoono suchawk
                jc      prog_menu               ; - skocz jeli za dugo czeka
                lcall   print_nible_spec__      ;Wywietl drug wybran cyfr

                lcall   prog_nible_zloz         ;Skada nible w bajt (B-starszy, ACC-Modszy)
                lcall   prog_wykonaj            ;Wykonaj wybrany podprogram
                ljmp    prog_menu               ;Powrt do wyboru menu

;----------------------------------------------------------------------------
;Opis: Wywietla text menu o nr zawartym w R1
;we: R1 - nr tekstu menu
;wy: C  - (C=0 udao si wywietli, C=1 koniec tekstw)
;
wys_txt_menu:   mov     a,R1                                         ;Czy koniec tekstw ?
                cjne    a,#(tab_txtm_end-tab_txtm)/2,wys_txt_menu_l1 ; - nie wic wywietlaj dalej
                setb    C                                            ; - tak wic wyjd
                ret
wys_txt_menu_l1:mov     a,R1                    ;Obliczenie przesunicia
                rl      a                       ; (2 bajty na jeden adres)
                anl     a,#%11111110
                mov     B,a                     ;Zapamitanie przesunicia w B
                mov     dptr,#tab_txtm          ;Odczytanie modszego bajtu adresu
                movc    a,@a+dptr               ;Modszy adresu do R7
                mov     R7,a
                mov     a,B                     ;Odtworzenie przesunicia
                inc     a                       ; na nastpny bajt tablicy
                mov     dptr,#tab_txtm          ;Odczytanie starszego bajtu adresu
                movc    a,@a+dptr               ;Starszy adresu do DPH
                mov     DPH,a
                mov     DPL,R7                  ;Odtworzenie modszego bajtu adresu
                                                ;DPTR wskazuje teraz na tekst
                lcall   curs_off                ;Wywietlenie tekstu
                lcall   print_text
                clr     C
                ret

;----------------------------------------------------------------------------
;Opis: Czeka na bajt wysany przez tarcz numerow (lub RS)
;      Wyjcie z procedury tylko po wybraniu dwuch cyfr, znaku ponad $0A lub
;      po odorzeniu suchawki. Jeli wybrano znak ponad $A jako pierwszy
;      procedura zwroci ten znak w modszym i starszym nible,
;      jeli wybrano znak ponad $A jako drugi procedura zwrci w starszym poprzedni
;      warto, w modszym wybrany znak pinad $A.
;we: ACC - pozycja kursora (jeli 7 bit=1 to nie wywietla wprowadzanego znaku na LCD)
;wy: ACC - odczytany bajt
;     F0 - status (F0=1 gdy odoono suchawk (lub nacinito ESC przy RS))
;
wait_bajt:      clr     F1                      ;Wczenie ECHO
                sjmp    wait_bajt_0

;----------------------------------------------------------------------------
;Opis; Jak wyej tyle, e czeka na nible
;
wait_nible:     clr     F1                      ;Wczenia echa
                push    B
                mov     a,poz_wys               ;Ustaw kursor na LCD
                lcall   curs_set
                mov     B,#0                    ;Starszy=0
                sjmp    wait_bajt_2

;----------------------------------------------------------------------------
;Opis: Jak "wait_byte" tylko nie generuje ECHA na lcd
;
wait_bajt_noecho:
                setb    F1
wait_bajt_0:    push    B                       ;Ochrona rejestru
                mov     a,poz_wys               ;Ustaw kursor na LCD
                lcall   curs_set
wait_bajt_1:    lcall   wait_cyfra              ;Czeka na cyfr
                jb      F0,wait_bajt_exit
                jc      wait_bajt_1
                cjne    a,#$A,*+3               ;Jeli cyfra miejsza od $A to skok
                jc      wait_bajt_3
                mov     B,a                     ;cyfra wiksza od $A, Zapamitaj znak w B
                rl      a                       ;Przesu znak na starszy nible
                rl      a
                rl      a
                rl      a
                anl     a,#$F0
                orl     a,B                     ;skopiuj znak
                sjmp    wait_bajt_exit          ; i wyjd
wait_bajt_3:    mov     B,a                     ;W B dziesitki
                jb      F1,*+6                  ;Jeli F1 to nie wywietlaj echa
                lcall   print_nible_spec__
wait_bajt_2:    lcall   wait_cyfra              ;Czeka na cyfr
                jb      F0,wait_bajt_exit
                jc      wait_bajt_2
                jb      F1,*+6                  ;Jeli F1 to nie wywietlaj echa
                lcall   print_nible_spec__      ;W ACC jednoski
                lcall   prog_nible_zloz         ;Zoenie nibli w cao
wait_bajt_exit: pop     B
                ret

;-----------------------
prog_nible_zloz:push    ACC                     ;Zoenie nibli w cao
                mov     a,B                     ;W B starszy, ACC modszy
                rl      a                       ;Wynik w ACC
                rl      a
                rl      a
                rl      a
                anl     a,#$f0
                mov     B,a
                pop     ACC
                orl     a,B
                ret

;----------------------------------------------------------------------------
;Opis: Sprawdza czy odloono suchawk (jeli out_device=#STD_OUT_PRT) lub wyslano
;      znak ESC (jeli out_device=#STD_OUT_SER)
;wy: C (C=1 przerwano, C=0 nie)
;
czy_break:      push    ACC
                mov     a,out_device                    ;Jakie urzdzenie wyjciowe
                cjne    a,#STD_OUT_SER,czy_break_telefon
                                                        ;Obsuga RS232
                lcall   read_fifo                       ;pobiera znak
                jnc	czy_break_nie                   ;C=0 wic bez znaku
                cjne    a,#ESC_ASCII,czy_break_nie      ;Jeli nie ESC to nie przerwano
                sjmp    czy_break_tak                   ;jest ESC wic przerwano
czy_break_telefon:                                      ;Obsuga drukarki
                jnb     OPT1,czy_break_nie
                jnb     OPT2,czy_break_nie
czy_break_tak:  pop     ACC                             ;Zdekodowano przerwanie
                setb    C
                ret
czy_break_nie:  pop     ACC                             ;Nie przerwano
                clr     C
                ret

;----------------------------------------------------------------------------
;Opis: Czeka na cyfr 2 sekundy. Wychodzi z ustawionym C jei wybrano cyfr
;       lub zerowanym jeli miny 2 sek.
;      Jeli "std_out_ser" to czeka na znak z RS i konwertuje do cyfry BCD
;we: --
;wy: ACC - wybrana cyfra
;      C - status (C=0 wybrano cyfr, C=1 min czas)
;     F0 - status (F0=1 gdy odoono suchawk (lub nacinito ESC dla RS)
;zmienia: PSW, ACC, R7, F0
;
wait_cyfra:     lcall   reset_watchdog
                mov     a,std_out                       ;Czy RS ?
                cjne    a,#STD_OUT_SER,wait_cyfra_c0    ; nie wic obsuga telefonu
wait_cyfra_r1:  lcall   in_rs                           ; tak wic czeka na RS
                jc      wait_cyfra_time
                cjne    a,#ESC_ASCII,wait_cyfra_r2      ;Czy kod przerwania
                sjmp    wait_cyfra_off                  ; tak wic symyluj odoenie sluchawki
wait_cyfra_r2:  clr     C                               ; nie wic znak
                subb    a,#$30                          ;symuluj cyfr BCD
                sjmp    wait_cyfra_ok

wait_cyfra_c0:  lcall   zeruj_czas_rozmowy
                mov     overtime,#2             ;Czas czekania
wait_cyfra_c1:  jnb     OPT1,wait_cyfra_c4      ;Jeli prd pynie
                jnb     OPT2,wait_cyfra_c4      ; sprawd czy DTMF
                sjmp    wait_cyfra_c5           ;Przerwa (impuls) wic skacz

wait_cyfra_c4:  jnb     FL_DTMF,wait_cyfra_c2   ;Nie DTMF wic skacz

wait_cyfra_c5:  lcall   licz                    ;Jest DTMF lub impuls wic dekoduj cyfr
                jnc     wait_cyfra_ok           ;Czy odoono suchawk ?
wait_cyfra_off: setb    F0                      ;Suchawka odoona
                setb    C                       ; no i nie ma znaku (jakby min czas)
                ret
wait_cyfra_ok:  clr     F0                      ;Wybrano cyfr (wynik w ACC)
                clr     C                       ; oczywiste, e suchawka podniesiona
                ret
wait_cyfra_c2:  lcall   reset_watchdog
                mov     a,overtime              ;Czy min czas ?
                cjne    a,#$00,wait_cyfra_c1
wait_cyfra_time:clr     F0                      ;min czas ale, suchawka podniesiona
                setb    C
                ret

;-----------------------
;                        1234567890123456
txtm_wyjscie:   BYTE    CLS_ASCII
                STRING  '** Wycz PROG *'
                BYTE    END_ASCII

txtm_liczniki:  BYTE    CLS_ASCII               ; 1x - wywietlanie
                STRING  '11-Liczniki'
                BYTE    END_ASCII

txtm_druk_rozm: BYTE    CLS_ASCII
                STRING  '71-Druk bufora'        ; 7x - wydruki
                BYTE    END_ASCII

txtm_druk_pref: BYTE    CLS_ASCII
                STRING  '72-Druk prefiks'
                BYTE    END_ASCII

txtm_druk_tar:  BYTE    CLS_ASCII
                STRING  '73-Druk taryf'
                BYTE    END_ASCII

txtm_druk_konf: BYTE    CLS_ASCII
                STRING  '74-Druk konfig'
                BYTE    END_ASCII

txtm_druk_poCLR:BYTE    CLS_ASCII
                STRING  '79-Druk po CLR'
                BYTE    END_ASCII

txtm_prefiksy:  BYTE    CLS_ASCII               ; 9x - ustawianie
                STRING  '91-Ustaw prefiks'
                BYTE    END_ASCII

txtm_taryfy:    BYTE    CLS_ASCII
                STRING  '92-Ustaw taryfy'
                BYTE    END_ASCII

txtm_cena:      BYTE    CLS_ASCII
                STRING  '93-Cena'
                BYTE    END_ASCII

txtm_czas:      BYTE    CLS_ASCII
                STRING  '94-Czas'
                BYTE    END_ASCII

txtm_zalicz:    BYTE    CLS_ASCII
                STRING  '95-Zaliczanie'
                BYTE    END_ASCII

txtm_typprt:    BYTE    CLS_ASCII
                STRING  '96-Drukarka'
                BYTE    END_ASCII

txtm_typ_pl:    BYTE    CLS_ASCII
                STRING  '97-Standard PL'
                BYTE    END_ASCII

txtm_jasled:    BYTE    CLS_ASCII
                STRING  '98-Jasno LED'
                BYTE    END_ASCII

txtm_kod:       BYTE    CLS_ASCII
                STRING  '99-Kod'
                BYTE    END_ASCII

txtm_init:      BYTE    CLS_ASCII               ; 0x - kasowanie
                STRING  '00-Standard'
                BYTE    END_ASCII

txtm_clr_rozm:  BYTE    CLS_ASCII
                STRING  '01-Kasuj bufor'
                BYTE    END_ASCII

;-----------------------
tab_txtm:       BYTE    LOW txtm_liczniki,    HIGH txtm_liczniki
                BYTE    LOW txtm_druk_rozm,   HIGH txtm_druk_rozm
                BYTE    LOW txtm_druk_pref,   HIGH txtm_druk_pref
                BYTE    LOW txtm_druk_tar,    HIGH txtm_druk_tar
                BYTE    LOW txtm_druk_konf,   HIGH txtm_druk_konf
 IF SAA1064=NO  ;--- dla SAA1064 nie wyswietla ponizszego menu ---
                BYTE    LOW txtm_druk_poCLR,  HIGH txtm_druk_poCLR
                BYTE    LOW txtm_prefiksy,    HIGH txtm_prefiksy
                BYTE    LOW txtm_taryfy,      HIGH txtm_taryfy
 ENDI
                BYTE    LOW txtm_cena,        HIGH txtm_cena
                BYTE    LOW txtm_czas,        HIGH txtm_czas
                BYTE    LOW txtm_zalicz,      HIGH txtm_zalicz
 IF SAA1064=YES ;--- za to jest dodatkowe menu ----
                BYTE    LOW txtm_jasled,      HIGH txtm_jasled
 ENDI
 IF SAA1064=NO  ;--- dla SAA1064 nie wyswietla ponizszego menu ---
                BYTE    LOW txtm_typprt,      HIGH txtm_typprt
                BYTE    LOW txtm_typ_pl,      HIGH txtm_typ_pl
                BYTE    LOW txtm_kod,         HIGH txtm_kod
 ENDI
                BYTE    LOW txtm_init,        HIGH txtm_init
                BYTE    LOW txtm_clr_rozm,    HIGH txtm_clr_rozm
tab_txtm_end:

;----------------------------------------------------------------------------
;Opis: Wykonuje podprogram o numerze zawartym w Acc
;We: ACC - nr programu
;Wy: C   - (C=0 ok, C=1 nie ma takiego programu)
;
prog_wykonaj:   cjne    a,#$11,*+8
                lcall   print_liczniki
                clr     C
                ret

                cjne    a,#$71,*+8
                lcall   print_rejestr
                clr     C
                ret

                cjne    a,#$72,*+8
                lcall   print_prefiksy
                clr     C
                ret

                cjne    a,#$73,*+8
                lcall   print_taryfy
                clr     C
                ret

                cjne    a,#$74,*+8
                lcall   print_konfig
                clr     C
                ret
 IF SAA1064=NO                                   ;Dla SAA1064 ponisze opcje niewystpuj
                cjne    a,#$79,*+8
                lcall   print_rejestr_poCLR
                clr     C
                ret

                cjne    a,#$91,*+8
                lcall   set_prefiksy
                clr     C
                ret

                cjne    a,#$92,*+8
                lcall   set_taryfy
                clr     C
                ret
 ENDI
                cjne    a,#$93,*+8
                lcall   ustaw_cene
                clr     C
                ret

                cjne    a,#$94,*+8
                lcall   ustaw_czas
                clr     C
                ret

                cjne    a,#$95,*+8
                lcall   ustaw_zaliczanie
                clr     C
                ret
 IF SAA1064=NO                                   ;Dla SAA1064 ponisze opcje niewystpuj
                cjne    a,#$96,*+8
                lcall   ustaw_typ_drukarki
                clr     C
                ret

                cjne    a,#$97,*+8
                lcall   ustaw_typ_pl
                clr     C
                ret

                cjne    a,#$99,*+8
                lcall   ustaw_kod
                clr     C
                ret
 ENDI
 IF SAA1064=YES                                  ;Dla SAA1064 dodatkowe menu
                cjne    a,#$98,*+8
                lcall   ustaw_jasled
                clr     C
                ret
 ENDI
                cjne    a,#$00,*+8
                lcall   set_standard
                clr     C
                ret

                cjne    a,#$01,*+8
                lcall   kasuj_bufor
                clr     C
                ret

                setb    C
                ret

;----------------------------------------------------------------------------
;Opis; Ustawia typ znakw PL dla drukarki i RS
;
ustaw_typ_pl:   lcall   curs_on
                mov     dptr,#txt_typ_pl_prt    ;Wywietlenie pytania na LCD
                lcall   print_text
                lcall   wait_cyfra
                jb      F0,ustaw_typ_pl_exit    ;Jeli odoona suchawka pomi
                jc      *-6                     ;Jeli nie wybrano cyfry czekaj poniwnie
                mov     prt_pl,a
                mov     dptr,#txt_typ_pl_rs     ;Wywietlenie pytania na LCD
                lcall   print_text
                lcall   wait_cyfra
                jb      F0,ustaw_typ_pl_exit    ;Jeli odoona suchawka pomi
                jc      *-6                     ;Jeli nie wybrano cyfry czekaj poniwnie
                mov     ser_pl,a
                lcall   write_konfig            ;Zapisz zmianay
ustaw_typ_pl_exit:
                ljmp    print_crlf      ;<--- Zastpuje RET

                ;        1234567890123456
txt_typ_pl_prt: BYTE    CLS_ASCII
                STRING  'Prt PL: '
                BYTE    END_ASCII
txt_typ_pl_rs:  BYTE    CLS_ASCII
                STRING  'RS232 PL: '
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Ustwia typ drukarki (par lub ser)
;
ustaw_typ_drukarki:
                lcall   curs_on
                mov     dptr,#txt_typprt        ;Wywietlenie pytania na LCD
                lcall   print_text
                lcall   wait_cyfra_01           ;Czekanie na cyfr 1 lub 0
                jb      F0,ustaw_typ_prt_exit   ;Jeli odoona suchawka pomi
                jc      ustaw_typ_prt_ser
                mov     printer_device,#PARALLEL_PRINTER
                sjmp    ustaw_typ_prt_zapisz
ustaw_typ_prt_ser:
                mov     printer_device,#SERIAL_PRINTER
ustaw_typ_prt_zapisz:
                lcall   write_konfig            ;Zapisz zmiany
ustaw_typ_prt_exit:
                ljmp    print_crlf      ;<--- Zastpuje RET

txt_typprt:     BYTE    CLS_ASCII
                STRING  'Prt 0-Par 1-Ser'
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Kasuje rejestr rozmw
;
clr_rejestr:                                    ;Kasowanie rejestratora
                lcall   set_rekord_0            ; zapis bajtu koca rejestratora
clr_rej_1:      lcall   get_rejestr_nonext      ; do pierwszego rekordu
                setb    Acc+END_REJESTR
                lcall   put_rejestr
                lcall   next_rekord             ;next rekord
                jnc     clr_rej_1               ; i tak do konca pamici
                lcall   init_status
                ret

;----------------------------------------------------------------------------
;Opis: Wywietla stan liczniakw ostatniej rozmowy, sumy rozmw
;       wielok bufora i pozosta woln pami bufora
;      Jeli podczas wywietlania nacinity zostanie przycisk to pokae pierwszy
;       rekord z romow, pniej kolejny itd
;
print_liczniki: lcall   cls
        ;-------- pojemno rejestratora ------------
                mov     DPL,max_rekord_l
                mov     DPH,max_rekord_h
                mov     B,#5 OR DO_LEWEJ        ;Liczba znakow do wywietlenia
                lcall   print_dptr_bcd_NZ       ; wywietlamy w BCD
                mov     a,#"/"                  ;Wywietlenie pojemnoci pamici
                lcall   print_char
                lcall   oblicz_licznik          ;Oblicza stan licznika
                mov     DPL,R2
                mov     DPH,R3
                mov     B,#4 OR DO_LEWEJ        ;Liczba cyfr do wywietlenia
                lcall   print_dptr_bcd_NZ       ;Wywietlenie liczby rozmw

                lcall   print_crlf
                                       ;??? Moe drugie obliczenie nie bdzie konieczne ?
                lcall   oblicz_licznik          ;Oblicza stan licznika
                mov     B,#8 OR DO_LEWEJ        ;Liczba pozycji do wywietlenia
                lcall   print_cena_licznika     ;Wywietla Sum licznikw
                mov     a,#"/"
                lcall   print_char
                mov     R5,licznik_impulsow_ost_h;Ostania rozmowa
                mov     R4,licznik_impulsow_ost_l
                mov     R7,#0                   ;najstarsze=0
                mov     R6,#0
                mov     B,#5 OR DO_LEWEJ        ;Liczba pozycji do wywietlenia
                lcall   print_cena_licznika

prt_licz_0:     lcall   reset_watchdog          ;Czeka a przycisk bdzie puszczony
                jnb     PROGRAM,prt_licz_0
                mov     B,#20                   ;Czekaj 2 sekundy
prt_licz_1:     lcall   wait_100ms
                jnb     PROGRAM,prt_licz_2      ; jeli nacinito przycisk to skocz
                djnz    B,prt_licz_1            ; jeli nie i min czas to wyjd
                ret
prt_licz_2:     ljmp    print_ostatnie

;-----------------------
;Opis: Oblicza stan licznika na podstawie rejestru rozmw
;we: --
;wy: R7, R6, R5, R4 - stan licznika (R7 - najstarszy, R4 - najmodszy)
;    R3, R2         - liczba rozmw
;
oblicz_licznik: mov     R4,#0                   ;Zerowanie licznikw
                mov     R5,#0
                mov     R6,#0
                mov     R7,#0
                mov     R2,#0
                mov     R3,#0
                lcall   szukaj_pierwszego_rekordu
                jnc     oblicz_licz_31          ;Jeli bufor pusty
                ret                             ; wyjd z zezrami
oblicz_licz_31: lcall   get_rejestr             ;Odczyt pamici rejestratora
                jc      oblicz_licz_exit        ;Jeli C=1 to koniec danych
                mov     B,#12                   ;Przeswa wskanik na licznik abonencki
                lcall   next_rejestr
                lcall   get_rejestr             ;Pobiera starszy
                push    ACC                     ; i zapamituje
                lcall   get_rejestr             ;Pobiera modszy
                add     a,R4                    ; dodaje
                da      a
                mov     R4,a
                pop     ACC                     ;starszy
                addc    a,R5
                da      a
                mov     R5,a
                mov     a,R6                    ;jeszcze starszy
                addc    a,#0
                da      a
                mov     R6,a
                mov     a,R7                    ;Najstarszy
                addc    a,#0
                da      a
                mov     R7,a
                mov     a,R2                    ;Dodaj licznik rozmw
                add     a,#1
                mov     R2,a
                mov     a,R3
                addc    a,#0
                mov     R3,a
                lcall   next_rekord             ;next rekord
                sjmp    oblicz_licz_31
oblicz_licz_exit:
                ret

;----------------------------------------------------------------------------
;Opis: Szuka pierwszego penego rekordu w buforze koowym
;       Najpierw szuka pierwszego pustego rekordu (pene pomija)
;       nastpnie szuka szuka pierwszego penego rekordu (puste pomija)
;       Po tej operacji mam pierwszy peny rekord odnaleziony
;       Jeli penego rekordu nie da si odnale do koca bufora
;       oznacza to e jest pusy
;      Procedura taka jest konieczna poniewa rekord nr 0 moe zawiera
;       pusty rekord, ale poprzedni rekord (czyli na koncu pamici) moe
;       zawiera peny rekord
;Wy: "rekord_l" - nr rekordu
;    "rekord_h" - nr rekordu
;    "rej_l"    - wskanik rekordu w eeprom
;    "rej_h"    - wskanik rekordu w eeprom
;    C          - (C=0 ok, C=1 bufor pusty)
;
szukaj_pierwszego_rekordu:
                lcall   szukaj_free_rekord      ;Szukaj rekordu pustego
                lcall   next_rekord
                mov     dptr,#0                 ;Licznik przej
oblicz_licz_21: lcall   get_rejestr_nonext      ; a teraz pierwszego zapenionego
                jnc     oblicz_licz_3
                inc     dptr                    ;Zwiksz licznik obiegw
                mov     a,DPL                   ;Czy obiegi=pojemno bufora ?
                cjne    a,max_rekord_l,oblicz_licz_22
                mov     a,DPH
                cjne    a,max_rekord_h,oblicz_licz_22
                lcall   set_rekord_0            ; tak, wic bufor pusty
                setb    C
                ret
oblicz_licz_22: lcall   next_rekord
                sjmp    oblicz_licz_21
oblicz_licz_3:  clr     C
                ret

;----------------------------------------------------------------------------
;-                             Ustawianie czasu                             -
;----------------------------------------------------------------------------
ustaw_czas:     mov     dptr,#txt_czas_1
                lcall   print_text
                lcall   curs_on                 ;Ustawia migajcy kursor

        ;--------- Programowanie roku -----
ustaw_czas_rr:  mov     poz_wys,#0              ;Pozycja kursora
                lcall   wait_bajt
                jb      F0,ustaw_czas_exit
                mov     nr_linii_h,a            ;Zapamitanie setek/tysicy lat w R0
                lcall   wait_bajt
                jb      F0,ustaw_czas_exit
                mov     nr_linii_l,a            ;Zapamitanie jednoci/dziesitek lat

        ;--------- Programowanie miesica i dnia -----
ustaw_czas_mm:  mov     poz_wys,#5              ;Pozycja kursora
                lcall   wait_bajt
                jb      F0,ustaw_czas_exit
                mov     R2,a                    ;Zapamitanie miesica w R2
                cjne    a,#$12+1,*+3            ;Sprawdzenie zakresu (01-12)
                jnc     ustaw_czas_mm
                cjne    a,#$01,*+3
                jc      ustaw_czas_mm

ustaw_czas_dd:  mov     poz_wys,#8
                lcall   wait_bajt
                jb      F0,ustaw_czas_exit
                mov     R3,a                    ;Zapamitanie dni w R3
                cjne    a,#$31+1,*+3            ;Sprawdzenie zakresu (01-31)
                jnc     ustaw_czas_dd
                cjne    a,#$01,*+3
                jc      ustaw_czas_dd

        ;--------- Programowanie godziny i minuty -----
ustaw_czas_gg:  mov     dptr,#txt_czas_2
                lcall   print_text
                mov     poz_wys,#0
                lcall   wait_bajt
                jb      F0,ustaw_czas_exit
                mov     R4,a                    ;Zapamitanie godzin w R4
                cjne    a,#$23+1,*+3            ;Sprawdzenie zakresu (00-23)
                jnc     ustaw_czas_gg

ustaw_czas_min: mov     poz_wys,#3
                lcall   wait_bajt
                jb      F0,ustaw_czas_exit
                mov     R5,a                    ;Zapamitanie minut w R5
                cjne    a,#$59+1,*+3            ;Sprawdzenie zakresu (00-59)
                jnc     ustaw_czas_min

                mov     godzina,R4              ;Przepisanie czasu do ram
                mov     minuta,R5
                mov     dzien,R3
                mov     miesiac,R2
                mov     rok_h,nr_linii_h
                mov     rok_l,nr_linii_l

                lcall   write_czas              ;i do zegara PCF
ustaw_czas_exit:ret

;-----------------------
                        ;0123456789abcdef
txt_czas_1:     BYTE    CLS_ASCII
                STRING  'RRRR MM/DD'
                BYTE    0
txt_czas_2:     BYTE    CLS_ASCII
                STRING  'gg:mm'
                BYTE    0

;----------------------------------------------------------------------------
;-                             Ustawianie ceny                              -
;----------------------------------------------------------------------------
ustaw_cene:     mov     dptr,#txt_cena_1
                lcall   print_text
                lcall   curs_on

        ;----------- Ustawianie zotych -------------
                mov     poz_wys,#5              ;Ustawia migajcy kursor
ustaw_cene_1:   lcall   wait_bajt
                jb      F0,ustaw_cene_exit
                mov     R2,a                    ;Zapamitanie zotych w R2

        ;----------- Ustawianie groszy -------------
                mov     poz_wys,#8
ustaw_cene_3:   lcall   wait_bajt
                jb      F0,ustaw_cene_exit
                mov     R3,a                    ;Zapamitanie groszy w R3

;??? Ominite ustawianie VAT
;        ;----------- Ustawianie stawki VAT -------------
;                mov     poz_wys,#$d
;ustaw_cene_5:   lcall   wait_bajt
;                jb      F0,ustaw_cene_exit
;                mov     R4,a                    ;Zapamitanie vat w R4

                mov     cena_gr,R3              ;Zapamitace ceny w RAM
                mov     cena_zl,R2
                mov     cena_vat,R4
                lcall   write_konfig            ;Zapamitanie konfigu w eeprom

ustaw_cene_exit:mov     a,#10                   ;Opnienie
                ljmp    delay_100ms             ;<---- Zastpuje RET

                        ;0123456789abcdef
txt_cena_1:     BYTE    CLS_ASCII
                STRING  'Cena ??,??z'
    ;???        STRING  'Cena ??,??z ??%'
                BYTE    0



;----------------------------------------------------------------------------
;-                         Ustawie sposobu zaliczania                       -
;----------------------------------------------------------------------------
ustaw_zaliczanie:
                mov     dptr,#txt_sp_zaliczania
                lcall   print_text
                lcall   curs_on
                mov     poz_wys,#11
prog_zalicz_5:  lcall   wait_bajt
                jb      F0,prog_zalicz_exit
                mov     kryterium_rozmowy,a
                lcall   write_konfig            ;Zapamitanie konfigu w eeprom
prog_zalicz_exit:
                ljmp    print_crlf      ;<--- Zastpuje RET

txt_sp_zaliczania:
                BYTE    CLS_ASCII
                STRING  'Zaliczanie ??'
                BYTE    0

;----------------------------------------------------------------------------
;Opis: czeka na cyfr 1 lub rn od 0
;we: --
;wy: C  - (C=1 to wybrano tak "1", jeli C=0 to wybrano inn)
;    F0 - (F0=1 to odoono suchawk)
;
wait_cyfra_01:  lcall   wait_cyfra                      ;Czekanie na cyfr
                jb      F0,wait_cyfra_01_exit           ;Jeli odoona suchawka to F0=1
                jc      wait_cyfra_01                   ;
                cjne    a,#$01,wait_cyfra_01_exit       ;jak cyfr wybrano ?
                setb    C                               ; "1" wic C=1
                ret
wait_cyfra_01_exit:
                clr     C                               ; "0" wic C-0
                ret

;============================================================================
;=   Procedury wywieltania daty, czasu, licznika impulsw, itp na LCD      =
;============================================================================
;Opis: Napis "Drukowanie..." lub "Obsuga RS..."na LCD
;we: --
;wy: --
;
lcd_drukowanie: push    std_out
                mov     std_out,#STD_OUT_LCD
                lcall   curs_on
                mov     dptr,#txt_drukowanie
                mov     a,out_device                    ;Czy wyjcie na drukark ?
                cjne    a,#STD_OUT_SER,lcd_druk_l1      ; tak wic skocz
                mov     dptr,#txt_obsluga_rs            ; nie wic zmie napis
lcd_druk_l1:    lcall   print_text
                pop     std_out
                ret

txt_drukowanie: BYTE    CLS_ASCII
                STRING  'Drukowanie..'
                BYTE    0

txt_obsluga_rs: BYTE    CLS_ASCII
                STRING  'Obsuga RS..'
                BYTE    0


;----------------------------------------------------------------------------
;Opis: Wywietla czas pozostay do koca impulsu
;
print_timeback:
 IF SAA1064=NO ;--- dla SAA1064 wyswietla timeback bez setnych sekundy i dane na LED ---
                mov     a,#$45
                lcall   curs_set_lcd
                mov     a,licznik_czasu_sek_h
                lcall   print_nible
                mov     a,licznik_czasu_sek_l
                lcall   print_hex
                mov     a,#"."
                lcall   print_char
                mov     a,licznik_czasu_setne
                lcall   print_hex
                mov     a,#$40
                lcall   curs_set_lcd
                mov     a,#"t"
                lcall   print_char
                mov     a,pref_taryfa
                lcall   print_hex
 ELSE
                mov     a,#$42
                lcall   curs_set_lcd
                mov     a,licznik_czasu_sek_h
                lcall   print_nible
                mov     a,licznik_czasu_sek_l
                lcall   print_hex

                mov     a,std_out
                cjne    a,#STD_OUT_LCD,exit_timeback    ;Jeli wyjcie na LCD to obsuguj, jeli nie to olej procedur
                lcall   iic_init                        ;LED dolny
                mov     a,licznik_czasu_sek_h
                lcall   konw_led
                mov     R4,B
                mov     R5,a
                mov     a,licznik_czasu_sek_l
                lcall   konw_led
                mov     R6,B
                mov     R7,a
                lcall   saa1
                lcall   iic_init
 ENDI
exit_timeback:  ret

;----------------------------------------------------------------------------
;Opis: Wywietla taryf i miejscowo z jak prowadzona jest rozmowa
;we:
;wy:
;zmienia:
;
print_taryfa_miejscowosc:
                lcall   print_crlf
                mov     DPL,nr_prefiksu
                mov     DPH,#0
                lcall   read_prefiks
                lcall   print_nazwa_prefiksu
                lcall   print_spc
                mov     a,#SNG_TARYFA
                lcall   print_char
                mov     a,pref_taryfa
                ljmp    print_hex       ;<--- zastpuje RET

;----------------------------------------------------------------------------
;Opis: Wywietla nazw prefiksu (komentarz)
;      Przed t funkcj musi by wywoana "read_prefiks"
;Zmienia: ACC, DPTR, R0
;
print_nazwa_prefiksu:
                lcall   read_nazwa_prefiksu
print_nazwa_prefiksu_2:
                mov     R0,#9
prn_namepref_4: lcall   read_eeprom
                jz      prn_namepref_42         ;Jeli zero to wczeniejszy koniec tekstu
                lcall   print_char
                inc     dptr                    ;next adres eeprom
                djnz    R0,prn_namepref_4
                sjmp    prn_namepref_43
prn_namepref_42:lcall   print_spc               ;Jeli kocem tekstu by kod ZERO
                djnz    R0,prn_namepref_42      ; to dopenij spacjami
prn_namepref_43:ret

;----------------------------------------------------------------------------
;Opis: Wywietla czas trwania rozmowy i naleno za rozmow
;we:
;wy:
;zmienia:
;
print_kasa:
 IF SAA1064=NO ;--- dla SAA1064 czas rozmowy i licznik impulsw ---
                mov     a,czas_rozmowy_godz
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                mov     a,czas_rozmowy_min
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                mov     a,czas_rozmowy_sek
                lcall   print_hex

                lcall   print_spc
                lcall   print_spc
                mov     a,licznik_impulsow_h
                mov     R5,a                    ;Zapamitaj starszy licznika
                mov     R7,#0                   ;najstarsze=0
                mov     R6,#0
                mov     a,licznik_impulsow_l
                mov     R4,a                    ;Zapamitaj modszy licznika
                mov     B,#5                    ;Liczba pozycji do wywietlenia
                lcall   print_cena_licznika
 ELSE
                mov     a,#"L"
                lcall   print_char
                mov     a,licznik_impulsow_h
                lcall   print_hex
                mov     a,licznik_impulsow_l
                lcall   print_hex

                lcall   print_spc
                lcall   print_spc
                mov     a,licznik_impulsow_h
                mov     R5,a                    ;Zapamitaj starszy licznika
                mov     R7,#0                   ;najstarsze=0
                mov     R6,#0
                mov     a,licznik_impulsow_l
                mov     R4,a                    ;Zapamitaj modszy licznika
                mov     B,#5                    ;Liczba pozycji do wywietlenia
                lcall   print_cena_licznika
                mov     a,#"z"
                lcall   print_char
                mov     a,#""
                lcall   print_char

                lcall   iic_init                ;LED dolny
                mov     a,licznik_impulsow_h
                lcall   konw_led
                mov     R4,B
                mov     R5,a
                mov     a,licznik_impulsow_l
                lcall   konw_led
                mov     R6,B
                mov     R7,a
                lcall   saa2
                lcall   iic_init
 ENDI
                ret

;----------------------------------------------------------------------------
;Opis: Wywietla czas trwania rozmowy i licznik impulsw
;we:
;wy:
;zmienia:
;
print_impulsy:  mov     a,czas_rozmowy_godz     ;czas rozmowy
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                mov     a,czas_rozmowy_min
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                mov     a,czas_rozmowy_sek
                lcall   print_hex

                lcall   print_spc               ; i stan licznika impulsw
                lcall   print_spc
                lcall   print_spc
                mov     a,#"L"
                lcall   print_char
                mov     a,licznik_impulsow_h
                lcall   print_hex
                mov     a,licznik_impulsow_l
                ljmp    print_hex       ;<--- zastpuje RET

;----------------------------------------------------------------------------
;Opis: Wywietla aktualny czas i dat na LCD
;
print_data_czas:lcall   home                            ;Wywietl aktualn dat
                lcall   read_czas
                mov     a,dzien_tygodnia
                lcall   print_dzien_tygodnia
                lcall   print_spc
                mov     a,dzien
                lcall   print_hex
                lcall   print_spc
                mov     a,miesiac
                lcall   print_miesiac
                lcall   print_spc

                mov     a,godzina                       ; i czas
                lcall   print_hex
                mov     a,std_out                       ;Jeli wyjcie nie na LCD
                cjne    a,#STD_OUT_LCD,prt_data_czas_2  ; wywietlaj zawsze dwukropek
                mov     a,licznik10_2                   ;Czy mino p sekundy?
                cjne    a,#5,*+3
                mov     a,#" "                          ; - nie to znak " "
                jc      prt_data_czas_1
prt_data_czas_2:mov     a,#":"                          ; - tak to znak ":"
prt_data_czas_1:lcall   print_char                      ;Wywietl w/w znak
                mov     a,minuta
                lcall   print_hex
 IF SAA1064=NO ;Jeli nie SAA1064 to wyjcie z podprogramu
                ret
 ELSE         ;--- dla SAA1064 obsluga SAA ---
                mov     a,std_out
                cjne    a,#STD_OUT_LCD,exit_dataczas    ;Jeli wyjcie na LCD to obsuguj, jeli nie to olej procedur

                lcall   iic_init                        ;LED dolny
                mov     R4,#0
                mov     R5,#0
                mov     R6,#0
                mov     R7,#0
                lcall   saa1

                lcall   iic_init                        ;LED rodkowy
                mov     R4,#0
                mov     R5,#0
                mov     R6,#0
                mov     R7,#0
                lcall   saa2

                lcall   iic_init                        ;LED grny gdz:min
                mov     R4,#LED_0
                mov     R5,#LED_0
                mov     a,godzina
                lcall   konw_led
                mov     R6,B
                mov     R7,a                            ;Zapamietaj znak na ktrym moze byc kropka
                mov     a,licznik10_2                   ;Czy mino p sekundy?
                cjne    a,#5,*+3
                mov     a,#%00000000                    ; - nie to nie ma kropki
                jc      prt_data_czas_3
                mov     a,#%10000000                    ; - tak to jest kropka
prt_data_czas_3:orl     a,R7                            ;OR ewentualnej kropki i znaku
                mov     R7,a
                lcall   saa3

                lcall   iic_init                        ;LED grny sekundy
                mov     a,minuta
                lcall   konw_led
                mov     R4,B
                mov     R5,a
                lcall   saa4

                lcall   iic_init
exit_dataczas:  ret

error_saa0:     mov     a,#0
                ljmp    error_saa

saa1:           clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj odwoania do IIC
                lcall   iic_start
                jc      error_saa1
                mov     a,#SAA1_WRITE
                lcall   iic_write
                jc      error_saa1
                mov     a,#00                           ;nr rejestru do zapisu
                lcall   iic_write
                jc      error_saa1
                mov     a,bright_led                    ;jasnosc bierzemy z starszej polwki
                anl     a,#%01110000
                orl     a,#%00000111                    ;rejestr kontrolny
                lcall   iic_write
                jc      error_saa1
                ;--- wywietla rejestry na led wygaszajc zera nieznaczace ---
saa_data:       mov     B,#LED_0                        ;Do rejestru B kod znaku 0
                mov     a,R4                            ; badaj pierwsz cyfr
                cjne    a,B,saa_data_bw                 ;  <> "0" to skok
                mov     R4,#0                           ;  =  "0" wic wyga
                mov     a,R5                            ; badaj drug cyfr
                cjne    a,B,saa_data_bw                 ;  <> "0" to skok
                mov     R5,#0                           ;  =  "0" wic wyga
                mov     a,R6                            ; badaj trzeci cyfr
                cjne    a,B,saa_data_bw                 ;  <> "0" to skok
                mov     R6,#0                           ;  =  "0" wic wyga
                                                        ; czwartej niebadaj wywietlaj zawsze (nawet "0")
                ;--- wywietla rejestry na LED ---
saa_data_bw:    mov     a,R4                            ;1 cyfra
                lcall   iic_write
                jc      error_saa0
                mov     a,R5                            ;2 cyfra
                lcall   iic_write
                jc      error_saa0
                mov     a,R6                            ;3 cyfra
                lcall   iic_write
                jc      error_saa0
                mov     a,R7                            ;4 cyfra
                lcall   iic_write
                jc      error_saa0
                lcall   iic_stop
                setb    ET0                             ;Przywrcenie przerwa
                setb    EX0
                ret
error_saa1:     mov     a,#1
                ljmp    error_saa

saa2:           clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj odwoania do IIC
                lcall   iic_start
                jc      error_saa2
                mov     a,#SAA2_WRITE
                lcall   iic_write
                jc      error_saa2
                mov     a,#00                           ;nr rejestru do zapisu
                lcall   iic_write
                jc      error_saa2
                mov     a,bright_led                    ;jasnosc bierzemy z starszej polwki
                anl     a,#%01110000
                orl     a,#%00000111                    ;rejestr kontrolny
                lcall   iic_write
                jc      error_saa2
                ljmp    saa_data                        ;Wywietl dane z R4...R7
error_saa2:     mov     a,#3
                ljmp    error_saa

saa3:           clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj odwoania do IIC
                lcall   iic_start
                jc      error_saa3
                mov     a,#SAA3_WRITE
                lcall   iic_write
                jc      error_saa3
                mov     a,#00                           ;nr rejestru do zapisu
                lcall   iic_write
                jc      error_saa3
                mov     a,bright_led                    ;jasnosc bierzemy z starszej polwki
                anl     a,#%01110000
                orl     a,#%00000111                    ;rejestr kontrolny
                lcall   iic_write
                jc      error_saa3
                ljmp    saa_data                        ;Wywietl dane z R4...R7
error_saa3:     mov     a,#3
                ljmp    error_saa

saa4:           clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj odwoania do IIC
                lcall   iic_start
                jc      error_saa4
                mov     a,#SAA4_WRITE
                lcall   iic_write
                jc      error_saa4
                mov     a,#00                           ;nr rejestru do zapisu
                lcall   iic_write
                jc      error_saa4
                mov     a,bright_led                    ;rejestr kontrolny
                rl      a                               ;jasnosc bierzemy z mlodszej polwki
                rl      a
                rl      a
                rl      a
                anl     a,#%01110000
                orl     a,#%00000110
                lcall   iic_write
                jc      error_saa4
                ljmp    saa_data_bw                     ;Wywietl dane z R4...R7
error_saa4:     mov     a,#4
                ljmp    error_saa

error_saa:
 IF ERROR_SAA                           ;Czy obsugiwa bdy SAA czy olewa
                push    ACC                             ;Zapamitanie nr SAA
                mov     std_out,#STD_OUT_LCD
                lcall   print_err
                mov     dptr,#txt_error_saa             ;Wywietlenie napisu
                lcall   print_text
                pop     ACC                             ;odtwrz nr SAA
                lcall   print_nible                     ; i wywietl
                ljmp    wait_error       ;<--- zastpuje RET
 ELSE
                setb    ET0                             ;Przywrcenie przerwa
                setb    EX0
                ret
 ENDI
txt_error_saa:  STRING  'SAA '
                BYTE    0

;----------------- konwertuje liczbe z BCD na LED -------
;WE: Acc - liczba upakowane BCD
;WY: Acc - modszy bajt
;    B   - starszy bajt
;Zmienia: Acc, B
;
konw_led:       push    DPH
                push    DPL
                push    ACC                             ;zapamietaj liczbe na stosie
                rl      a                               ; wytnij starszy bajt
                rl      a
                rl      a
                rl      a
                anl     a,#$f
                mov     dptr,#tab_led
                movc    a,@a+dptr                       ;pobranie skonwertowanej liczby
                mov     B,a                             ; i zapamietanie w B
                pop     ACC                             ;odtworz liczbe ze stosu
                anl     a,#$f                           ; wytnij modszy bajt
                movc    a,@a+dptr                       ;pobranie skonwertowanej liczby
                pop     DPL                             ; do Acc i wyjcie
                pop     DPH
                ret

tab_led:        BYTE    LED_0,LED_1,LED_2,LED_3
                BYTE    LED_4,LED_5,LED_6,LED_7
                BYTE    LED_8,LED_9,LED_a,LED_b
                BYTE    LED_c,LED_d,LED_e,LED_f

;----------------- Ustawienie jasnosci LED
ustaw_jasled:   mov     dptr,#txt_jasled
                lcall   print_text
                lcall   curs_on
                mov     poz_wys,#14
                lcall   wait_bajt
                jb      F0,prog_jasled_exit
                anl     a,#%01110111            ;Dla pewnosci
                mov     bright_led,a
                lcall   write_konfig            ;Zapamitanie konfigu w eeprom
prog_jasled_exit:
                ljmp    print_crlf      ;<--- Zastpuje RET

txt_jasled:     BYTE    CLS_ASCII
                STRING  'Jasno LED ?'
                BYTE    0

 ENDI

;----------------------------------------------------------------------------
;Opis: Wywietla nazw dnia tygodnia na aktualnej pozycji wywietlacza
;we: ACC - nr dnia (1-poniedziaek)
;wy: --
;zmienia: ACC, B, DPTR, PSW
;
print_dzien_tygodnia:
                rl      a                       ;nr dnia mnomy przez 2
                anl     a,#%11111110            ; (nazwy dwuliterowe)
                mov     B,a
                mov     dptr,#tablica_dni       ;Adres tablicy tekstw
                movc    a,@a+dptr               ;Wczytujemy pierwszy znak
                lcall   print_char              ; i na wywietlacz
                inc     B                       ;Next znak
                mov     a,B                     ; wczyta
                movc    a,@a+dptr               ; i na wywietlacz
                ljmp    print_char      ;<--- zastpuje RET


tablica_dni:    STRING  'Ni'
                STRING  'Po'
                STRING  'Wt'
                STRING  'r'
                STRING  'Cz'
                STRING  'Pi'
                STRING  'So'

;----------------------------------------------------------------------------
;Opis  Wywietla nazw miesica na aktualnej pozycji wywietlacza
;we  ACC - nr miesica w BCD (1-stycze)
;wy  --
;zmienia  ACC, B, DPTR, PSW
;
print_miesiac   cjne    a,#$0f,*+3              ;korekta BCD-BIN
                jc      prt_miesiac_l1          ; jeli ACC>$09
                clr     C                       ; to korekta
                subb    a,#6
prt_miesiac_l1  dec     a                       ;zmieniamy zakres miesicy na 0-11
                rl      a                       ;nr miesica mnomy przez 4
                rl      a                       ; (nazwy czterobajtowe)
                anl     a,#%11111100
                mov     dptr,#tablica_miesicy  ; i dodajemy do wskanika tablicy
                add     a,DPL
                mov     DPL,a
                mov     a,DPH
                addc    a,#0
                mov     DPH,a
                clr     a                       ;Wczytujemy pierwszy znak
                movc    a,@a+dptr
                lcall   print_char              ; i na wywietlacz
                inc     dptr                    ;Next znak
                clr     a
                movc    a,@a+dptr
                lcall   print_char
                inc     dptr                    ;Next znak
                clr     a
                movc    a,@a+dptr
                ljmp    print_char      ;<--- zastpuje RET

tablica_miesicy
                STRING  'Sty '
                STRING  'Lut '
                STRING  'Mar '
                STRING  'Kwi '
                STRING  'Maj '
                STRING  'Cze '
                STRING  'Lip '
                STRING  'Sie '
                STRING  'Wrz '
                STRING  'Pa '
                STRING  'Lis '
                STRING  'Gru '

;============================================================================
;=                       Procedury taryfikacji                              =
;============================================================================
;Opis: Okrela taryf na podstawie cyfr zgromadzonym w buforze
;
;we: --
;wy: "nr_prefiksu" - numer kolejny prefiksu psujcego do wzorca
;    "taryfa"      - numer taryfy prefiksu psujcego do wzorca
;zmienia: PSW, ACC, DPTR, R0, R1, R6, R7
;
okresl_taryfe:  mov     R6,#0                           ;Pami maksymalnej liczby zgodnych cyfr
                mov     nr_prefiksu,#0                  ;prefiks nr 0 ("taryfa pusta")
                mov     dptr,#0                         ;Wskanik na pierwszy prefiks
okresl_tar4:    mov     R7,#0                           ;Liczba zgodnych cyfr
                mov     R0,#buf_cyf_str                 ;Adres bufora wybranych cyfr
                mov     R1,#pref_start                  ;Adres bufora prefiksw
okresl_tar1:    lcall   read_prefiks                    ;Wczytaj prefiks do RAM
                jc      okresl_tar_end                  ;Jeli koniec prefiksw
                                                        ;  to wyjd
        ;-------- Czy cyfry w buforach zgodne ? ----------
okresl_tar3:    mov     a,@R1                           ;Czy ostatnia cyfra prefiksu ?
                cjne    a,#CYFRA_EMPTY,okresl_tar21     ; - nie wic id dalej
                sjmp    okresl_tar_5                    ; - tak wic sprawd ile zgodnych
okresl_tar21:
                mov     a,@R0                           ;Czy @R0=@R1
                mov     B,a
                mov     a,@R1
                cjne    a,B,okresl_tar_next             ;Jeli koniec zgodnoci
                                                        ; sprawd nastpny prefiks
                inc     R7                              ;kolejna cyfra zgodna
                inc     R0                              ;Next bajt bufora cyfr
                inc     R1                              ;Next bajt bufora prefiksw
                cjne    R1,#pref_end+1,okresl_tar3      ;Jeli koniec bufora prefiksw
                                                        ; sprawd ile zgodnych
okresl_tar_5:   cjne    R7,#0,okresl_tar_6              ;Jeli rozpoznano 0 cyfr
                sjmp    okresl_tar_next                 ; sprawd nastpny prefiks
okresl_tar_6:                                           ;Czy liczba zgodnych cyfr
                mov     a,R6                            ; wiksza od dotychczas
                cjne    a,RR7,*+3                       ; zapamiranej ?
                jnc     okresl_tar_next                 ; - nie wic kolejny prefiks
                mov     R6,RR7                          ;Najlepszy wynik w R6
                mov     nr_prefiksu,DPL                 ;Nr prefiksu w "nr_prefiksu"
okresl_tar_malo:
okresl_tar_next:inc     dptr                            ;Wskanik na kolejny prefiks
                sjmp    okresl_tar4

okresl_tar_end: mov     DPL,nr_prefiksu                 ;Okreli nr taryfy
                mov     DPH,#0                          ; odnalezionego prefiksu
                lcall   read_prefiks                    ; i zapisz do zmiennej "taryfa"
                mov     taryfa,pref_taryfa
                ret

;----------------------------------------------------------------------------
;Opis: Czyta prefiks z pamici EEPROM do bufora w RAM
;we: DPTR - nr kolejny prefiksu do odczytania
;wy: C    - rezultat (jeli C=1 to koniec tablicy prefiksw)
;zmienia: PSW
;
read_prefiks:   push    ACC                     ;Zapamitaj rejestry na stosie
                push    B
                mov     B,R0                    ;R0 za porednictwem B
                push    B
                push    DPL
                push    DPH
                mov     R2,DPL
                mov     DPH,#0
                lcall   wylicz_adres_prefiksu

                mov     R0,#pref_taryfa         ;Adres bufora prefiksw
                lcall   read_eeprom             ;wczytaj prefiks do ACC
                cjne    a,#END_PREFIKS,read_pref_2 ;Jeli ostatni prefiks
                setb    C                          ; to wyjd z ustawionym C
                sjmp    read_prefiks_quit
read_pref_2:    mov     @R0,a                   ;Zapamitaj taryf w buforze
                inc     R0
                inc     dptr

read_pref_1:    lcall   read_eeprom             ;Wczytaj cyfry prefiksu do ACC
                push    ACC                     ;Przeswamy starszy do modszego
                rr      a
                rr      a
                rr      a
                rr      a
                anl     a,#$0f
                mov     @R0,a                   ;Zapamitaj bajt w buforze
                inc     R0
                pop     ACC
                cjne    R0,#pref_end+1,read_pref_3  ;Jeli zapisano cay bufor
                sjmp    read_prefiks_end            ; to wyjd z zerowanym C
read_pref_3:    anl     a,#$0f
                mov     @R0,a
                inc     R0
                inc     dptr
                cjne    R0,#pref_end+1,read_pref_1 ;Jeli zapisano cay bufor
read_prefiks_end:
                clr     C                          ; to wyjd z zerowanym C
read_prefiks_quit:
                pop     DPH                     ;Rejestry ze stosu
                pop     DPL
                pop     B                       ;R0 odtwarzamy za porednictwem B
                mov     R0,B
                pop     B
                pop     ACC
                ret

;----------------------------------------------------------------------------
;Opis: Zwraca w DPTR adres pierwszego bajtu nazwy prefiksu
;we: DPTR - nr kolejny prefiksu do odczytania
;wy: DPTR - adres w EEPROM tekstu opisujcego prefiks
;zmienia: PSW, DPTR
;
read_nazwa_prefiksu:
                push    ACC
                mov     R2,DPL
                lcall   wylicz_adres_prefiksu   ;Ustawia na pocztek struktury prefiksu
                inc     dptr                    ;Pominicie prefiksu i taryfy
                inc     dptr
                inc     dptr
                inc     dptr
                inc     dptr
                inc     dptr
                inc     dptr
                pop     ACC
                ret

;----------------------------------------------------------------------------
;Opis: Na podstawie nr kolejnego prefiksu w DPTR oblicza adres w pamici
;      EEPROM pierwszego bajtu wskazujcego na tablic prefiksu
;we: R2   - nr kolejny prefiksu
;wy: DPTR - adres w EEPROM
;zmienia: PSW, ACC, DPTR
;
wylicz_adres_prefiksu:
                mov     a,R2                   ;Mnoymy przez 2
                rlc     a
                mov     DPL,a
                mov     a,#0
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 4)
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 8)
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 16)
                rlc     a
                anl     a,#%11110000
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a

                push    ACC
                mov     a,DPL                   ;Dodanie przesunicia
                add     a,#LOW prefiksy
                mov     DPL,a
                mov     a,DPH
                addc    a,#HIGH prefiksy
                mov     DPH,a
                pop     ACC

                ret

;============================================================================
;Opis: Czeka na podniesienie suchawki
;we: --
;wy: C  - C=0  - odoona
;         C=1  - podniesiona
;    F0 - F0=1 - dzwonienie
;       - F0=0 - brak dzwonienia
;zmienia: PSW, Acc, R5, R6, R7
;
zgloszenie:     lcall   reset_watchdog
                mov     R7,#10                  ;Czas przez jaki musi trwa impuls dzwonka
zgl_3:          jb      DZW,zgl_czy             ;Sprawdzaj Pin4 (istotne dla V2) - skok gdy brak
                lcall   wait_10ms               ; wykryto impuls dzwonienia, wic poczekaj
                djnz    R7,zgl_3                ; odliczanie czasu
                sjmp    zgl_dzwonek             ; nadal aktywny to oznacza dzwonek
zgl_czy:        jnb     OPT1,zgl_1              ;Jeli prd pynie w ktrymkolwiek
                jnb     OPT2,zgl_1              ;  kierunku id dalej
zgl_nie:        clr     C                       ;Jeli nic si nie dzieje
                clr     F0                      ; wyjd z zerowanym C i F0
                ret

zgl_1:          mov     R7,#70                  ;Czas prby (*1ms)
                mov     R6,#0                   ;Zerowanie licznika stanw H
                mov     R5,#0                   ;Zerowanie licznika stanw L
zgl_2:          lcall   wait_1ms
                jnb     OPT1,zgl_l
                jnb     OPT2,zgl_l
                inc     R6                      ;Zwiksz licznik stanw H
                sjmp    zgl_next

zgl_l:          inc     R5                      ;Zwiksz licznik stanw L
zgl_next:       djnz    R7,zgl_2                ;Czy koniec czasu pomiaru ?

   ;    lcall   cls      ;???
   ;    mov     a,R6
   ;    lcall   print_hex
   ;    mov     a,R5
   ;    lcall   print_hex
   ;    mov     a,#10
   ;    lcall   delay_100ms

                mov     a,R5                    ;Sprawdzenie czy podniesiona
                cjne    a,#$45,*+3
                jc      zgl_czy_dzw
zgl_tak:        setb    C                       ;Wykryto podniesienie suchawki
                clr     F0                      ; ustaw C , zeruj F0 i wyjd
                ret

zgl_czy_dzw:    jb      FL_HARDWARE,zgl_nie     ;Dla V2 nie sprawdzaj programowo dzwonka
  sjmp zgl_nie ;????                                              ; poniewa wczeniej sprawdzono sprztowo
                mov     a,R6                    ;Dla V1 sprawdzaj programowo
                cjne    a,#$02,*+3              ;($01/2 bo moe by 25Hz!)
                jc      zgl_nie
zgl_dzwonek:    clr     C                       ;Jest dzwonek, ustaw F0
                setb    F0                      ; zeruj C i wyjd
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia w buforze "puste" cyfry
;we: --
;wy: --
;zmienia: PSW, ACC, R0
;
init_bufor_cyf: mov     R0,#buf_cyf_str         ;W R0 pocztek bufora wybranych cyfr
                mov     a,#CYFRA_EMPTY
init_buf_cyf_1: mov     @R0,a
                inc     R0
                cjne    R0,#buf_cyf_end+1,init_buf_cyf_1
                ret

;----------------------------------------------------------------------------
;Opis: Czeka na przerw w przepywie prdu (wybieranie cyfry/odoenie suchawki)
;      lub kod DTMF.
;       jeli >255ms traktuje jako rozczenie (wychodzi z ustawionym C)
;       jeli >50<70 traktuje jako impuls
;we: --
;wy: C - C=1 odoono suchawk
;        C=0 wybrano cyfr
;    ACC - wybrana cyfra (jeli ustawiony C i ACC=ROZMOWA to wykryto kryterium rozmowy)
;zmienia: PSW, ACC
;
licz:           push    B                       ;Zapamitaj B na stosie
                mov     B,R7                    ;Zapamitaj R7 za porednictwem B
                push    B
                mov     R7,#1                   ;Inicjalizuj licznik impulsw

pod_3:          lcall   reset_watchdog
                lcall   czy_rozmowa             ;Czy kryterium rozmowy
                jnc     pod_2                   ; - nie, czekaj dalej
                mov     a,#ROZMOWA              ; - tak, sygnalizuj rozmow (ACC=ROZMOWA)
                sjmp    pod_cyfra

pod_2:          jnb     FL_DTMF,pod_impuls      ;Jeli nie DTMF obsuguj impulsowe
                lcall   czytaj_z_dtmf
                lcall   zeruj_czas_rozmowy      ; potrzebne przy kryterium rozmowy po czasie
                sjmp    pod_cyfra               ; i wyjd z zerowanym C

pod_impuls:     jnb     OPT1,pod_3              ;Jeli prd pynie czekaj dalej?
                jnb     OPT2,pod_3
                lcall   wait_10ms               ;Nie pynie - czekaj (olewanie odbi styku)
                jnb     OPT1,pod_3              ;Jeli prd pynie czekaj dalej?
                jnb     OPT2,pod_3
                                                ;Prd nie pynie
                mov     a,#0                    ; licz jak dugo prd nie pynie
pod_4:          lcall   wait_1ms
                inc     a
                cjne    a,#0,pod_5              ;Jeli ponad 255ms (odoenie suchawki)
                setb    C                       ; wyjd z ustawionym C
                sjmp    pod_exit

pod_5:          jnb     OPT1,pod_6              ;Jeli prd pynie
                jnb     OPT2,pod_6              ; kocz liczenie
                sjmp    pod_4                   ; a jei nie to licz czas

pod_6:          lcall   wait_10ms               ;Czekaj (olewanie odbi styku)
                mov     a,#0                    ;Licz jak dugo prd pynie
pod_8:          lcall   wait_1ms
                inc     a
                cjne    a,#0,pod_7              ;Jeli ponad 255ms (przerwa midzy cyframi)
                mov     a,R7                    ; w ACC liczba impulsw
                lcall   zeruj_czas_rozmowy      ; potrzebne przy kryterium rozmowy po czasie
pod_cyfra:      cjne    a,#$0a,pod_9            ;Jeli 10 impulsw
                mov     a,#0                    ; wpisz "zero"
pod_9:          clr     C                       ; wyjd z zerowanym C (Wybrano cyfr)
                sjmp    pod_exit

pod_7:          jnb     OPT1,pod_8              ;Jeli prd pynie czekaj dalej?
                jnb     OPT2,pod_8
                                                ;Nie pynie, wic
                inc     R7                      ;Zwiksz cyfr
                sjmp    pod_3                   ; i licz czas przerwy

pod_exit:       pop     B                       ;R7 ze stosu (za porednictwem B)
                mov     R7,B
                pop     B                       ;B ze stosu
                ret

;----------------------------------------------------------------------------
;Odczytuje dan z ukladu DTMF
;wy: ACC - odczytana liczba
;
czytaj_z_dtmf:  mov     a,P3                    ;Pobierz dan DTMF do ACC
                                ;Na starszych bitach kod DTMF
                                ; P3.4 bit 3
                                ; P3.5 bit 2
                                ; P3.6 bit 1
                                ; P3.7 bit 0
                mov     B,#0                    ;Zeruj cel
                jnb     ACC.7,*+5               ;Jeli ustawiony ACC 7
                setb    B.0                     ; ustaw B.0
                jnb     ACC.6,*+5               ;Jeli ustawiony ACC 6
                setb    B.1                     ; ustaw B.1
                jnb     ACC.5,*+5               ;Jeli ustawiony ACC 5
                setb    B.2                     ; ustaw B.2
                jnb     ACC.4,*+5               ;Jeli ustawiony ACC 4
                setb    B.3                     ; ustaw B.3
                mov     a,B                     ;Wynik do ACC
                cjne    a,#$0a,*+5              ;Jeli 10 impulsw
                mov     a,#0                    ; wpisz "zero"
                clr     FL_DTMF                 ;Zeruj flag DTMF
                ret

;----------------------------------------------------------------------------
;Opis: Zapamituje polaryzacj cza w komrce "polaryzacja"
;we: --
;wy: "polaryzacja"
;zmienia: PSW, "polaryzacja"
;
pamietaj_polaryzacje:
                mov     a,P1                    ;Port gdzie podczono OPT do ACC
                anl     a,#%00000011            ;Wydziel tylko bity OPT
                mov     polaryzacja_lacza,a     ; i zapamitaj w zmiennej
                ret

;----------------------------------------------------------------------------
;Opis: Sprawdza aktualn polaryzacj
;      jeli taka sama jak zapamitana to C=0
;      jeli rna od zapamitanej to C=1
;we: --
;wy: C - stan polaryzacji (C=0 taka jak zapamitana, C=1 zmieniona)
;Zmiania: PSW
;
sprawdz_polaryzacje:
                mov     a,P1                    ;Port gdzie podczono OPT do ACC
                anl     a,#%00000011            ;Wydziel tylko bity OPT
                xrl     a,#%00000011            ; i zaneguj
                                                ;Dziki negacji skok nie nastpi
                                                ; tylko wtedy gdy obydwa transoptory
                                                ; zmieniy stan
                cjne    a,polaryzacja_lacza,spr_pol_takasama
spr_pol_rozna:  setb    C                       ;Zmiana polaryzacji wic C=1
                ret

spr_pol_takasama:
                clr     C                       ;Polaryzacja bez zmian wic C=0
                ret

;----------------------------------------------------------------------------
;Opis: Wykrywa kryterium rozmowy. Zalenie od stanu komrki "kryterium_rozmowy"
;      sygnalizuje rozmow znacznikiem C=1 gdy:
;       - pojawi si impuls 16kHz
;       - wykryto zmian polaryzacji
;       - min ustawiony czas od wybrania ostatniej cyfry
;       - zanik tomu 400Hz
;we: --
;wy: C - C=0 nie ma rozmowy
;        C=1 rozmowa
;zmienia: PSW
;
czy_rozmowa:    mov     a,kryterium_rozmowy             ;Wczyctaj do ACC kryterium rozmowy
                cjne    a,#POLARYZACJA,czy_roz_l1       ;jeli kryterium
                lcall   sprawdz_polaryzacje             ; sprawd czy zmiana polaryzacji
                jc      czy_roz_tak                     ; bya zmiana wic skocz to TAK
                clr     C                               ;
                ret

czy_roz_l1:     cjne    a,#IMPULS_16KHZ,czy_roz_l3      ;jeli kryterium
                jb      FL_16KHZ,czy_roz_tak            ;Sprawd czy impuls 16 KHZ
                clr     FL_16KHZ                        ;Zeruj znacznik 16kHz
                clr     C
                ret

czy_roz_l3:
 IF SAA1064=NO   ;--- dla SAA1064 nie ma kryterium "zanik tomu 400Hz ---
                cjne    a,#TON_400HZ,czy_roz_l4         ;jeli kryterium
                mov     a,pam_400hz_h                   ;Sprawd czy poprzedni ton
                cjne    a,#08,*+3                       ;   trwa conajmniej 800ms
                jc      czy_roz_l31                     ; - nie wic wyjd
                cjne    a,#12,*+3                       ; - tak wic czy nie by duszy 1200ms
                jnc     czy_roz_l31                     ; - by wic wyjd
                mov     a,licznik_400hz_l               ;Spawd czy zanik tonu duszy ni 5 sek
                cjne    a,#50,*+3                       ;czas 5 sekund
                jnc     czy_roz_tak                     ; - tak wic kryterium rozmowy
czy_roz_l31     clr     C
                ret
 ENDI
czy_roz_l4:     jnb     PROGRAM,czy_roz_tak             ;jeli inne kryterium sprawdzaj przycisk
                cjne    a,czas_rozmowy_sek,*+3          ; i czas
                jc      czy_roz_tak
                clr     C
                ret

czy_roz_tak:    setb    C
                ret

;----------------------------------------------------------------------------
;Opis: Czyci wskanik 16KHz, aby nie byo podwjnego impulsu
;      po rozpoczciu rozmowy. Funkcja wywoywana zaraz po rozpoznaniu
;      kryterium rozmowy
;
clr_flagi_zaliczania:
                clr     FL_16KHZ                        ;Zeruje znacznik odbioru 16kHz
                ret

;============================================================================
;Wywietla tekst powitania
;Wejcie: --
;Wyjcie: --
;Zmienia: --
;
print_powitanie:
                mov     dptr,#powitanie_tx1
                lcall   print_text
                mov     a,#25
                lcall   delay_100ms
                lcall   suma_ttaryf             ;Sprawdzenie sumy kontrolnej tablicy
 IF SAA1064=NO ;--- dla SAA1064 inne powitanie ---
                mov     dptr,#powitanie_tx2
                lcall   print_text
                mov     a,#"1"                  ;Wywietltnie wersji hardware
                jnb     FL_HARDWARE,prn_pow_l1
                mov     a,#"2"
prn_pow_l1:     lcall   print_char
                mov     dptr,#powitanie_tx21    ;Ilo zajtej Flash: $1FFF -  8kB
                lcall   print_text              ;                     $2FFF - 12kB
                mov     dptr,#end_program       ;                     $3FFF - 16kB
                lcall   print_dptr              ;                     $4FFF - 20kB
                mov     dptr,#rewizja_txt       ;Nr rewizji ROM'u
                lcall   print_text
 ENDI
                lcall   suma_tprefiks           ;Sprawdzenie sumy kontrolnej tablicy
 IF SAA1064=NO
                mov     a,#25
                lcall   delay_100ms     ;<--- zastpuje RET
 ENDI
                ret

                ;        1234567890123456
powitanie_tx1:
 IF SAA1064
                BYTE    CLS_ASCII
                STRING  'Dzie dobry'
                BYTE    LF_ASCII
                STRING  'Rejestrator tel'
                BYTE    0
 ELSE
                BYTE    CLS_ASCII
                STRING  'Rejestrator 2.33'
                BYTE    LF_ASCII
                STRING  '(C)2009 By R-MIK'
                BYTE    0
 ENDI

powitanie_tx2:  BYTE    CLS_ASCII
                STRING  'Hardware: V'
                BYTE    0

powitanie_tx21: BYTE    LF_ASCII
                STRING  'Rom '
                BYTE    0

rewizja_txt:    STRING  ' Rev.0938'              ;Nr rewizji ROM
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Wywietla dptr w postaci liczby HEX
; zera nieznaczce s pomijane (wygaszone w ich miejsce spacja)
;we: B     - liczba pozycji (cyfr) do wywietlenia
;            jeli najstarszy B=1 to dosunicie do lewej
;
print_dptr_NZ:  push    B
                lcall   zeruj_resld             ;Przygotowanie bufora
                mov     a,DPH                   ;Rozpakowanie starszego bajtu
                lcall   depack_bcd
                mov     resld+3,B               ; i do bufora
                mov     resld+2,a
                mov     a,DPL                   ;Rozpakowanie modszego bajtu
                lcall   depack_bcd
                mov     resld+1,B               ; i do bufora
                mov     resld+0,a
                pop     B
                sjmp    print_resld_NZ

;----------------------------------------------------------------------------
;Opis: Wywietla dptr w postaci liczby BCD
; zera nieznaczce s pomijane (wygaszone w ich miejsce spacja)
;we: B     - liczba pozycji (cyfr) do wywietlenia
;            jeli najstarszy B=1 to dosunicie do lewej
;
print_dptr_bcd_NZ:
                push    B                       ;Zapamitanie liczby pozycji do wywietlenia
                mov     resl,DPL                ;Wpisanie liczby do bufora
                mov     resl+1,DPH
                mov     resl+2,#0
                mov     resl+3,#0
                lcall   hexbcd                  ;konwersja
                pop     B                       ;Odtworzenie liczby pozycji do wywietlenia
                sjmp    print_resld_NZ

;----------------------------------------------------------------------------
;Opis: Wywietla resld w z nieupakowane BCD
;      zera nieznaczce s pomijane (wygaszone w ich miejsce spacja)
;we: B     - liczba pozycji (cyfr) do wywietlenia
;            jeli bit B.7=1 to dosunicie do lewej
;
print_resld_NZ: clr     F1                      ;Dosunicie do prawej czy lewej?
                jnb     B.7,druk_dptr0
                setb    F1
druk_dptr0:     mov     a,B                     ;Obcicie nsjstarszego
                anl     a,#%0111111
                mov     B,a
                mov     a,#resld-1              ;Adres bufora cyfr
                add     a,B                     ;Obliczenie koca bufora
                mov     R0,a
                setb    F0                      ;Znacznik wygaszenia zera (F0=1 - wyga)
druk_dptr1:     mov     a,@R0
                jnb     F0,druk_dptr3           ;Znacznik skasowany czyli nie wygaszaj
                jz      druk_dptr4              ;Cyfra rwna zero wic skocz
                clr     F0                      ;Cyfra rna od zera, wic ustaw niewygaszaj
                sjmp    druk_dptr3              ; i wydrukuj cyfr
druk_dptr4:     mov     a,B                     ;Sprawd czy moe trzeci od koca znak
                cjne    a,#1,druk_dptr6         ; nie wic drukuj spacj
                clr     F0                      ; trzeci od koca wic ustaw niewygaszaj
                mov     a,#"0"                  ; wywietl zero
                sjmp    druk_dptr3              ; i skacz dalej
druk_dptr6:     jb      F1,druk_dptr2           ;jeli dosunicie do lewej nie wywietlaj spacji
                lcall   print_spc               ;Drukuj spacj
                sjmp    druk_dptr2              ; i skacz dalej
druk_dptr3:     lcall   print_nible
druk_dptr2:     dec     R0
                djnz    B,druk_dptr1
                ret

;----------------------------------------------------------------------------
;Opis: Okrela wielko bufora (krok 8kB)
;      Sprawdza od koca czy ukady zgaszaj si
;      zaczynamy od adresu %10101110 koczymy na $1010000
;Wielkoci:
;       %10101110       - $FFF0 64kB
;       %10101100       - $DFF0 56kB
;       %10101010       - $BFF0 48kB
;       %10101000       - $9FF0 40kB
;       %10100110       - $7FF0 32kB
;       %10100100       - $5F00 24kB
;       %10100010       - $3FF0 16kB
;       %10100000       - $1FF0  8kB
;
max_bufor:      mov     dptr,#max_buf_tab_adr
                mov     R0,#0
max_buf_next:   lcall   iic_start               ;Sprawdzenie ukadu
                clr     a
                movc    a,@a+dptr
                lcall   iic_write
                jc      max_buf_nie             ;nieodpowiedzia wic sprawdzamy inne
                lcall   iic_stop                ;odpowiedzia wic ustawienie adresw
                mov     dptr,#max_buf_tab_poj   ; i wyjcie
                mov     a,R0
                movc    a,@a+dptr
                mov     end_bufor_h,a
                mov     end_bufor_l,#$F0
;      mov     end_bufor_h,#HIGH bufor+(20*16)   ;??? Do testowania bufora koowego
;      mov     end_bufor_l,#LOW  bufor+(20*16)   ;?    min warto #20
        ;-------- Obliczmy max liczb rekordw ------
                clr     C                       ; obliczamy liczb bajtw *256
                mov     a,end_bufor_l           ; wynik do dptr
                subb    a,#LOW bufor
                mov     DPL,a
                mov     a,end_bufor_h
                subb    a,#HIGH bufor
                mov     DPH,a
                mov     B,#4                    ; dzielimy przez 16
prn_pow_l2:     clr     C
                mov     a,DPH
                rrc     a
                mov     DPH,a
                mov     a,DPL
                rrc     a
                mov     DPL,a
                djnz    B,prn_pow_l2
                mov     max_rekord_l,DPL        ;Wynik w zmiennych
                mov     max_rekord_h,DPH
                ret

max_buf_nie:    lcall   iic_stop                ;Nie znaleziono rzadnej pamici
                inc     dptr
                inc     R0
                mov     a,R0
                cjne    a,#8,max_buf_next
                ljmp    error_eeprom

max_buf_tab_adr:BYTE    EEPROM_READ+%1110
                BYTE    EEPROM_READ+%1100
                BYTE    EEPROM_READ+%1010
                BYTE    EEPROM_READ+%1000
                BYTE    EEPROM_READ+%0110
                BYTE    EEPROM_READ+%0100
                BYTE    EEPROM_READ+%0010
                BYTE    EEPROM_READ+%0000
max_buf_tab_poj:BYTE    $FF
                BYTE    $DF
                BYTE    $BF
                BYTE    $9F
                BYTE    $7F
                BYTE    $5F
                BYTE    $3F
                BYTE    $1F

;============================================================================
;=       Procedury obsugi TIMERW i zwizanych z nimi przerwaniami         =
;============================================================================
init_timer:	anl     TMOD,#%11110000         ;Timera 1 nie ruszamy
                orl     TMOD,#%00000001         ;Tryb 1 Timera 0
       		mov	TH0,#SPEED_0h		;zaadowanie timerw
		mov	TL0,#SPEED_0l
                mov     licznik10_1,#2          ;init dzielnika wstpnego
                mov     licznik10_2,#2          ;init dzielnika wstpnego
		setb    TR0			;start timera
		setb    ET0                     ;Zezwolenie na przerwania
                ret

;----------------------------------------------------------------------------
init_interput:	setb    EA			;Zezwolenie na przerwania
                ret

;----------------------------------------------------------------------------
; W przerwaniu mona zaj IIC poniewa jest wolna
; (na czas zajcia IIC przez program gwny wyczane s przerwania T0)
;
irq_timer:	push    PSW
		mov	TH0,#SPEED_0h	        ;zaadowanie timerw
		mov	TL0,#SPEED_0l
                setb    FL_IDLE10MS             ;Znacznik ze bylo przerwanie od timera
                push    ACC
                push    B
                push    RR0
                push    RR1
                push    RR2
                push    RR3
                push    RR4
                push    RR5
                push    RR6
                push    RR7
                push    DPH
                push    DPL


   ;     cpl STB_PRT ;????

        ;-------- Ponisze rozkazy wykonywane s 100 razy na sekund ----
                inc     dcf_h
                mov     a,dcf_h                 ;dcf_l zmieniamy 50 razy na sekund
                jb      ACC.0,*+5
                inc     dcf_l

        ;-------- Dzielnik wstpny przez 10 ------------------
                djnz    licznik10_1,irq_czas_1  ;Dzielnik wstpny
                mov     licznik10_1,#10
        ;-------- Ponisze rozkazy wykonywane s 10 razy na sekund ----
                lcall   licz_400hz              ;Obsuguje liczniki tonu 400hz

        ;-------- Dzielnik wstpny przez 10 (razem z wyszym przez 100) ----
                djnz    licznik10_2,irq_czas_1  ;Dzielnik wstpny
                mov     licznik10_2,#10
        ;-------- Ponisze rozkazy wykonywane s co sekund ----
                mov     a,overtime              ;Zmiejszenie overtime co 1 sek do 0
                jz      *+4
                dec     overtime

                mov     a,licz_nad_prt          ;Zmiejsza czas co 1 sek
                jz      *+4
                dec     licz_nad_prt

        ;-------- Obsuga licznika czasu trwania rozmowy -------
                mov     a,czas_rozmowy_sek      ;Licznik czasu rozmowy sekundy w BCD
                add     a,#1                    ;dodaj 1 sekund
                da      a                       ;korekcja dziesitna
                mov     czas_rozmowy_sek,a
                cjne    a,#$60,irq_czas_1       ;czy 60 sekund ?
                mov     czas_rozmowy_sek,#0     ; - tak, wic sekundy =00
                mov     a,czas_rozmowy_min      ;zwiksz minuty
                add     a,#1
                da      a
                mov     czas_rozmowy_min,a
                cjne    a,#$60,irq_czas_1       ;czy 60 minut ?
                mov     czas_rozmowy_min,#0     ; - tak, wic minuty =00
                mov     a,czas_rozmowy_godz     ;zwiksz godziny
                add     a,#1
                da      a
                mov     czas_rozmowy_godz,a
irq_czas_1:     nop
                lcall   obsluga_licznika
                lcall   sprawdz_stos            ;Kontrola przepenienia stosu

irq_exit        pop     DPL
                pop     DPH
                pop     RR7
                pop     RR6
                pop     RR5
                pop     RR4
                pop     RR3
                pop     RR2
                pop     RR1
                pop     RR0
                pop     B
                pop     ACC
                pop     PSW
                reti

;----------------------------------------------------------------------------
;Opis: Na podstawie stanu wyprowadzenia portu PIO oblicza czas trwania i czas
;      zaniku tonu 400hz. Wynik jest pamitany w "pam_400hz_l" i "pam_400hz_h"
;
licz_400hz:     mov     a,buf_pio                       ;Odtworzenie stanu PIO
                jnb     ACC+INT_400HZ,irq_ton_h          ;Jaki stan linii 400HZ ?
                mov     a,licznik_400hz_l               ;Zwiksza czas licznika braku tonu 400hz
                jz      *+4
                inc     licznik_400hz_l
                mov     a,licznik_400hz_h               ;Jei licznik H=$01
                cjne    a,#1,*+5                        ;to skacze do wyjcia
                sjmp    irq_ton_end                     ;jeli rny od 1
                mov     pam_400hz_h,licznik_400hz_h     ;to zapamituje stan licznika w pamici
                mov     licznik_400hz_h,#1              ;i przygotowyje do next pomiaru
                sjmp    irq_ton_end
irq_ton_h:      mov     a,licznik_400hz_h               ;Zwiksza czas licznika tonu 400hz
                jz      *+4
                inc     licznik_400hz_h
                mov     a,licznik_400hz_l               ;Jei licznik L=$01
                cjne    a,#1,*+5                        ;to skacze do wyjcia
                sjmp    irq_ton_end                     ;jeli rny od 1
                mov     pam_400hz_l,licznik_400hz_l     ;to zapamituje stan licznika w pamici
                mov     licznik_400hz_l,#1              ;i przygotowyje do next pomiaru
                sjmp    irq_ton_end
irq_ton_end:    ret

;----------------------------------------------------------------------------
;Opis: Sprawdza komrk kontroln i informuje o przepenienu stosu
;we:
;wy:
;zmienia: PSW, ACC
;
sprawdz_stos:   push    RR0
                mov     R0,#dno_stosu           ;Sprawdza komrk kontroln stosu
                mov     a,@R0
                cjne    a,#KONT_STOS,stos_err_h
                pop     RR0
                ret
stos_err_h:     mov     std_out,#STD_OUT_LCD
                lcall   print_err
                mov     dptr,#txt_err_stos_h
                lcall   print_text
                ljmp    wait_error       ;<---- Zastpuje RET

txt_err_stos_h: STRING  'Stos'
                BYTE    0

;----------------------------------------------------------------------------
;Obsuga przerwania INT1
; Jeli przerwanie od PIO mona zaj IIC poniewa jest wolna
; (na czas zajcia IIC przez program gwny wyczane s przerwania T0 i EX0)
;
irq_pio:        push    DPL
                push    DPH                     ;Przerwanie od PIO
                push    RR7
                push    RR6
                push    RR5
                push    RR4
                push    RR3
                push    RR2
                push    RR1
                push    RR0
                push    B
                push    ACC
                push    PSW

                jb      FL_HARDWARE,irq_pio_l1  ;Jeli hardware V1
                setb    FL_16KHZ                ; to obsu przerwanie z FX631 (Ustaw znacznik)
                sjmp    irq_pio_exit            ; i wyjd

irq_pio_l1:     lcall   iic_start               ;Jeli hardware V2 odczyt danej z PIO
                mov     a,#PIO_WRITE
                lcall   iic_write
                lcall   iic_start
                mov     a,#PIO_READ
                lcall   iic_write
                lcall   iic_read_np             ;Odczyt bajtu
                push    buf_pio                 ; zapamitaj stan portu (poprzedni) na stosie
                mov     buf_pio,a               ; zapamitanie stanu portu w buforze
                pop     buf_pioD                ; zapamitaj poprzedni stan portu w zmiennej
                lcall   iic_stop

                mov     a,buf_pio               ;Czy Przerwanie od watchdoga?
                jb      ACC+INT_WATCHDOG,irq_watchdog_exit
                sjmp    watchdog_error
irq_watchdog_exit:
      ;???          lcall   dcf
                lcall   czy_16khz
                lcall   czy_clip

irq_pio_exit:   pop     PSW
                pop     ACC
                pop     B
                pop     RR0
                pop     RR1
                pop     RR2
                pop     RR3
                pop     RR4
                pop     RR5
                pop     RR6
                pop     RR7
                pop     DPH
                pop     DPL
                reti

;----------------------------------------------------------------------------
watchdog_error: mov     std_out,#STD_OUT_SER    ;Drukowanie rejestrw na RS
                setb    EA                      ;Zezwl na przerwania
                setb    ES                      ; tylko z RS ???
                setb    PS                      ; RS najwyszy priorytet

                setb    FL_TXEMPTY              ;Ustaw znacznik "bufor odbiorczy pusty"
                clr     TI                      ;Kasuj przerwania

                lcall   print_crlf              ;Godzina
                lcall   print_crlf
                lcall   print_data_czas
                mov     dptr,#txt_watchdog
                lcall   print_text
        ;------------ Wywietlenie rejestrow ze stosu -------
                pop     Acc                     ;PSW
                lcall   print_hex
                lcall   print_spc
                pop     Acc                     ;Acc
                lcall   print_hex
                lcall   print_spc
                pop     Acc                     ;B
                lcall   print_hex
                lcall   print_spc
                mov     B,#8
irq_watchdog_1: pop     Acc                     ;R0-R7
                lcall   print_hex
                lcall   print_spc
                lcall   reset_watchdog
                djnz    B,irq_watchdog_1
                pop     Acc                     ;DPTR
                lcall   print_hex
                pop     Acc
                lcall   print_hex
                lcall   print_spc
                pop     Acc                     ;PC
                lcall   print_hex
                pop     Acc
                lcall   print_hex
                lcall   print_spc
                pop     Acc                     ;PC2 (wywoujcy podprogram)
                lcall   print_hex
                pop     Acc
                lcall   print_hex
                lcall   print_spc
                pop     Acc                     ;PC3 (next wywoujcy podprogram)
                lcall   print_hex
                pop     Acc
                lcall   print_hex
                ljmp    wait_error              ;Restart

                        ;1234567890123456789012345678901234567890
                        ;xx xx xx xx xx xx xx xx xx xx xx xxxx xxxx xxxx xxxx
txt_watchdog:   BYTE    CR_ASCII,LF_ASCII
                STRING  'PS A  B  R0 R1 R2 R3 R4 R5 R6 R7 dptr PC   PC2  PC3'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Na podstawie poprzedniego stanu linii oraz akutalnego okrela
;      czy nastpia zmiana sygnau i z jakiego poziomu na jaki
;      Jei zmiana w H na L (zbocze opadajce) ustawia flag
;
czy_16khz:      mov     a,buf_pio                       ;Aktualny stan XORujemy z poprzednim
                xrl     a,buf_pioD                      ; w wyniku na zmienionych pozycjach jest "1"
                anl     a,#AND_16KHZ                    ;Czy zmiana dotyczy pinu 16KHZ ?
                cjne    a,#AND_16KHZ,czy_16khz_nie      ; - nie to skacz
                                                        ; - tak analizuj jakie zbocze
                mov     a,buf_pioD                      ;Jedynka bedzie gdy opadajce zbocze
                anl     a,#AND_16KHZ                    ;Czy opadajace
                cjne    a,#AND_16KHZ,czy_16khz_nie      ; - nie to skacz
                setb    FL_16KHZ                        ; - tak wic ustaw flag
czy_16khz_nie:  ret

;----------------------------------------------------------------------------
;Opis: Na podstawie poprzedniego stanu linii oraz akutalnego okrela
;      czy nastpia zmiana sygnau i z jakiego poziomu na jaki
;      Jei zmiana w H na L (zbocze opadajce) ustawia flag
;
czy_clip:       mov     a,buf_pio                       ;Aktualny stan XORujemy z poprzednim
                xrl     a,buf_pioD                      ; w wyniku na zmienionych pozycjach jest "1"
                anl     a,#AND_FSK                      ;Czy zmiana dotyczy pinu FSK ?
                cjne    a,#AND_FSK,czy_clip_nie         ; - nie to skacz
                                                        ; - tak analizuj jakie zbocze
                mov     a,buf_pioD                      ;Jedynka bedzie gdy opadajce zbocze
                anl     a,#AND_FSK                      ;Czy opadajace
                cjne    a,#AND_FSK,czy_clip_nie         ; - nie to skacz
                setb    FL_FSK                          ; - tak wic ustaw flag
czy_clip_nie:   ret

;;----------------------------------------------------------------------------
;;Opis: Obsuga dekodowania DCF
;;IRQ jest generowane gdy sygna DCF zmieni stan (z H na L lub odwrotnie)
;; Ze wzgldu na to, e moe wystpi faszywa obsuga (IRQ z innego powodu)
;; jest badany stan linii DCF i flagi FL_INPUT_DCF. Procedura stwierdz czy
;; nastpia zmiana czy nie. jeli nie procedura jest ignorowana, jeli tak
;; badany jest kierunek zmiany i zapamitywany czas trwania stanu wysokiego i niskiego.
;; Zmiana licznika i "dcf_h" musi nastpowa 100 razy na sekund (co 10ms),
;; natomiast "dcf_l" 50 razy na sekund (co 20ms).
;; Jeli wykryto przerw synchronizujc zerowany jest licznik "dcf_wsk"
;; i zerowana flaga bdu "FL_ERR_DCF".
;;
;;Zmienia: ACC, B, R0, DPTR
;;
;dcf:    ;-------- Wykrycie zmiany stanu linii DCF --- !  PATRZ WZOR PROCEDURY FSK i 16KHZ !
;                mov     a,buf_pio               ;Odtworzenie stanu PIO
;                jnb     ACC+INT_DCF,dcf_l1       ;Czy zmiana stanu linii DCF ?
;                jb      FL_INPUT_DCF,dcf_zmiana_l
;                ret                             ; bez zmian wyjd
;dcf_l1:         jnb     FL_INPUT_DCF,dcf_zmiana_h
;dcf_quit:       ret                             ; bez zmian wyjd
;dcf_zmiana_h:   setb    FL_INPUT_DCF              ;Zmiana na H (koniec pomiaru L)
;        ;-------- Dekodowanie 0, 1 czy Synchro -------
;                mov     dcf_h,#0                ; rozpoczcie pomiaru
;                mov     a,dcf_l                 ; Czy SYNCHRO ?
;                cjne    a,#130/2,*+3
;                jc      dcf_quit                ; - nie synchro wic skocz
;                lcall   init_dcf                ; - synchro wic zeruj licznik i flagi
;                ret
;dcf_zmiana_l:   clr     FL_INPUT_DCF            ;Zmiana na L (koniec pomiaru H)
;                mov     dcf_l,#0                ; rozpoczcie pomiaru
;                mov     a,dcf_h                 ; Czy "1" ?
;                cjne    a,#14,*+3
;                jc      dcf_0                   ; - nie "1" wic skok
;                setb    FL_BIT_DCF              ; odczytano bit "1"
;                sjmp    dcf_l2
;dcf_0:          clr     FL_BIT_DCF              ; odczytano bit "0"
;dcf_l2: ;-------- Dekodowanie pierwszych 15 bitw -----
;                mov     a,dcf_wsk               ;Czy bity 0...14 ? (liczymy od 1)
;                cjne    a,#15+1,*+3
;                jnc     dcf_l3                  ; - nie wic dalej
;                jnb     FL_BIT_DCF,dcf_exit     ; jeli bity =0 to wyjd
;                setb    FL_ERR_DCF              ; jeli bity =1 to bd
;                sjmp    dcf_exit
;dcf_l3: ;-------- Zapis danych do bufora ---------------
;                jb      FL_ERR_DCF,dcf_err      ;Jeli by bd to pomi
;                clr     C                       ;Odjcie przesunicia (-14 bitw)
;                mov     a,dcf_wsk
;                subb    a,#15
;                mov     B,a                     ;Zapamitaj nr bajtu i bitu
;                rr      a                       ; wydzielenie nr bajtu
;                rr      a
;                rr      a
;                anl     a,#%111
;                add     a,#dcf_start            ; dodanie adresu pocztka bufora
;                mov     R0,a                    ; i zapamitanie w R0
;                cjne    a,#dcf_end+1,*+3        ;Jeli przekroczono bufor to bd
;                jnc     dcf_err
;                mov     a,B                     ; odtwrz nr bajtu i bitu
;                anl     a,#%111                 ; wydzielenie nr bitu
;                mov     B,a                     ; i zapamitanie go w B
;                mov     a,@R0                   ;Odczytanie bajtu z bufora do modyfikacji
;                jnb     FL_BIT_DCF,dcf_l4       ; ustawienie lub skasowanie bitu w buforze
;                lcall   ustaw_bit
;                sjmp    dcf_l5
;dcf_l4:         lcall   kasuj_bit
;dcf_l5:         mov     @R0,a                   ; zapis zmodyfikowanego bajtu
;                mov     a,dcf_wsk               ;Czy nadano ostatni bit ?
;                cjne    a,#58,dcf_exit          ; - nie to wyjd
;        ;-------- Dekoduj informacje z bufora -----------
;                mov     B,#6
;                lcall   roluj_bufor_dcf
;        mov pam1,dcf_start           ;???
;                lcall   obroc_bajt
;        mov pam2,dcf_start           ;???
;
;
;
;                setb    FL_OK_DCF               ;Dekodowanie poprawne
;; Dane zawieraj dat:
;;	 7. 4.98  pitek
;;	21:24
;
;dcf_exit:       inc     dcf_wsk
;                ret
;
;dcf_err:        setb    FL_ERR_DCF              ;Sygnalizacja bdu
;                ret
;
;
;;----------------------------------------------------------------------------
;;Opis: Przeswa bufor DCF o "B" bajtw w lewo
;;zmienia: ACC, B
;;
;roluj_bufor_dcf:clr     C
;                mov     a,dcf_start
;                rrc     a
;                mov     dcf_start,a
;                mov     a,dcf_b1
;                rrc     a
;                mov     dcf_b1,a
;                mov     a,dcf_b2
;                rrc     a
;                mov     dcf_b2,a
;                mov     a,dcf_b3
;                rrc     a
;                mov     dcf_b3,a
;                mov     a,dcf_b4
;                rrc     a
;                mov     dcf_b4,a
;                mov     a,dcf_end
;                rrc     a
;                mov     dcf_end,a
;                djnz    B,roluj_bufor_dcf
;                ret
;
;;----------------------------------------------------------------------------
;;Opis: Obraca bajt (bit7 na bit0, bit6 na bit1,itd)
;;Zmienia: Acc, R7, R6, R5
;;
;obroc_bajt:     mov     R7,#8                   ;Liczba przesuni
;                mov     R6,a                    ;rdo
;obroc_bajt_loop:mov     a,R6
;                rlc     a
;                mov     R6,a
;                mov     a,R5
;                rrc     a
;                mov     R5,a
;                djnz    R7,obroc_bajt_loop
;                ret
;
;----------------------------------------------------------------------------
init_dcf:       clr     FL_ERR_DCF
                clr     FL_OK_DCF
                mov     dcf_wsk,#$0
                mov     dcf_start,#0
                mov     dcf_b1,#0
                mov     dcf_b2,#0
                mov     dcf_b3,#0
                mov     dcf_b4,#0
                mov     dcf_end,#0
                ret

;----------------------------------------------------------------------------
irq_dtmf:       push    PSW
                setb    FL_DTMF                 ;ustaw znacznik
                pop     PSW
                reti

;----------------------------------------------------------------------------
;Ustawia wybrany bit w bajcie
;we: Acc - warto bajtu
;    B   - nr ustawianego bitu
;wy: Acc - zmieniona zawarto bajtu
;Zmienia: Acc
;
ustaw_bit:      push    RR7                             ;Zapamitaj rejestry
                push    DPH
                push    DPL

                mov     R7,a                            ;Zapamitaj bajt w R7
                mov     a,B                             ;Oblicz ktry bit ustawi
                mov     dptr,#ustaw_zgl_tab             ; adres tablicy
                movc    a,@a+dptr                       ; pobranie elementu
                orl     a,R7                            ;Zsumowanie starej zawartoci
                                                        ; bajtu z ustawionym bitem
                pop     DPL                             ;Odtwrz rejestry
                pop     DPH
                pop     RR7
                ret

;----------------------------------------------------------------------------
;Kasuje wybrany bit w bajcie
;we: Acc - warto bajtu
;    B   - nr ustawianego bitu
;wy: Acc - zmieniona zawarto bajtu
;Zmienia: Acc
;
kasuj_bit:      push    RR7                             ;Zapamitaj rejestry
                push    DPH
                push    DPL

                mov     R7,a                            ;Zapamitaj bajt w R7
                mov     a,B                             ;Oblicz ktry bit ustawi
                mov     dptr,#kasuj_zgl_tab             ; adres tablicy
                movc    a,@a+dptr                       ; pobranie elementu
                anl     a,R7                            ;Zsumowanie starej zawartoci
                                                        ; bajtu z ustawionym bitem
                pop     DPL                             ;Odtwrz rejestry
                pop     DPH
                pop     RR7
                ret

ustaw_zgl_tab:  BYTE    %00000001,%00000010,%00000100,%00001000,%00010000,%00100000,%01000000,%10000000
kasuj_zgl_tab:  BYTE    %11111110,%11111101,%11111011,%11110111,%11101111,%11011111,%10111111,%01111111

;============================================================================
;=              Procedury obsugi zegara czasu rzeczywistego                =
;============================================================================
write_czas:     clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   iic_start                       ;Zeruj preskaler
                mov     a,#ZEGAR_WRITE
                lcall   iic_write
                jc      error_zegar
                mov     a,#%00100000                    ;Wskanik trybu - Zeruj preskaler
                lcall   iic_write
                jc      error_zegar
                lcall   iic_stop

                lcall   iic_start                       ;Zapis daty i czasu do PCF
                mov     a,#ZEGAR_WRITE
                lcall   iic_write
                jc      error_zegar
                mov     a,#%00000000                    ;Wskanik trybu - Zapis godzin
                lcall   iic_write
                jc      error_zegar
                mov     a,godzina                       ;Zapis godziny
                lcall   iic_write
                jc      error_zegar
                mov     a,minuta                        ;Zapis minut
                lcall   iic_write
                jc      error_zegar
                mov     a,dzien                         ;Zapis dnia miesica
                lcall   iic_write
                jc      error_zegar
                mov     a,miesiac                       ;Zapis miesica
                lcall   iic_write
                jc      error_zegar
                lcall   iic_stop
                setb    ET0
                setb    EX0
                ljmp    write_lata                      ;Zapis lat i znacznikw do Zegara
                                        ;<--- zastpuje RET

;----------------------------------------------------------------------------
;Opis: Zapisuje znaczniki i lata do Zegara
;we: B - znaczniki
;
write_znaczniki:
write_lata:     clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   iic_start                       ;Zapis lat do PCF
                mov     a,#ZEGAR_WRITE
                lcall   iic_write
                jc      error_zegar
                mov     a,#%00000100                    ;Wskanik trybu - Zapis alarmu
                lcall   iic_write
                jc      error_zegar
                mov     a,rok_h                         ;Zapis setek lat (alarm godzin)
                lcall   iic_write
                jc      error_zegar
                mov     a,rok_l                         ;Zapis jednoci lat (alarm godzin)
                lcall   iic_write
                jc      error_zegar
                mov     a,B                             ;Zapis wskanika
                lcall   iic_write
                jc      error_zegar
                lcall   iic_stop
                setb    ET0
                setb    EX0
                ret

;----------------------------------------------------------------------------
error_zegar:    mov     std_out,#STD_OUT_LCD
                lcall   print_err
                mov     dptr,#txt_error_zegar           ;Wywietlenie napisu
                lcall   print_text
                ljmp    wait_error       ;<--- zastpuje RET
txt_error_zegar:
                STRING  'Zegar'
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Odczytuje czas z zegara PCF
;
read_czas:      clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   iic_start                       ;Odczyt daty i czasu z PCF
                mov     a,#ZEGAR_WRITE
                lcall   iic_write
                jc      error_zegar
                mov     a,#%00000000                    ;Wskanik trybu - Odczyt godzin
                lcall   iic_write
                lcall   iic_start
                mov     a,#ZEGAR_READ
                lcall   iic_write
                jc      error_zegar

                lcall   iic_read_p                      ;Odczyt godziny
                mov     godzina,a
                lcall   iic_read_p                      ;Odczyt minut
                mov     minuta,a
                lcall   iic_read_p                      ;Odczyt dnia miesica
                mov     dzien,a
                lcall   iic_read_np                     ;Odczyt miesica
                mov     miesiac,a
                lcall   iic_stop
                setb    ET0
                setb    EX0

                lcall   read_lata
                lcall   oblicz_dzien_tygodnia
                lcall   korekta_lat
                lcall   korekta_lato_zima
                ljmp    korekta_zima_lato       ;<--- zastpuje RET


;----------------------------------------------------------------------------
error_zegar1:   ljmp    error_zegar                     ;Skok do obsugi bdu

;----------------------------------------------------------------------------
;Opis: Odczytuje wskazniki i lata z Zegara do Ram
;wy: B - znaczniki
;
read_znaczniki:
read_lata:      clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   iic_start                       ;Odczyt daty i czasu z PCF
                mov     a,#ZEGAR_WRITE
                lcall   iic_write
                jc      error_zegar
                mov     a,#%00000100                    ;Wskanik trybu - Odczyt Alarmu
                lcall   iic_write
                lcall   iic_start
                mov     a,#ZEGAR_READ
                lcall   iic_write
                jc      error_zegar

                lcall   iic_read_p                      ;Odczyt lat (alarm godzin)
                mov     rok_h,a
                lcall   iic_read_p                      ;Odczyt lat (alarm minut)
                mov     rok_l,a
                lcall   iic_read_np                     ;Odczyt wskanika "nieaktualny rok"
                mov     B,a                             ; w B wskanik "nieaktualny rok"
                lcall   iic_stop
                setb    ET0
                setb    EX0
                ret

;----------------------------------------------------------------------------
;Opis: Korekta lat
;we: B  - wskaniki odczytane z zegara PCF
;
korekta_lat:    lcall   read_znaczniki
                mov     a,miesiac                       ;Czy 12 miesic ?
                cjne    a,#$12,kor_rok_1
                mov     a,dzien                         ;Czy 31 dziemiesica ?
                cjne    a,#$31,kor_rok_1
                setb    B+FAIL_ROK                      ;Ustawia wskanik
                clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   iic_start                       ;Zapis wskanika
                mov     a,#ZEGAR_WRITE
                lcall   iic_write
                jc      error_zegar1
                mov     a,#%00000110                    ;Wskanik trybu - Zapis Alarmu
                lcall   iic_write
                jc      error_zegar1
                mov     a,B
                lcall   iic_write
                jc      error_zegar1
                lcall   iic_stop
                setb    ET0
                setb    EX0
kor_rok_1:      mov     a,miesiac                       ;Czy 01 miesic ?
                cjne    a,#$01,kor_rok_2
                mov     a,dzien                         ;Czy 01 dziemiesica ?
                cjne    a,#$01,kor_rok_2
                jnb     B+FAIL_ROK,kor_rok_2            ;Jeli wskanik zero, pomi
                mov     a,rok_l                         ;rok=rok+1 (w BCD)
                add     a,#1
                da      a
                mov     rok_l,a
                mov     a,rok_h
                addc    a,#0
                da      a
                mov     rok_h,a
                clr     B+FAIL_ROK                      ;Kasuj wskanik
                lcall   write_lata                      ;Zapisz lata i wskaniki
kor_rok_2:      ret

;----------------------------------------------------------------------------
;Opis: Zmiana czasu Zima ---> Lato
;we: B  - wskaniki odczytane z zegara PCF
;
korekta_zima_lato:
                lcall   read_znaczniki
                mov     a,miesiac                       ;Czy miesic 03 (Marzec) ?
                cjne    a,#$03,kor_lat_1                ; - nie to pomi
                mov     a,dzien                         ;Czy 25 lub dalszy dzie ?
                cjne    a,#$25,*+3
                jnc     kor_lat_2                       ; - tak, wic sprawd dalej
                sjmp    kor_lat_1                       ; - nie wic pomi
kor_lat_2:      mov     a,dzien_tygodnia                ;Czy niedziela ?
                cjne    a,#NIEDZIELA,kor_lat_1          ; - nie to pomi
                mov     a,godzina                       ;Czy 2:xx ?
                cjne    a,#$02,kor_lat_1                ; - nie to pomi
                mov     godzina,#$03                    ;Tak wic ustaw godz 3:xx
                lcall   write_czas                      ;Zapisz skorygowany czas

kor_lat_1:      ret

;----------------------------------------------------------------------------
;Opis: Zmiana czasu Lato ---> Zima
;we: B  - wskaniki odczytane z zegara PCF
;
korekta_lato_zima:
                lcall   read_znaczniki
                mov     a,miesiac                       ;Czy miesic 10 (Padziernik) ?
                cjne    a,#$10,kor_zim_1                ; - nie to pomi
                mov     a,dzien                         ;Czy 24 ?
                cjne    a,#$24,kor_zim_2                ; - nie to pomi
                setb    B+PRZESUN_DZIEN                 ; - tak ustaw znacznik "przesun dat"
                lcall   write_znaczniki                 ;Zapisz wskanik
kor_zim_2:      mov     a,dzien                         ;Czy 25 lub dalszy dzie ?
                cjne    a,#$25,*+3
                jnc     kor_zim_3                       ; - tak, wic sprawd dalej
                sjmp    kor_zim_1                       ; - nie wic pomi
kor_zim_3:      mov     a,dzien_tygodnia                ;Czy niedziela ?
                cjne    a,#NIEDZIELA,kor_zim_1          ; - nie to pomi
                mov     a,godzina                       ;Czy 3:xx ?
                cjne    a,#$03,kor_zim_1                ; - nie to pomi
                jnb     B+PRZESUN_DZIEN,kor_zim_1       ;Jeli wskanik zero, pomi
                clr     B+PRZESUN_DZIEN                 ;Kasuj wskanik
                lcall   write_znaczniki                 ;Zapisz wskanik
                mov     godzina,#$02                    ;Tak wic ustaw godz 2:xx
                lcall   write_czas                      ;Zapisz skorygowany czas
kor_zim_1:      ret

;----------------------------------------------------------------------------
;Opis: Obliczanie dnia tygodnia na podstawie daty
;
oblicz_dzien_tygodnia:

                lcall   zeruj_resld                     ;Konwersja roku na HEX
                mov     a,rok_h
                lcall   depack_bcd
                mov     resld+3,B
                mov     resld+2,a
                mov     a,rok_l
                lcall   depack_bcd
                mov     resld+1,B
                mov     resld+0,a
                lcall   bcdhex                          ;Konwersja BCD->HEX
                mov     R0,#resl                        ;Wynik konwersji do "RRR"
                mov     R1,#RRR
                lcall   copy_r0_r1

                lcall   zeruj_resld                     ;Konwersja "miesiac" na HEX
                mov     a,miesiac
                lcall   depack_bcd
                mov     resld+1,B
                mov     resld+0,a
                lcall   bcdhex                          ;Konwersja BCD->HEX
                mov     R0,#resl                        ;Wynik konwersji do "MM"
                mov     R1,#MM
                lcall   copy_r0_r1

                lcall   zeruj_resld                     ;Konwersja dnia na HEX
                mov     a,dzien
                lcall   depack_bcd
                mov     resld+1,B
                mov     resld+0,a
                lcall   bcdhex                          ;Konwersja BCD->HEX
                mov     R0,#resl                        ;Wynik konwersji do "DD"
                mov     R1,#DD
                lcall   copy_r0_r1

                mov     a,miesiac                       ;Jeli miesic mniejszy
                cjne    a,#$03,*+3                      ; ni 3, wykonaj
                jc      obl_dz_mniej                    ; rok=rok-1 mie=mie+12
                sjmp    obl_dz_wiekszy
obl_dz_mniej:   mov     R0,#RRR                         ;RRR=RRR-1
                mov     B,#1
                lcall   odejmij_r0
                mov     R0,#MM                          ;MM=MM+12
                mov     B,#12
                lcall   dodaj_r0
obl_dz_wiekszy:


                mov     R0,#RRR                         ;AA=RRR
                mov     R1,#AA
                lcall   copy_r0_r1


                mov     R0,#RRR                         ;PP=RRR/4
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     arg2+0,#4
                mov     arg2+1,#0
                mov     arg2+2,#0
                mov     arg2+3,#0
                lcall   div32
                mov     R0,#resl
                mov     R1,#PP
                lcall   copy_r0_r1
                lcall   aa_aa_plus_pp                   ;AA=AA+PP


                mov     R0,#RRR                         ;PP=RRR/100
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     arg2+0,#100
                mov     arg2+1,#0
                mov     arg2+2,#0
                mov     arg2+3,#0
                lcall   div32
                mov     R0,#resl
                mov     R1,#PP
                lcall   copy_r0_r1
                lcall   aa_aa_minus_pp                  ;AA=AA-PP


                mov     R0,#RRR                         ;PP=RRR/400 ($0190)
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     arg2+0,#$90
                mov     arg2+1,#$01
                mov     arg2+2,#0
                mov     arg2+3,#0
                lcall   div32
                mov     R0,#resl
                mov     R1,#PP
                lcall   copy_r0_r1
                lcall   aa_aa_plus_pp                   ;AA=AA+PP


                mov     R0,#MM                          ;PP=3*M   (PP=arg1)
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     a,arg1
                mov     B,#3
                mul     ab
                mov     arg1,a
                mov     R0,#arg1
                mov     R1,#PP
                lcall   copy_r0_r1
                lcall   aa_aa_plus_pp                   ;AA=AA+PP


                mov     R0,#MM                          ;PP=2*M   (PP=arg1)
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     a,arg1
                mov     B,#2
                mul     ab
                inc     a                               ;PP=PP+1 (PP=acc)
                mov     B,#5                            ;PP=PP/5
                div     ab
                mov     arg1,a
                mov     R0,#arg1
                mov     R1,#PP
                lcall   copy_r0_r1
                lcall   aa_aa_minus_pp                  ;AA=AA-PP


                mov     R0,#DD                          ;AA=AA+DD
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     R0,#AA
                mov     R1,#arg2
                lcall   copy_r0_r1
                lcall   add32
                mov     R0,#resl
                mov     R1,#AA
                lcall   copy_r0_r1


                mov     R0,#AA                          ;AA=AA+1
                mov     B,#1
                lcall   dodaj_r0


                mov     R0,#AA                          ;Oblicz reszt z dzielnia
                mov     R1,#arg1                        ; AA/7
                lcall   copy_r0_r1
                mov     arg2+0,#7
                mov     arg2+1,#0
                mov     arg2+2,#0
                mov     arg2+3,#0
                lcall   div32
                mov     a,resd+0                        ;Reszta z dzielenia do ACC
                mov     dzien_tygodnia,a

                ret

;----------------------------------------------------------------------------
aa_aa_plus_pp:  mov     R0,#AA                          ;AA=AA+PP
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     R0,#PP
                mov     R1,#arg2
                lcall   copy_r0_r1
                lcall   add32
                mov     R0,#resl
                mov     R1,#AA
                ljmp    copy_r0_r1      ;<--- zastpuje RET


;----------------------------------------------------------------------------
aa_aa_minus_pp: mov     R0,#AA                          ;AA=AA-PP
                mov     R1,#arg1
                lcall   copy_r0_r1
                mov     R0,#PP
                mov     R1,#arg2
                lcall   copy_r0_r1
                lcall   sub32
                mov     R0,#resl
                mov     R1,#AA
                ljmp    copy_r0_r1      ;<--- zastpuje RET


;----------------------------------------------------------------------------
;Opis: Dodaje liczb z "B" od adresu wskazanego przez R0
;we: R0 - wskazany adres
;    B  - liczba do dodania
;Zmienia: PSW, ACC, R0
;
dodaj_r0:       mov     a,@R0
                add     a,B
                mov     @R0,a
                inc     R0
                mov     a,@R0
                addc    a,#0
                mov     @R0,a
                inc     R0
                mov     a,@R0
                addc    a,#0
                mov     @R0,a
                inc     R0
                mov     a,@R0
                addc    a,#0
                mov     @R0,a
                ret

;----------------------------------------------------------------------------
;Opis: Odejmuje liczb z "B" od adresu wskazanego przez R0
;we: R0 - wskazany adres
;    B  - liczba do odjcia
;Zmienia: PSW, ACC, R0
;
odejmij_r0:     clr     C
                mov     a,@R0
                subb    a,B
                mov     @R0,a
                inc     R0
                mov     a,@R0
                subb    a,#0
                mov     @R0,a
                inc     R0
                mov     a,@R0
                subb    a,#0
                mov     @R0,a
                inc     R0
                mov     a,@R0
                subb    a,#0
                mov     @R0,a
                ret

;----------------------------------------------------------------------------
;Opis: Kopiuje cztery bajty z adresw wskazywanych przez R0 do R1
;we: R0, R1
;wy:
;Zmienia: PSW, ACC, R0, R1
;
copy_r0_r1:     mov     a,@R0
                mov     @R1,a
                inc     R0
                inc     R1
                mov     a,@R0
                mov     @R1,a
                inc     R0
                inc     R1
                mov     a,@R0
                mov     @R1,a
                inc     R0
                inc     R1
                mov     a,@R0
                mov     @R1,a
                ret

;----------------------------------------------------------------------------
;Opis: Rozpakowuje liczb upakowane BCD na nieupakowane BCD
;we: ACC - liczba upakowane BCD
;wy: B   - starszy BCD
;    ACC - modszy BCD
;Zmienia: PSW, ACC, B
;
depack_bcd:     push    ACC
                rl      a
                rl      a
                rl      a
                rl      a
                anl     a,#$0F
                mov     B,a
                pop     ACC
                anl     a,#$0F
                ret

;----------------------------------------------------------------------------
;Opis: Zeruje bufor "resld"
;
zeruj_resld:    mov     resld+9,#0
                mov     resld+8,#0
                mov     resld+7,#0
                mov     resld+6,#0
                mov     resld+5,#0
                mov     resld+4,#0
                mov     resld+3,#0
                mov     resld+2,#0
                mov     resld+1,#0
                mov     resld+0,#0
                ret

;============================================================================
;=                 Procedury obsugi zaliczania impulsw                    =
;============================================================================
;Opis: Obsuguje (na IRQ) zaliczanie licznika abonenckiego
;we:
;wy:
;zmienia:
;
obsluga_licznika:
                mov     a,kryterium_rozmowy             ;Sprawd czy ustawiona
                cjne    a,#IMPULS_16KHZ,obs_czas_1      ;  taryfikacja 16 kHz ?
                jb      FL_16KHZ,obs_16khz_zalicz       ;Sprawd czy impuls 16 KHZ
                ret                                     ; - nie wic wyjd
obs_16khz_zalicz:                                       ; - tak wic:
                clr     FL_16KHZ                        ;Zeruje znacznik odbioru 16kHz
                ljmp    inc_licznik_impulsow            ;Zwiksz licznik impulsw
                                        ;<--- zastpuje RET

        ;-------- Obsuga licznika odliczajcego okresy zaliczania -----
obs_czas_1:     mov     a,licznik_czasu_setne   ;Jeli licznik =000000
                orl     a,licznik_czasu_sek_l   ;
                orl     a,licznik_czasu_sek_h   ;
                cjne    a,#$00,obs_czas_2       ;
                ret                             ; - nie obsuguj go

;!!!!???? Dac tu cos co bedzie zmienialo jakis pin co przerwanie (co powinno dac F=50Hz)
;         jesli owa czestotliwosc nie jest dokladna to podregulowac ustawieniami timera
;

obs_czas_2:     mov     a,licznik_czasu_setne   ;Zmiejsza licznika (100 razy na sekund)
                lcall   decacc
                mov     licznik_czasu_setne,a
                cjne    a,#$99,obs_czas_3
                mov     licznik_czasu_setne,#$99
                mov     a,licznik_czasu_sek_l
                lcall   decacc
                mov     licznik_czasu_sek_l,a
                cjne    a,#$99,obs_czas_3
                mov     licznik_czasu_sek_l,#$99
                mov     a,licznik_czasu_sek_h
                lcall   decacc
                mov     licznik_czasu_sek_h,a
obs_czas_3:     nop

        ;-------- Czy zwikszy licznik bierzcej rozmowy ? ------
                mov     a,licznik_czasu_setne   ;Jeli licznik =000000
                orl     a,licznik_czasu_sek_l   ;
                orl     a,licznik_czasu_sek_h   ;
                cjne    a,#$00,obs_czas_4       ;
                sjmp    obs_czas_5              ; - to min okres zaliczania
obs_czas_4:     ret                             ; licznik <>000000 to wyjd

obs_czas_5:     lcall   inc_licznik_impulsow    ;Zwiksz licznik impulsw
                ljmp    oblicz_okres_zaliczania ;Okrel okres zaliczania
                                                ;<--- zastpuje RET

;----------------------------------------------------------------------------
;Opis: Okrela okres zaliczania na podstawie taryfy, aktualnej godziny i dnia tygodnia
;we:
;wy:
;zmienia:
;
oblicz_okres_zaliczania:
                push    DPL
                push    DPH
                push    B
                mov     B,R0
                push    B

                mov     R0,#0                           ;Nr kolejny taryfy
okres_l1:       lcall   wylicz_adres_taryfy
                lcall   read_eeprom
                cjne    a,#END_TARYFA,okres_l2          ;Czy Koniec tablicy taryf
                sjmp    okres_err
okres_l2:       cjne    a,taryfa,okres_l3               ;Czy to ta taryfa ?, nie wic szukaj dalej
        ;-------- Znalazem taryf --------
                inc     dptr                            ;Jaki zakres godzin ?
                lcall   read_eeprom
                cjne    a,#$00,okres_przedzialy         ; - rny od $00
                                                        ; - rwny $00 wic pestka
        ;-------- Wyliczony okres wpisz do licznika czasu --------
okres_ustaw_licznik:
                lcall   wylicz_adres_taryfy
                inc     dptr                            ;Pomi nr taryfy
                inc     dptr                            ; i godziny
                mov     a,dzien_tygodnia
                cjne    a,#SOBOTA,czy_niedziela
                sjmp    okres_swieto
czy_niedziela:  cjne    a,#NIEDZIELA,czy_swieto
                sjmp    okres_swieto
czy_swieto:
  ;??? doda sprawdzanie czy dzie witeczny (wita stae)
                sjmp    okres_zwykle_dni

okres_swieto:   inc     dptr                            ;Jeli Sobota lub Niedziala
                inc     dptr                            ; zwiksz DPTR o 3
                inc     dptr
okres_zwykle_dni:                                       ;Wpisz do licznika
                lcall   read_eeprom                     ;Licznik czasu wpisz z tablicy taryf
                mov     licznik_czasu_sek_h,a
                inc     dptr
                lcall   read_eeprom
                mov     licznik_czasu_sek_l,a
                inc     dptr
                lcall   read_eeprom
                mov     licznik_czasu_setne,a
                mov     a,licznik_czasu_sek_h           ;Jeli sekundy w tablicy <> 0
                orl     a,licznik_czasu_sek_l
                cjne    a,#0,okres_lq                   ; to zaliczanie nomralne
                mov     licznik_impulsow_l,licznik_czasu_setne ;Jeli = 0 to zalicz
                mov     licznik_czasu_setne,#0          ; jednorazowo N impulsw
                sjmp    okres_lq

okres_l3:       inc     R0
                sjmp    okres_l1

okres_lq:       pop     B
                mov     R0,B
                pop     B
                pop     DPH
                pop     DPL
                ret

        ;-------- BD: Nie znaleziono taryfy --------------------
okres_err:      lcall   print_err
                mov     dptr,#txt_err_tar
                lcall   print_text
                ljmp    wait_error       ;<--- zastpuje RET

txt_err_tar:    STRING  'Brak taryfy'
                BYTE    0

        ;-------- Taryfa z zakresem godzin, wic wiksza zabawa --
okres_przedzialy:
                lcall   wylicz_adres_taryfy
                lcall   read_eeprom             ;Zapamitaj nr taryfy w R7
                mov     RR7,a
                inc     dptr                    ;Wczytaj godzin z taryfy
                lcall   read_eeprom
                mov     B,a
                mov     a,godzina
                cjne    a,B,*+3                 ;Czy aktualna godzina >= tej
                jnc     okres_prze_1            ; w taryfie ?
            ;------- Nie wic szukaj ostatniej godziny w tej taryfie ---
okres_prze_3:
                lcall   next_taryfa             ;Next taryfa
                lcall   read_eeprom             ;Wczytaj nr taryfy
                cjne    a,RR7,okres_prze_end    ;Jeli inny nr tar od poprzed wyjd
                sjmp    okres_prze_3            ; - taki sam wic szukaj dalej
okres_prze_end:
                lcall   prev_taryfa             ;Cofnij na poprzedni taryf
                ljmp    okres_ustaw_licznik     ; i wyjd

        ;-------- Szukaj zakresu godzin --------------------------
okres_prze_1:
                lcall   next_taryfa             ;Next taryfa
                lcall   read_eeprom             ;Wczytaj nr taryfy
                cjne    a,RR7,okres_prze_end    ;Jeli inny nr tar od poprzed wyjd
                inc     dptr                    ;Wczytaj godzin z taryfy
                lcall   read_eeprom
                mov     B,a
                mov     a,godzina
                cjne    a,B,*+3                 ;Czy aktualna godzina >= tej
                jnc     okres_prze_1            ; w taryfie ? (- tak to szukaj dalej)
                sjmp    okres_prze_end          ;- nie wic wyjd

;----------------------------------------------------------------------------
zeruj_licznik_czasu:
                mov     licznik_czasu_sek_h,#0          ;czas=0000 co oznacza STOP
                mov     licznik_czasu_sek_l,#0
                mov     licznik_czasu_setne,#0
                ret

;----------------------------------------------------------------------------
;Opis: Zwiksza wskanik na nastpn taryf i ustawia DPTR
;we: R0 - aktualny nr taryfy
;wy: R0 - nr taryfy po zmianie
;zmienia: PSW, ACC, R0,DPTR
;
next_taryfa:    inc     R0                      ;Next taryfa
                mov     a,R0                    ;Wskanik na taryf
                ljmp    wylicz_adres_taryfy     ;<--- zastpuje RET

;----------------------------------------------------------------------------
;Opis: Zmniejsza wskanik na nastpn taryf i ustawia DPTR
;we: R0 - aktualny nr taryfy
;wy: R0 - nr taryfy po zmianie
;zmienia: PSW, ACC, R0,DPTR
;
prev_taryfa:    dec     R0                      ;Prev taryfa
                mov     a,R0                    ;Wskanik na taryf
                ljmp    wylicz_adres_taryfy     ;<--- zastpuje RET

;----------------------------------------------------------------------------
;Opis: Na podstawie nr kolejnego taryfy oblicza adres w pamici
;      EEPROM pierwszego bajtu wskazujcego na tablic taryfy
;we: R0   - nr kolejny taryfy
;wy: DPTR - adres w EEPROM
;zmienia: PSW, ACC, DPTR
;
wylicz_adres_taryfy:
                mov     DPL,R0                  ;Przekazanie parametrw do DPTR
                mov     DPH,#0
                mov     a,DPL                   ;Mnoymy przez 2
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 4)
                rlc     a
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a
                mov     a,DPL                   ;i znw (czyli przez 8)
                rlc     a
                anl     a,#%11111000            ;Obcicie
                mov     DPL,a
                mov     a,DPH
                rlc     a
                mov     DPH,a

                mov     a,DPL                   ;Dodanie przesunicia
                add     a,#LOW taryfy
                mov     DPL,a
                mov     a,DPH
                addc    a,#HIGH taryfy
                mov     DPH,a

                ret

;----------------------------------------------------------------------------
;Opis: Zwiksza o jeden (w BCD) stan licznika impulsw bierzcej rozmowy
;we: --
;wy: --
;zmienia: PSW, ACC
;
inc_licznik_impulsow:
                mov     a,licznik_impulsow_l
                add     a,#1
                da      a
                mov     licznik_impulsow_l,a
                mov     a,licznik_impulsow_h
                addc    a,#0
                da      a
                mov     licznik_impulsow_h,a
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia licznik impulsw bierzcej rozmowy na 0001
;we: --
;wy: --
;zmienia: --
;
start_licznika_impulsow:
                mov     licznik_impulsow_l,#1
                mov     licznik_impulsow_h,#0
                clr     FL_16KHZ                ;Zeruj znacznik 16kHz
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia licznik impulsw bierzcej rozmowy i ostatniej rozmowy na 0000
;we: --
;wy: --
;zmienia: --
;
zeruj_licznik_impulsow:
                mov     licznik_impulsow_l,#0
                mov     licznik_impulsow_h,#0
                mov     licznik_impulsow_ost_l,#0
                mov     licznik_impulsow_ost_h,#0
                ret

;----------------------------------------------------------------------------
zeruj_czas_rozmowy:
                mov     czas_rozmowy_sek,#0
                mov     czas_rozmowy_min,#0
                mov     czas_rozmowy_godz,#0
                ret

;----------------------------------------------------------------------------
;Opis: Zmiejsza ACC o jeden w BCD (wykonujc korekcj dziesitn)
;we: ACC
;wy: ACC
;zmienia: PSW, ACC
;
decacc  	cjne	a,#0,niero	;Dekrementacja ACC z korekcj dziesitn
		mov	a,#$99
		ret
niero		clr	C
		subb	a,#1
		push	ACC
		anl	a,#$f
		cjne	a,#$f,nie0F
		pop	ACC
		anl	a,#$f0
		orl	a,#9
		ret
nie0F		pop	ACC
		ret

;============================================================================
;=                       Procedury drukowana                                =
;============================================================================
;============================================================================
;Opis: Drukuje konfiguracj przez RS (dla DRUKARKI)
;
print_konfig:   lcall   lcd_drukowanie                  ;Napis "Drukowanie..."
                push    std_out                         ;Zapamitaj std_out
                mov     std_out,out_device              ;Ustaw urzdzenie wyjciowe
                lcall   print_crlf                      ;Drukuj dat i czas
                lcall   print_data_czas
                mov     dptr,#txt_konfig_1
                lcall   print_text
                lcall   print_konf_spz                  ;Konfiguracja - sposb zaliczania
                lcall   print_konf_cena                 ;cena
 IF SAA1064=NO           ;Dla SAA1064 niweyswietlamy typu drukarki i std znakw
                lcall   print_konf_drukarka             ;typ drukarki
                lcall   print_konf_stdpl                ;Standard PL
 ENDI
                lcall   print_rs_end                    ;Napis ":END"
                lcall   auto_feed                       ;Wysw papieru
                pop     std_out                         ;odtwrz std_out
                ret

txt_konfig_1:   
 IF SAA1064=YES          ;Dla tryfla inny wydruk konfigu
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Konfiguracja:'
                BYTE    CR_ASCII,LF_ASCII
                STRING  '   Sposb       Cena   '
                BYTE    CR_ASCII,LF_ASCII
                STRING  '   zaliczania   impulsu'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    REPEAT_ASCII,24,"-"
                BYTE    CR_ASCII,LF_ASCII,0
 ELSE
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Konfiguracja:'
                BYTE    CR_ASCII,LF_ASCII
                STRING  '   Sposb       Cena    Typ      StdandardPL StdandardPL'
                BYTE    CR_ASCII,LF_ASCII
                STRING  '   zaliczania   impulsu Drukarki Drukarki    RS-232C'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    REPEAT_ASCII,57,"-"             ;57 znakw "-"
                BYTE    CR_ASCII,LF_ASCII,0
 ENDI

;----------------------------------------------------------------------------
;Opis: Drukuje konfiguracj (napisy polaruzacji sownie)
;
print_konf_spz: mov     a,#3                            ;Drukuje napis "   "
                lcall   print_spacje
                mov     a,kryterium_rozmowy             ;Jakie kryterium rozmowy ?
                cjne    a,#POLARYZACJA,print_konf_spz1
                mov     dptr,#txt_konfig_pol
                ljmp    print_text              ;<- Zastpuje RET

print_konf_spz1:cjne    a,#IMPULS_16KHZ,print_konf_spz2
                mov     dptr,#txt_konfig_16khz
                ljmp    print_text              ;<- Zastpuje RET

print_konf_spz2:
 IF SAA1064=NO                   ;Dla SAA1064 niewyswietlamy kryterium 400Hz
                cjne    a,#TON_400HZ,print_konf_spz3
                mov     dptr,#txt_konfig_400hz
                ljmp    print_text              ;<- Zastpuje RET
 ENDI
print_konf_spz3:push    ACC                             ;Zapamitaj parametr
                mov     dptr,#txt_konfig_po
                lcall   print_text
                pop     ACC                             ;Odtwrz parametr
                lcall   print_hex
                mov     dptr,#txt_konfig_sek
                ljmp    print_text              ;<- Zastpuje RET

txt_konfig_pol: STRING  'Polaryzacja '
                BYTE    0

txt_konfig_16khz:
                STRING  'Impuls 16kHz'
                BYTE    0

txt_konfig_400hz:
                STRING  'Zanik 400Hz  '
                BYTE    0

txt_konfig_po:  STRING  'Po '
                BYTE    0

txt_konfig_sek: STRING  ' sek.  '
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Drukuje konfiguracj (standard polskich znakw dla drukarki i RS)
;
print_konf_stdpl:
                mov     a,#6
                lcall   print_spacje
                mov     a,prt_pl                ;Polski standard dla drukarki
                lcall   prt_konf_pl
                mov     a,#3
                lcall   print_spacje
                mov     a,ser_pl                ; i dla RS
prt_konf_pl:    mov     dptr,#txt_bez_pl        ;Standardowo brak PL
                cjne    a,#AMIGA_PL,*+6
                mov     dptr,#txt_amiga_pl
                cjne    a,#WINDOWS_PL,*+6
                mov     dptr,#txt_windows_pl
                cjne    a,#MAZOWIA_PL,*+6
                mov     dptr,#txt_mazowia_pl
                ljmp    print_text              ;<- Zastpuje RET

txt_amiga_pl:   STRING  'AmigaPL  '
                BYTE    END_ASCII

txt_windows_pl: STRING  'WindowsPL'
                BYTE    END_ASCII

txt_mazowia_pl: STRING  'MazowiaPL'
                BYTE    END_ASCII

txt_bez_pl:     STRING  'BezPL    '
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis; Drukuje spacj
;Zmienia:
;
;print_spc:      push    ACC
;               mov     a,#" "
;                lcall   print_char
;                pop     ACC
;                ret
;----------------------------------------------------------------------------
;Opis; Drukuje Acc spacji
;we: Acc -liczba spacji do wydrukowania
;Zmienia: Acc
;
print_spacje:   push    ACC
                lcall   print_spc
                pop     ACC
                djnz    ACC,print_spacje
                ret

;----------------------------------------------------------------------------
;Opis: Drukuje konfiguracj (typ drukarki)
;
print_konf_drukarka:
                mov     a,#3
                lcall   print_spacje
                mov     a,printer_device        ;Jaki typ drukarki ?
                mov     dptr,#txt_druk_par      ;Domylny tekst
                cjne    a,#SERIAL_PRINTER,prn_konf_drukpar
                mov     dptr,#txt_druk_ser      ; Ser wic zmie tekst
prn_konf_drukpar:
                ljmp    print_text      ;<- Zastpuje RET

txt_druk_par:   STRING  'Par'
                BYTE    END_ASCII

txt_druk_ser:   STRING  'Ser'
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Drukuje konfiguracj (cen impulu )
;
print_konf_cena:lcall   print_spc                       ;Cena jednostki
                mov     a,cena_zl
                lcall   print_hex
                mov     a,#","
                lcall   print_char
                mov     a,cena_gr
                lcall   print_hex

;??? Ominite drukowanie VAT
;                mov     a,#5                          ;VAT
;                lcall   print_spacje
;                mov     a,cena_vat
;                lcall   print_hex
;                mov     a,#"%"
;                lcall   print_char
                ret



;----------------------------------------------------------------------------
;Opis: Drukuje zawarto rejestratora po wykonaniu CLR
;
print_rejestr_poCLR:
                setb    FL_PRT_ALL                      ;Drukuj take skasowane
                sjmp    print_rejestr0

;----------------------------------------------------------------------------
;Opis: Drukuje zawarto rejestratora
;we: --
;wy: --
;zmiania:
;
print_rejestr:  clr     FL_PRT_ALL                      ;Nie drukuj skasowanych
print_rejestr0: lcall   lcd_drukowanie                  ;Drukowanie zawartoci rejestratora
                push    std_out                         ;Zapamitaj std_out
                mov     std_out,out_device              ;Ustaw urzdzenie wyjciowe
                lcall   print_rej
                pop     std_out
                mov     a,out_device                    ;Jeli wyjcie na Ser
                cjne    a,#STD_OUT_PRT,print_rejestr1   ; to pomi kasowanie
                lcall   kasuj_bufor
print_rejestr1: ret

;----------------------------------------------------------------------------
;Opis: Pyta i ewentualnie kasuje bufor rozmw
;
kasuj_bufor:    lcall   curs_on
                mov     dptr,#txt_clr_bufor     ;Wywietlenie pytania na LCD
                lcall   print_text
                lcall   wait_cyfra_01           ;Czekanie na cyfr 1 lub 0
                jb      F0,kasuj_bufor1         ;Jeli odoona suchawka pomi
                jnc     kasuj_bufor1            ;Jeli nie "1" pomi
                lcall   clr_rejestr             ;Kasowanie rejestratora
kasuj_bufor1:   ljmp    print_crlf      ;<--- Zastpuje RET

txt_clr_bufor:  BYTE    CLS_ASCII
                        ;1234567890123456
                STRING  'Kasowa bufor ?'
                BYTE    0

txt_clr_konfig: BYTE    CLS_ASCII
                STRING  'Init konfig ?'
                BYTE    0

txt_napewno:    BYTE    CLS_ASCII
                STRING  'Napewno ?'
                BYTE    0

;----------------------------------------------------------------------------
print_rej:      lcall   print_crlf                      ;Drukuj dat i czas
                lcall   print_data_czas
                mov     dptr,#txt_rejestr_1     ;Linia pierwsza
                lcall   print_text

                mov     nr_linii_h,#0           ;Nr lini
                mov     nr_linii_l,#1
                jb      FL_PRT_ALL,print_rej_0    ;Czy wydruk take skasowynych ?
                lcall   szukaj_pierwszego_rekordu ;- nie wic sukaj pierwszego rekordu
                jnc     print_rej_1               ;Jeli bufor pusy
                mov     dptr,#txt_bufor_empty     ; komunikat
                lcall   print_text                ; i pominicie wydruk
                ljmp    print_rej_end1
print_rej_0:    lcall   set_rekord_0              ;- tak wic ustaw na pierwszy rekord
print_rej_1:    jnb     FL_PRT_ALL,print_rej_11 ;Czy wydruk take skasowanych ?
                lcall   get_rejestr             ; tak wic drukuj wszystko <>$FF
                anl     a,#%01111111
                cjne    a,#%01111111,print_rej_2
                ljmp    print_rej_6             ;Jeli $FF to pomi rekord ??? bylo ljmp
print_rej_11:   lcall   get_rejestr             ;Odczyt pamici rejestratora
                jnc     print_rej_2             ;Jeli C=1 to koniec danych
                ljmp    print_rej_end
print_rej_2:    push    ACC                     ;Zapamitaj miesic
                mov     suma_kontrolna,#0       ;Suma kontrolna
                lcall   dodaj_sume
                push    DPH                     ;Zapamitaj DPTR (potrzebny dla "get_rejestr")
                push    DPL
                mov     DPL,nr_linii_l          ;Druk Liczby porzdkowej
                mov     DPH,nr_linii_h
                mov     B,#4
                lcall   print_dptr_NZ
                pop     DPL
                pop     DPH
                pop     ACC                     ;Odtwrz miesic
                lcall   print_spc               ;Data
                lcall   print_hex
                mov     a,#"/"
                lcall   print_char
                lcall   get_rejestr
                lcall   print_hex

                lcall   print_spc               ;Godzina
                lcall   get_rejestr
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                lcall   get_rejestr
                lcall   print_hex

                lcall   print_spc               ;Wybrany numer
                mov     R7,#(buf_cyf_end-buf_cyf_str)/2 ;Licznik obiegw (liczba cyfr/2)
                mov     R0,#buf_cyf_str         ;Adres bufora cyfr
print_rej_3:    lcall   get_rejestr
                lcall   print_hex_spec__        ;Na RS
                push    ACC                     ;Zapisz do bufora aby ztaryfikowa
                rr      a
                rr      a
                rr      a
                rr      a
                anl     a,#$0f
                mov     @R0,a
                inc     R0
                pop     ACC
                anl     a,#$0f
                mov     @R0,a
                inc     R0
                djnz    R7,print_rej_3

                push    DPH                     ;Zapamitaj DPTR (potrzebny dla "get_rejestr")
                push    DPL
                lcall   okresl_taryfe           ;Okreli taryf
                mov     DPL,nr_prefiksu
                mov     DPH,#0
                lcall   read_prefiks            ;Wczytaj prefiks do RAM
                lcall   print_spc               ;nr taryfy
                mov     a,pref_taryfa
                lcall   print_hex
                lcall   print_spc               ;Nazwa miejscowoci
                lcall   print_nazwa_prefiksu
                pop     DPL
                pop     DPH

                lcall   print_spc               ;Czas trwania
                lcall   get_rejestr
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                lcall   get_rejestr
                lcall   print_hex
                mov     a,#"."
                lcall   print_char
                lcall   get_rejestr
                lcall   print_hex

                lcall   print_spc               ;Licznik
                lcall   get_rejestr
                mov     R5,a                    ;Zapamitaj starszy licznika
                mov     R7,#0                   ;najstarsze=0
                mov     R6,#0
                lcall   get_rejestr
                mov     R4,a                    ;Zapamitaj modszy licznika

                push    DPH                     ;Zapamitanie DPTR (potrzebny dla "get_rejestr")
                push    DPL
                mov     DPH,R5                  ;Do dptr stan licznika
                mov     DPL,R4
                mov     B,#4                    ;Liczba pozycji do wywietlenia
                lcall   print_dptr_NZ           ;wywietlenie
                lcall   print_spc
                mov     B,#10                   ;Liczba pozycji do wywietlenia
                lcall   print_cena_licznika     ;Oblicza i wywietla cen rozmowy
                mov     R7,suma_kontrolna       ;Zapamitaj obliczon sum kotroln w R7
                lcall   get_rejestr             ;Odczytaj sum kontroln
                cjne    a,RR7,print_rej_51      ;porownaj sum kontroln o obliczon
                sjmp    print_rej_52            ; - dobra to skacz
print_rej_51:   mov     dptr,#txt_err_rejestr   ; - za to daj komunikato "-err"
                lcall   print_text
print_rej_52:   pop     DPL                     ;odtworzenie dptr
                pop     DPH

                mov     a,nr_linii_l            ;Next nr lini
                add     a,#1
                da      a
                mov     nr_linii_l,a
                mov     a,nr_linii_h
                addc    a,#0
                mov     nr_linii_h,a
                lcall   print_crlf              ;Next linia na wydruku

                lcall   czy_break               ;Czy przerwano wydruk ?
                jc      print_rej_end           ; tak

                jb      FL_PRT_ALL,print_rej_6    ;Czy wydfruk take skasowynych ?
                lcall   next_rekord               ;- nie wic Next rekord
                ljmp    print_rej_1               ;  i skok
print_rej_6:    lcall   next_rekord               ;- tak wic Next rekord
                jc      print_rej_end             ;  a skok tylko dgy nie przekroczono
                ljmp    print_rej_1               ;  ostatniego adresu bufora rozmow

         ;--- Koniec wydruku rejestratora -----
print_rej_end:  jb      FL_PRT_ALL,print_rej_end1 ;Czy wydruk take skasowynych ?
                mov     dptr,#txt_rejestr_2       ; jeli tak to pomin wydruk sumy
                lcall   print_text
                lcall   oblicz_licznik          ;Oblicza stan licznika
                lcall   zeruj_resld
                mov     a,R7                    ;Wywietla Sum licznikw
                lcall   depack_bcd
                mov     resld+7,B
                mov     resld+6,a
                mov     a,R6
                lcall   depack_bcd
                mov     resld+5,B
                mov     resld+4,a
                mov     a,R5
                lcall   depack_bcd
                mov     resld+3,B
                mov     resld+2,a
                mov     a,R4
                lcall   depack_bcd
                mov     resld+1,B
                mov     resld+0,a
                mov     B,#8                    ;Liczba pozycji do wywietlenia
                lcall   print_resld_NZ

                lcall   print_spc               ;Spacja
                mov     B,#10                   ;Liczba pozycji do wywietlenia
                lcall   print_cena_licznika

print_rej_end1: lcall   print_crlf              ;Wysu wiersz
                ljmp    print_rs_end            ;Napis "Koniec.."
                                        ;<--- zastpuje RET

txt_rejestr_1:  BYTE    CR_ASCII,LF_ASCII
                STRING  'Wydruk danych rejestratora'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Lp.  Data  Godz  Nr telefonu Tar Strefa    Czas     Licznik     Cena'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    REPEAT_ASCII,68,"-"             ;68 znakw "-"
                BYTE    CR_ASCII,LF_ASCII,0

txt_rejestr_2:  BYTE    CR_ASCII,LF_ASCII
                BYTE    REPEAT_ASCII,42," "             ;42 spacje
                STRING  'Suma: '
                BYTE    0

txt_bufor_empty:BYTE    CR_ASCII,LF_ASCII
                STRING  'Bufor pusty!'
                BYTE    0

txt_err_rejestr:STRING  ' - Err'
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Na podstawie stanu licznika (upakowane BCD w R7...R4) i ceny impulsu
;      oblicza i wywietla koszt poczenia
;we: B  - liczba pozycji (cyfr) do wywietlenia (doda naley znak ",")
;         jeli najstarszy B=1 to dosunicie do lewej
;    R7 - najstarszy upakowany BCD bajt licznika
;    R6
;    R5
;    R4 - najmodszy upakowany BCD bajt licznika
;
print_cena_licznika:
                push    B                       ;Zapamitaj liczb pozycji
                mov     a,R7                    ;Zapamitaj starszy licznika
                lcall   zeruj_resld
                lcall   depack_bcd              ; w buforze do konwersji
                mov     resld+7,B               ;BCD->HEX
                mov     resld+6,a
                mov     a,R6                    ;Zapamitaj kolejny licznika
                lcall   depack_bcd              ; w buforze do konwersji
                mov     resld+5,B               ;BCD->HEX
                mov     resld+4,a
                mov     a,R5                    ;Zapamitaj kolejny licznika
                lcall   depack_bcd              ; w buforze do konwersji
                mov     resld+3,B               ;BCD->HEX
                mov     resld+2,a
                mov     a,R4                    ;Zapamitaj kolejny licznika
                lcall   depack_bcd              ; w buforze do konwersji
                mov     resld+1,B               ;BCD->HEX
                mov     resld+0,a
                lcall   bcdhex                  ;Konwersja BCD->HEX
                mov     arg1+3,resl+3           ;Wynik konwersji do arg1
                mov     arg1+2,resl+2
                mov     arg1+1,resl+1
                mov     arg1+0,resl+0
                lcall   cena_do_arg2            ;Cena impulsu do arg2
                lcall   mul32                   ;Mnoymy liczb impulsw przez cen
                lcall   hexbcd                  ;konwersja HEX->BCD
                pop     B                       ;Odtworz liczb pozycji
                lcall   druk_cena_z_resld_NZ    ;Drukowanie ceny z "resld"
 IF SAA1064=YES          ;Dla SAA1064 wywietlamy koszt poczenia take na LED
                mov     a,std_out
                cjne    a,#STD_OUT_LCD,exit_cena;Jeli wyjcie na LCD to obsuguj, jeli nie to olej procedur
                clr     ET0                     ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                     ; poniewarz na irq wystpuj
                lcall   iic_init
                mov     a,resld+5
                lcall   konw_led
                mov     R4,a
                mov     a,resld+4
                lcall   konw_led
                mov     R5,a
                mov     a,resld+3
                lcall   konw_led
                mov     R6,a
                mov     a,resld+2
                lcall   konw_led
                setb    ACC.7                   ; kropka
                mov     R7,a
                lcall   saa3
                lcall   iic_init
                mov     a,resld+1
                lcall   konw_led
                mov     R4,a
                mov     a,resld
                lcall   konw_led
                mov     R5,a
                lcall   saa4
                lcall   iic_init
                setb    ET0                     ;Przywrcenie przerwa
                setb    EX0
exit_cena:      ret
 ENDI
                ret

;----------------------------------------------------------------------------
;Wywietla cen z bufora "resld"
; zera nieznaczce s pomijane (wygaszone w ich miejsce spacja)
;we: B     - liczba pozycji (cyfr) do wywietlenia
;            w rzeczywistoci bdzie o jeden znak wicej (doda naley znak ",")
;            jeli najstarszy B=1 to dosunicie do lewej
;    resld - liczby w nieupakowane BCD
;
druk_cena_z_resld_NZ:
                clr     F1                      ;Dosunicie do prawej czy lewej?
                jnb     B.7,druk_cena0
                setb    F1
druk_cena0:     mov     a,B                     ;Obcicie najstarszego
                anl     a,#%0111111
                mov     B,a
                mov     a,#resld-1              ;Adres bufora cyfr
                add     a,B                     ;Obliczenie koca bufora
                mov     R0,a
                setb    F0                      ;Znacznik wygaszenia zera (F0=1 - wyga)
druk_cena1:     mov     a,@R0
                jnb     F0,druk_cena3           ;Znacznik skasowany czyli nie wygaszaj
                jz      druk_cena4              ;Cyfra rwna zero wic skocz
                clr     F0                      ;Cyfra rna od zera, wic ustaw niewygaszaj
                sjmp    druk_cena3              ; i wydrukuj cyfr
druk_cena4:     mov     a,B                     ;Sprawd czy moe trzeci od koca znak
                cjne    a,#3,druk_cena6         ; nie wic drukuj spacj
                clr     F0                      ; trzeci od koca wic ustaw niewygaszaj
                mov     a,#"0"                  ; wywietl zero
                sjmp    druk_cena3              ; i skacz dalej
druk_cena6:     jb      F1,druk_cena5           ;jeli dosunicie do lewej nie wywietlaj spacji
                lcall   print_spc               ;Drukuj spacj
                sjmp    druk_cena5              ; i skacz dalej
druk_cena3:     lcall   print_nible
druk_cena5:     mov     a,R0                    ;Czy drukowa kropk dziesitn ?
                clr     C
                subb    a,#resld
                cjne    a,#2,druk_cena2
                mov     a,#","
                lcall   print_char
druk_cena2:     dec     R0
                djnz    B,druk_cena1
                ret

;----------------------------------------------------------------------------
;Kopiuje cen impulsu do "adr2" w kodze HEX
;
cena_do_arg2:   mov     a,cena_zl               ;Cena impulsu
                lcall   depack_bcd
                lcall   zeruj_resld
                mov     resld+3,B
                mov     resld+2,a
                mov     a,cena_gr
                lcall   depack_bcd
                mov     resld+1,B
                mov     resld+0,a
                lcall   bcdhex                  ;Konwersja BCD->HEX
                mov     arg2+3,resl+3           ;Wynik konwersji do arg2
                mov     arg2+2,resl+2
                mov     arg2+1,resl+1
                mov     arg2+0,resl+0
                ret

;----------------------------------------------------------------------------
;Opis: Przeswa wskanik w pamici eeprom (jak "get_rejestr" ale nie czyta)
;we: B       - o ile przesun
;    "rej_l" - modszy modszy wskanika
;    "rej_h" - starszy starszy wskanika
;wy: "rej_l" - wskanik na kolekny bajt
;    "rej_h" - wskanik na kolekny bajt
;zmienia: PSW, "rej_l", "rej_h"
;
next_rejestr:   push    ACC
                mov     a,rej_l
                add     a,B
                mov     rej_l,a
                mov     a,rej_h
                addc    a,#0
                mov     rej_h,a
                pop     ACC
                ret

;============================================================================
;Opis: Drukuje tablic taryf
;we: --
;wy: --
;zmiania:
;
print_taryfy:   lcall   lcd_drukowanie                  ;Napis "Drukowanie..."
                push    std_out                         ;Zapamitaj std_out
                mov     std_out,out_device              ;Ustaw urzdzenie wyjciowe
                lcall   print_crlf                      ;Drukuj dat i czas
                lcall   print_data_czas
                mov     dptr,#txt_taryfy_1              ;Linia pierwsza
                lcall   print_text
                lcall   print_taryfy_t                  ;Tablica taryf
                lcall   print_rs_end                    ;Napis ":END"
                lcall   auto_feed                       ;Wysw papieru
                pop     std_out                         ;odtwrz std_out
                ret

;----------------------------------------------------------------------------
;Opis: Drukuje tablic taryf
;
print_taryfy_t: mov     R0,#0                   ;Nr rekordu taryfy

print_tar_1:    lcall   czy_break               ;Czy przerwano wydruk ?
                jc      print_tar_end           ; tak
                lcall   wylicz_adres_taryfy     ;Oblicza adres tablicy taryf w EEPROm
                                                ; na podstawie nr rekoru w R0
                lcall   read_eeprom             ;Pobierz bajt
                cjne    a,#END_TARYFA,print_tar_2 ;Sprawd czy konic tablicy
                sjmp    print_tar_end             ; - tak koniec wic wyjd
print_tar_2:    push    ACC                     ;Zapamitaj taryf
                mov     a,#"t"                  ;Drukuje napis ": t"
                lcall   print_char
                pop     ACC                     ;Drukuj taryf
                lcall   print_hex
                lcall   print_spc               ;Drukuj godzin
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex       ;<--- Zastpuje RET

                mov     a,#3                    ;Drukuj okres zaliczania
                lcall   print_spacje
                inc     dptr
                lcall   read_eeprom
                lcall   print_nible             ;najstarsze zero olewamy
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex
                mov     a,#","
                lcall   print_char
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex

                mov     a,#4                    ;Drukuj okres zaliczania
                lcall   print_spacje            ; dla dni witecznych
                inc     dptr
                lcall   read_eeprom
                lcall   print_nible             ;najstarsze zero olewamy
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex
                mov     a,#","
                lcall   print_char
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex

                lcall   print_crlf               ;Next linia

                inc     R0                      ;Next rekord
                sjmp    print_tar_1

print_tar_end:  ret

;----------------------------------------------------------------------------
txt_taryfy_1:   BYTE    CR_ASCII,LF_ASCII
                STRING  '#83'
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Taryfy'
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Nr Godz Dni powsz Dni wit'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    REPEAT_ASCII,29,"-"             ;29 znakw "-"
                BYTE    CR_ASCII,LF_ASCII,0

;============================================================================
;Opis: Drukuje tablic prefiksw
;we: "std_out" (gdzie drukowa)
;wy: --
;zmiania:
;
print_prefiksy: lcall   lcd_drukowanie                  ;Napis "Drukowanie..."
                push    std_out                         ;Zapamitaj std_out
                mov     std_out,out_device              ;Ustaw urzdzenie wyjciowe
                lcall   print_crlf                      ;Drukuj dat i czas
                lcall   print_data_czas
                mov     dptr,#txt_prefiksy_1            ;Linia pierwsza
                lcall   print_text
                lcall   print_prefiksy_t                ;Tablica prefiksw
                lcall   print_rs_end                    ;Napis ":END"
                lcall   auto_feed                       ;Wysw papieru
                pop     std_out                         ;odtwrz std_out
                ret

;----------------------------------------------------------------------------
;Opis: Drukuje tablic prefiksw
;
print_prefiksy_t:
                mov     R2,#0                           ;Nr rekordu prefiksu

print_pref_1:   lcall   czy_break                       ;Czy przerwano wydruk ?
                jc      print_pref_end                  ; tak
                lcall   print_pref_NR_R2                ;Drukuje nr prefiksu
                jc      print_pref_end                  ; jeli ostatni to wyjcie
                lcall   print_spc                       ;Drukuj Opis
                inc     dptr
                lcall   print_nazwa_prefiksu_2
                lcall   print_crlf                      ;Next linia
                inc     R2                              ;Next rekord
                sjmp    print_pref_1
print_pref_end: ret

;----------------------------------------------------------------------------
;Opis: Drukuje nr prefiksu
;wy: C - (C=0 ok, C=1 koniec tablicy
;
print_pref_NR_R2:
                lcall   wylicz_adres_prefiksu           ;Obliczanie adresu w EEPROM
                                                        ; na podstawie nr rekordu
                lcall   read_eeprom                     ;Pobierz bajt
                cjne    a,#END_PREFIKS,print_pref_2     ;Sprawd czy konic tablicy
                setb    C                               ; - tak koniec wic wyjd
                ret
print_pref_2:   push    ACC                             ;Zapamitaj taryf na STOSIE
                mov     a,#SNG_PREFIKS
                lcall   print_char

                inc     dptr                            ;Drukuj prefiks
                lcall   read_eeprom
                lcall   print_hex_spec__
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex_spec__
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex_spec__
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex_spec__
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex_spec__
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex_spec__
                lcall   print_spc                       ;Drukuj Taryf
                pop     ACC                             ;Odtwrz ze stosu
                lcall    print_hex
                clr     C
                ret

;----------------------------------------------------------------------------
txt_prefiksy_1: BYTE    CR_ASCII,LF_ASCII
                STRING  '#82'
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Prefiksy'
                BYTE    CR_ASCII,LF_ASCII
                STRING  '   Nr         Tar Opis'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    REPEAT_ASCII,21,"-"             ;21 znakw "-"
                BYTE    CR_ASCII,LF_ASCII,0

;============================================================================
;Drukuje nible w postaci HEX (Drukuje "#", "*" dla pozostaych "_")
;Wejcie: ACC - kod znaku
;Wyjcie: --
;zmienia: PSW
;
print_nible_spec__:
                push    ACC                     ;Ochrona rejestrw
                push    DPL
                push    DPH
                sjmp    print_hex_spec1

;----------------------------------------------------------------------------
;Drukuje bajt w postaci HEX (Dla $F drukuje "_")
;Wejcie: ACC - kod znaku
;Wyjcie: --
;zmienia: PSW
;
print_hex_spec__:
                push    ACC                     ;Ochrona rejestrw
                push    DPL
                push    DPH
                push    ACC
                rr      a
                rr      a
                rr      a
                rr      a
                anl     a,#$f
                mov     dptr,#znaki_kowersji_spec__
                movc    a,@a+dptr
                lcall   print_char
                pop     ACC
print_hex_spec1:anl     a,#$f
                mov     dptr,#znaki_kowersji_spec__
                movc    a,@a+dptr
                lcall   print_char
                pop     DPH
                pop     DPL
                pop     ACC
                ret

znaki_kowersji_spec__:
                STRING  '0123456789A*#DE_'

;----------------------------------------------------------------------------
;Drukuje bajt w postaci HEX  (Dla $F drukuje " ")
;Wejcie: ACC - kod znaku
;Wyjcie: --
;zmienia: PSW
;
print_hex_spec_spc:
                push    ACC                     ;Akumulator na stos
                push    DPL
                push    DPH
                push    ACC
                rr      a
                rr      a
                rr      a
                rr      a
                anl     a,#$f
                mov     dptr,#znaki_kowersji_spec_spc
                movc    a,@a+dptr
                lcall   print_char
                pop     ACC
                anl     a,#$f
                mov     dptr,#znaki_kowersji_spec_spc
                movc    a,@a+dptr
                lcall   print_char
                pop     DPH
                pop     DPL
                pop     ACC                     ;Akumulator ze stosu
                ret

znaki_kowersji_spec_spc:
                STRING  '0123456789A*#DE '

;----------------------------------------------------------------------------
;Opis: Konwertuje znaki wychodzce jeli PL
;we: ACC - znak do skonwertowania
;wy: ACC - znak po skonwertowaniu
;zmienia: PSW
;
DLUG_TAB_PL     equ     13                              ;Dugo 1-go wiersza tablicy
;
konw_outPL:     push    DPH
                push    DPL
                push    B
                push    RR0

                mov     B,a                             ;Zapamitaj znak w B
                mov     dptr,#tab_pl                    ;Adres tablicy znakw
                mov     R0,#DLUG_TAB_PL                 ;Licznik obiegw (dugo wiersza tablicy)
konw_outPL_1:   clr     a                               ;Pobierz znak z tablicy
                movc    a,@a+dptr
                cjne    a,B,konw_outPL_2                ;Jeli to nie szukany znak to skocz
                lcall   konw_outPL_zm                   ; - tak wic konwertuj
                clr     a                               ;Pobierz nowy kod znaku
                movc    a,@a+dptr
                sjmp    konw_outPL_exit                 ; i wyjd

konw_outPL_2:   inc     dptr                            ;next znak
                djnz    R0,konw_outPL_1
                mov     a,B                             ;Nie znaleziono znaku wic wyjcie bez zmian

konw_outPL_exit:pop     RR0
                pop     B
                pop     DPL
                pop     DPH
                ret


konw_outPL_zm:  mov     R0,#DLUG_TAB_PL*1               ;Jeli bez standardu ustaw ofset na 2-ugi wiersz tablicy
                mov     a,std_pl                        ;Jaki standard polskich znakw ?
                cjne    a,#AMIGA_PL,konw_outPL_zm_1     ;Jeli AmigaPL ustaw ofset na 3-eci wiersz tablicy
                mov     R0,#DLUG_TAB_PL*2
konw_outPL_zm_1:cjne    a,#WINDOWS_PL,konw_outPL_zm_2   ;Jeli Windows ustaw ofset na 4-ty wiersz tablicy
                mov     R0,#DLUG_TAB_PL*3
konw_outPL_zm_2:cjne    a,#MAZOWIA_PL,konw_outPL_zm_3   ;Jeli Mazowia ustaw ofset na 5-ty wiersz tablicy
                mov     R0,#DLUG_TAB_PL*4
konw_outPL_zm_3:mov     a,DPL                           ;Dodaj ofset
                add     a,R0
                mov     DPL,a
                mov     a,DPH
                addc    a,#0
                mov     DPH,a
                ret

        ;     08  01  02  03  04  05  06  07  0a  0d  fe  fd  fc
        ;     61  65  63  6c  6e  6f  73  7a  0a  0d  0d  0d  0c
tab_pl: BYTE "","","","","","","","",LF_ASCII,CR_ASCII,CLS_ASCII,HOME_ASCII,FEED_ASCII  ;Kody w rdwce
        BYTE "a","e","c","l","n","o","s","z",      10,      13,       13,        13,        12  ;Kody Bez polskich
        BYTE $E2,$EB,$EA,$EE,$EF,$F3,$F4,$FB,      10,      13,       10,        10,        12  ;Kody AmigaPL
        BYTE $B9,$EA,$E6,$B3,$F1,$F3,$9C,$BF,      10,      13,       13,        13,        12  ;Kody Windows
        BYTE $86,$91,$8D,$92,$A4,$A2,$9E,$A7,      10,      13,       13,        13,        12  ;Kody Mazowia

;----------------------------------------------------------------------------
;Opis: Konwertuje znak przychodzce jeli PL
;we: ACC - znak do skonwertowania
;wy: ACC - znak po skonwertowaniu
;zmienia: PSW
;
konw_inPL:      push    DPH
                push    DPL
                push    B
                push    RR0
                push    RR7

                mov     B,a                             ;Zapamitaj znak w B
                mov     a,std_pl                        ;Jeli bez pl to pomi konwersj
                cjne    a,#BEZ_PL,konw_inPL_0           ; w przeciwnym wypadku "a" bedzie zastpienie przez ""
                sjmp    konw_inPL_no                    ; "e" przez "", "c" przez "" itd
konw_inPL_0:    mov     dptr,#tab_pl                    ;Adres tablicy znakw
                lcall   konw_outPL_zm                   ;Dodaj ofset zaleny od wybranego standardu
                mov     R0,#DLUG_TAB_PL                 ;Licznik obiegw (dugo wiersza tablicy)
                mov     R7,#0                           ;Licznik pozycji
konw_inPL_1:    clr     a                               ;Pobierz znak z tablicy
                movc    a,@a+dptr
                cjne    a,B,konw_inPL_2                 ;Jeli to nie szukany znak to skocz
                mov     a,R7                            ; - tak wic konwertuj
                mov     dptr,#tab_pl                    ;Adres tablicy znakw
                movc    a,@a+dptr                       ;Pobierz nowy kod znaku
                sjmp    konw_inPL_exit                  ; i wyjd

konw_inPL_2:    inc     dptr                            ;next znak
                inc     R7
                djnz    R0,konw_inPL_1
konw_inPL_no:   mov     a,B                             ;Nie znaleziono znaku wic wyjcie bez zmian

konw_inPL_exit: pop     RR7
                pop     RR0
                pop     B
                pop     DPL
                pop     DPH
                ret

;============================================================================
;=                          Procedury obsugi portu RS                      =
;============================================================================
;Obsuga przerwania portu RS
; jeli przyszed znak to wysanie do bufora
;
irq_rs:         push    PSW
                push    ACC
                push    B
                push    RR0
                push    RR1
                push    RR2
                push    RR3
                push    RR4
                push    RR5
                push    RR6
                push    RR7
                push    DPH
                push    DPL

                jb      TI,irq_rs_tx             ;Jei przerwanie odbiorcze
                                                 ; to obsu
                mov     a,SBUF                   ;pobierz znak i zapamitaj w ACC
                clr     RI                       ;Potwierd odbir
                lcall   write_fifo               ;Zapisz bajt do FIFO

irq_rs_exit:    lcall   reset_watchdog
                pop     DPL
                pop     DPH
                pop     RR7
                pop     RR6
                pop     RR5
                pop     RR4
                pop     RR3
                pop     RR2
                pop     RR1
                pop     RR0
                pop     B
                pop     ACC
                pop     PSW
                reti

irq_rs_tx:      setb    FL_TXEMPTY              ;Ustaw znacznik "bufor odbiorczy pusty"
                clr     TI                      ;Kasuj przerwania
                sjmp    irq_rs_exit             ;Wyjd z IRQ

;--------------------------------------
;Opis: Odczytuje bajt z bufora FIFO. Jeli bufor pusty to wychodzi
;      z procedury z zerowanym bitem C w PSW
;we: --
;wy: ACC - odczytany bajt
;    C   - wynik opwercji: C=0 bufor pusty
;                          C=1 OK
;zmienia: ACC, B, PSW
;
read_fifo:      push    B                       ;Zapamitaj B
                push    RR0                     ;Zapamitaj R0

                mov     a,status_fifo           ;Czy wystpiy bdy ?
                cjne    a,#ERROR_OK,fifo_error  ; - tak, wic stacz
                clr     ES                      ;Wyczenie przerwa z RS'a
                mov     a,licznik_fifo          ;Czy s bajty w FIFO ?
                cjne    a,#0,read_fifo_l1       ; - tak
                clr     C                       ; - nie, wic wyjd z C=0
read_fifo_exit: setb    ES                      ;Wczenie przerwa z RS'a
                pop     RR0                     ;Odtwrz R0
                pop     B                       ;Odtwrz B
                ret

read_fifo_l1:   dec     licznik_fifo            ;Zmiejsz licznik bajtw w FIFO
                mov     R0,wsk_fifo_rd          ;Odczytaj bajt z FIFO
                mov     a,@R0
                push    ACC                     ;Zapamitaj bajt na stosie
                inc     wsk_fifo_rd             ;Wskanik odczytu na next bajt w FIFO
                mov     a,wsk_fifo_rd           ;Jeli przekoroczono bufor FIFO
                cjne    a,#buf_fifo_end,read_fifo_l2
                mov     wsk_fifo_rd,#buf_fifo_str  ; to ustaw na pocztek

read_fifo_l2:   pop     ACC                     ;Odczytaj bajt ze stosu
                setb    C                       ;Wyjd z C=1
                sjmp    read_fifo_exit

;-----------------------
fifo_error:     mov     std_out,#STD_OUT_LCD
                lcall   print_err
                mov     dptr,#txt_err_fifo
                lcall   print_text
                ljmp    wait_error       ;<---- Zastpuje RET

txt_err_fifo:   STRING  'FIFO'
                BYTE    0

;--------------------------------------
;Opis: Zapisuje bajt do bufora FIFO. Jeli bufor peny to wychodzi
;      z procedury z ustwionym bitem C w PSW
;we: ACC - bajt do zapsiu
;wy: C   - wynik opwercji: C=1 bufor peny
;                          C=0 OK
;zmienia: ACC, R0, PSW
;
write_fifo:     mov     R0,wsk_fifo_wr          ;Zapisz bajt do FIFO
                mov     @R0,a
                inc     wsk_fifo_wr             ;Wskanik zapisu na next bajt w FIFO
                mov     a,wsk_fifo_wr           ;Jeli przekoroczono bufor FIFO
                cjne    a,#buf_fifo_end,write_fifo_l1
                mov     wsk_fifo_wr,#buf_fifo_str  ; to ustaw na pocztek

write_fifo_l1:  inc     licznik_fifo            ;Zwiksz licznik zapisanych bajtw w FIFO
                mov     a,licznik_fifo          ;Jeli przekroczono bufor
                cjne    a,#buf_fifo_end-buf_fifo_str,write_fifo_l2
                mov     status_fifo,#ERROR_FULL ;komunikuj bufor peny
                setb    C
                ret

write_fifo_l2:  clr     C                       ;komunikuj zapis do fifo OK
                ret

;--------------------------------------
;Opis: Inicjalizacja bufora FIFO
;
init_fifo:      mov     licznik_fifo,#0         ;Licznik zapisanych bajtow FIFO
                mov     status_fifo,#ERROR_OK   ;Status FIFO
                mov     wsk_fifo_wr,#buf_fifo_str
                mov     wsk_fifo_rd,#buf_fifo_str
                ret

;----------------------------------------------------------------------------
init_16khz:     clr     FL_16KHZ                ;Zeruj znacznik
                setb    IT0                     ;Przerwania z INT 0 po zboczu
                setb	EX0			;Zezwolenie na przerwania
                                                ;  z wejcia INT 0
                clr     IE0                     ;Zeruj znacznik przerwania 16KHZ
                ret

;----------------------------------------------------------------------------
init_dtmf:      clr     FL_DTMF                 ;Zeruj znacznik
                setb    IT1                     ;Przerwania z INT 1 po zboczu
                setb    EX1                     ;Zezwolenie na przerwania
                                                ;  z wejcia INT 1
                clr     IE1                     ;Zeruj znacznik przerwania DTMF
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia prdko transmisji i inicjalizuje sterowik RS
;      prdko transmisji patrz EDW 4/98 str.39
;we: --
;wy: --
;zmienia: PSW
;
init_rs:	mov	SCON,#$50       	;Tryb 3, zezwolenie odbioru
		orl	PCON,#$80		;SMOD=1
                anl     TMOD,#%00001111         ;Timera 0 nie ruszamy
		orl	TMOD,#%00100000		;Tryb 2 Timera 1 (Timer 1 dla RS)

		mov	TH1,#b2400		; - prdko transmisji 2400
		mov	TL1,#b2400

                setb	TR1			;Start timera
                setb    FL_TXEMPTY              ;Ustaw znacznik "bufor odbiorczy pusty"
                setb    ES                      ;Zezwolenie na przerwania z RS
        	ret

;----------------------------------------------------------------------------
;Opis: procedura oczekiwania na znak z portu szeregowego;
;      przed wywolaniem jej nalezy odpowiednio skonfigurowac
;      rejestry SMOD oraz okreslic predkosc transmisji
;we: -
;wy: gdy C=0 to zakonczenie poprawne i w Acc odebrany znak;
;    gdy C=1 to przekroczenie maksymalnego czasu oczekiwania
;    okreslonego w zmiennej 'overconst'
;zmienia: PSW, ACC
;
in_rs:          mov     overtime,#OVER_CONST    ;ustawienie czasu oczekiwania
in_rs_wait:     lcall   reset_watchdog
                lcall   read_fifo               ;pobiera znak
                jc	in_rs_ok                ;C=1 wic odebrano znak
                mov     a,overtime              ;sprawdzenie czy mnin
                jnz     in_rs_wait              ; czas oczekiwania "OVER_CONST"
                setb    C                       ;czas min - znacznik C ustaw.
                ret
in_rs_ok:       lcall   konw_inPL
                clr     C                       ;OK znacznik C=0
                ret

;--------------------------------------
;Opis: procedura oczekiwania na znak z portu szeregowego;
;      procedura czeka do bulu, wyjcie tylko, gdy przyjdzie znak po RS
;we: -
;wy: w ACC odczytany bajt
;
in_rs_notime:   lcall   read_fifo               ;Jak wyej tyle, e czeka do bulu
                jnc     in_rs_notime            ;C=0 wic nie ma znaku
                sjmp    in_rs_ok

;----------------------------------------------------------------------------
;Opis: Czeka na dwa bajty w kodach ascii z RS w wyniku zwraca zdekodowany bajt
;      Jeli czeka za dugo to ustawia znacznik C
;      SPACJA jest traktowana jako ZERO
;      znak "_" jako $F
;we: -
;wy: gdy C=0 to zakonczenie poprawne i w Acc odebrany znak;
;    gdy C=1 to przekroczenie maksymalnego czasu oczekiwania
;    okreslonego w zmiennej 'overconst'
;zmienia: PSW, ACC
;
in_2ascii_rs:   push    B
                lcall   in_rs
                jc      in_asc_err
                lcall   ascii_nible
                swap    a                       ;nible na starsz pozycj
                mov     B,a                     ;zapamitanie w B
                lcall   in_rs
                jc      in_asc_err
                lcall   ascii_nible
                orl     a,B                     ;poczenie nibli
                pop     B
                clr     C                       ;Znacznik czas OK
                ret

in_asc_err:     pop     B
                setb    C                       ;Znacznik bdu przekr. czasu
                ret

;----------------------------------------------------------------------------
;Opis: konwertuje ascii na nible (0..9 i A...F) wielko znakw nie ma znaczenia
;      SPACJA jest traktowana jako ZERO
;      znak "_" jako $F
;we: ACC - kod ASCII
;wy: ACC - w modszym nible cyfra HEX (0...F)
;zmienia: PSW, ACC
;
;ascii_nible:    cjne    a,#" ",as_ni__          ;czy spacja ?
;                mov     a,#0                    ; - tak, wic ZERO
;                ret
;as_ni__:        cjne    a,#"_",as_ni_0          ;czy znak "_" ?
;                mov     a,#$F                   ; - tak, wic $F
;                ret
;
;as_ni_0:        cjne    a,#$60,*+3              ;czy wiksze ni $60 ?
;                jnc     as_ni_1
;                cjne    a,#$40,*+3              ;czy wiksze ni $40 ?
;                jnc     as_ni_2
;                clr     C
;                subb    a,#48                   ;cyfra 0..9
;                ret
;as_ni_1:        clr     C
;                subb    a,#97-10                ;litera A...F
;                ret
;as_ni_2:        clr     C
;                subb    a,#65-10                ;litera a...f
;                ret

;============================================================================
;=      Procedury ptli czasowych (niektre koystaj z przerwa)           =
;============================================================================
;Odczekuje czas 100ms * ACC
;Wejcie: ACC - czas * 100ms
;Wyjcie: --
;Zmienia: PSW
;
delay_100ms:    push    ACC
delay_100_l1: ;???  lcall   reset_watchdog
                lcall   wait_100ms      ;Odczekuje czas 100ms * ACC
                djnz    ACC,delay_100_l1
                pop     ACC
                ret

;-----------------------------------------------------------------------------
;Opis: Czeka 100ms. Wymagane wczone przerwania.
;Wejcie: --
;Wyjcie: --
;Zmienia: PSW
;
wait_100ms:	push    ACC
            ;???    lcall   reset_watchdog
                mov     a,#10
wait_100ms_l1:  lcall   idle_10ms	        ;Tryb bezczynnoci 10ms
                djnz    ACC,wait_100ms_l1
                pop     ACC
		ret

;-----------------------------------------------------------------------------
;Opis: Czeka 50ms. Wymagane wczone przerwania.
;Wejcie: --
;Wyjcie: --
;Zmienia: PSW
;
wait_50ms:      push    ACC
           ;???     lcall   reset_watchdog
                mov     a,#5
wait_50ms_l1:   lcall   idle_10ms	        ;Tryb bezczynnoci 10ms
                djnz    ACC,wait_50ms_l1
                pop     ACC
		ret

;----------------------------------------------------------------------------
;Opis: Czeka 10 ms. Wymagane wczone przerwania.
;we: --
;wy: --
;zmienia: PSW
;
wait_10ms:      ljmp    idle_10ms
                ret

;----------------------------------------------------------------------------
;Zawiesza procesor na 10 ms
;
idle_10ms:      clr     FL_IDLE10MS
                lcall   reset_watchdog
                jnb     FL_IDLE10MS,*
                ret

;----------------------------------------------------------------------------
;Opis: Czeka ACC * 1ms.
;we: ACC - czas oczekiwania w ms
;wy: --
;zmienia: PSW
;
delay_1ms:      push    ACC
delay_1ms_1:    lcall   wait_1ms
                djnz    ACC,delay_1ms_1
                pop     ACC
                ret

;----------------------------------------------------------------------------
;Opis: Czeka 1 ms
;we: --
;wy: --
;zmienia: PSW
;
wait_1ms:       push    ACC
                mov     a,#247
                djnz    ACC,*
                mov     a,#247
                djnz    ACC,*
                pop     ACC
                ret

;============================================================================
;=                 Procedury obsugi konfiguracji                           =
;============================================================================
;Opis: Odczytuje konfiguracj z EEPROM do RAM
;
read_konfig:    mov     suma_kontrolna,#0               ;Suma kontrolna
                mov     dptr,#ee_versja
                lcall   read_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_kryterium_rozmowy
                lcall   read_eeprom
                mov     kryterium_rozmowy,a
                lcall   dodaj_sume

                mov     dptr,#ee_cena_gr
                lcall   read_eeprom
                mov     cena_gr,a
                lcall   dodaj_sume

                mov     dptr,#ee_cena_zl
                lcall   read_eeprom
                mov     cena_zl,a
                lcall   dodaj_sume

                mov     dptr,#ee_cena_vat
                lcall   read_eeprom
                mov     cena_vat,a
                lcall   dodaj_sume

                mov     dptr,#ee_kod1
                lcall   read_eeprom
                mov     kod1,a
                lcall   dodaj_sume

                mov     dptr,#ee_kod2
                lcall   read_eeprom
                mov     kod2,a
                lcall   dodaj_sume

                mov     dptr,#ee_ser_pl
                lcall   read_eeprom
                mov     ser_pl,a
                lcall   dodaj_sume

                mov     dptr,#ee_prt_pl
                lcall   read_eeprom
                mov     prt_pl,a
                lcall   dodaj_sume

                mov     dptr,#ee_printer_device
                lcall   read_eeprom
                mov     printer_device,a
                lcall   dodaj_sume

                mov     dptr,#ee_bright_led
                lcall   read_eeprom
                mov     bright_led,a
                lcall   dodaj_sume

                mov     dptr,#ee_suma           ;pobranie sumy kontrolnej
                lcall   read_eeprom
        ;-------- Porwnanie sumy kontrolnej jeli rne to pytanie o inicjalizacj ----
                cjne    a,suma_kontrolna,read_konfig_zla_suma
        ;-------- Porwnanie wersji jeli rne to pytanie czy inicjalizowa ----
                mov     dptr,#ee_versja
                lcall   read_eeprom
                cjne    a,#VERSJA,read_konfig_zla_wersja
                ret

read_konfig_zla_suma:                           ;Ustawienie kodu bdu
                mov     a,#STATUS_SUMA_KONFIGU
                ljmp    ustaw_status    ;<--- Zastpuje RET
read_konfig_zla_wersja:                         ;Ustawienie kodu bdu
                mov     a,#STATUS_WERSJA_KONFIGU
                ljmp    ustaw_status    ;<--- Zastpuje RET

;----------------------------------------------------------------------------
;Opis: Ustawia lini statusu
;we: Acc - bit do ustawienia (maska OR)
;
ustaw_status:   orl     a,linia_statusu
                mov     linia_statusu,a
                ret

;----------------------------------------------------------------------------
;Opis: Wywietla komunikaty bdw w linii statusu (pod godzin)
;
print_status:   mov     a,#$40                  ;Ustaw kursor w drugiej linii
                lcall   curs_set
                mov     a,linia_statusu         ;Jeli status ok to pomi
                cjne    a,#STATUS_OK,print_status_1
                ret
print_status_1: setb    LIGHT                   ;Wcz wywietlacz
                rrc     a
                jnc     print_status_2
                mov     dptr,#txt_konfig_suma
                sjmp    print_status_w
print_status_2: rrc     a
                jnc     print_status_3
                mov     dptr,#txt_taryfy_suma
                sjmp    print_status_w
print_status_3: rrc     a
                jnc     print_status_4
                mov     dptr,#txt_prefiksy_suma
                sjmp    print_status_w
print_status_4: rrc     a
                jnc     print_status_5
                mov     dptr,#txt_konfig_wersja
                sjmp    print_status_w
print_status_5: rrc     a
                jnc     print_status_6
                mov     dptr,#txt_bufor_full
                sjmp    print_status_w
print_status_6: rrc     a
                jnc     print_status_7
                mov     dptr,#txt_bufor_90
                sjmp    print_status_w
print_status_7: ret
print_status_w: lcall   print_text              ; wyswietla tekst
                lcall   wait_100ms              ;Ptla opzniajca
                ret

                        ;1234567890123456
txt_konfig_suma:STRING  'Za suma konfigu'
                BYTE    END_ASCII
txt_taryfy_suma:STRING  'Za suma taryf'
                BYTE    END_ASCII
txt_prefiksy_suma:
                STRING  'Za suma prefiks'
                BYTE    END_ASCII
txt_konfig_wersja:
                STRING  'Za wersja konf.'
                BYTE    END_ASCII
txt_bufor_full: STRING  'Bufor peny'
                BYTE    END_ASCII
txt_bufor_90:   STRING  'Zostao 10% buf.'
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: zapisuje konfig do eeprom
;
write_konfig:   mov     suma_kontrolna,#0       ;Suma kontrolna
                mov     dptr,#ee_versja
                mov     a,#VERSJA
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_kryterium_rozmowy
                mov     a,kryterium_rozmowy
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_cena_gr
                mov     a,cena_gr
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_cena_zl
                mov     a,cena_zl
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_cena_vat
                mov     a,cena_vat
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_kod1
                mov     a,kod1
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_kod2
                mov     a,kod2
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_ser_pl
                mov     a,ser_pl
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_prt_pl
                mov     a,prt_pl
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_printer_device
                mov     a,printer_device
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_bright_led
                mov     a,bright_led
                lcall   write_eeprom
                lcall   dodaj_sume

                mov     dptr,#ee_suma           ;Zapisz sum kontroln
                mov     a,suma_kontrolna
                lcall   write_eeprom

                ret

;----------------------------------------------------------------------------
;Opis: Dodaje bajty sumy kontrolnej:
;we: Acc, suma_kontrolna
;wy: suma_kontrolna
;Zmienia: Acc, suma_kontrolna
;
dodaj_sume:     add     a,suma_kontrolna        ;Dodaj sum kontroln do Acc
                mov     suma_kontrolna,a        ; wynik umie w "sumie_kontrolnek"
                ret

;----------------------------------------------------------------------------
print_overtime: lcall   print_err
                mov     dptr,#txt_overtime
                ljmp    print_text                ;<--- zastpuje RET

txt_overtime:   STRING  'Czas'
                BYTE    CR_ASCII,LF_ASCII,0

;----------------------------------------------------------------------------
print_rs_syntax:lcall   print_crlf
                lcall   print_err
                mov     dptr,#txt_syntax                ;Bd skadni!
                ljmp    print_text                ;<--- zastpuje RET

txt_syntax:     STRING  'Skadnia'
                BYTE    CR_ASCII,LF_ASCII,0

;============================================================================
;=                       Sprawdza RS'a                                      =
;============================================================================
sprawdz_rs:     mov     a,licznik_fifo                  ;Czy s bajty w FIFO ?
                cjne    a,#0,spr_rs_next                ; - tak
spr_rs_exit:    mov     std_out,#STD_OUT_LCD            ;Przywroc wywietlanie na LCD
                ret
spr_rs_next:
                lcall   in_rs                           ;Pobiera znak
                cjne    a,#"#",sprawdz_rs               ;Jeli znak inny ni "#"
                                                        ; sprawdzaj bufor a bdzie pusty
                clr     BLK
                mov     std_out,#STD_OUT_SER    ;Podprogramy na RS
                mov     out_device,#STD_OUT_SER ;Wydruki na RS
                lcall   lcd_drukowanie          ;Na LCD napis "Obsuga RS..."

        ;-------- Dekodowanie rozkazu i wykonanie -----
                lcall   print_crlf
                lcall   print_crlf
                lcall   in_2ascii_rs            ;Czeka na nr programu
                jc      print_overtime          ;Drukuje tekst i RET
                lcall   prog_wykonaj            ;Wykonaj wybrany podprogram
                jnc     spr_rs_exit             ; wykonano program wic wyjcie
                                                ; nie byo programu wic sprawd tylko dla RS
                cjne    a,#$82,spr_rs_82        ;Jeli "#82" to wczytaj prefiksy
                lcall   load_prefiksy_rs
                lcall   sortuj_prefiksy
                lcall   generuj_sume_prefiksow  ;Wygenerowanie sumy kontrolnej
                lcall   print_ok
                ljmp    spr_rs_exit

spr_rs_82:      cjne    a,#$83,spr_rs_83        ;Jeli "#83" to wczytaj taryfy
                lcall   load_taryfy_rs          ;adowanie taryf
                lcall   sortuj_taryfy           ;Sortowanie
spr_rs_821:     lcall   generuj_sume_taryf      ;Wygenerowanie sumy kontrolnej
                lcall   print_ok                ; jeli dobra suma to OK
                ljmp    spr_rs_exit

spr_rs_83:
spr_rs_syntax:  lcall   print_rs_syntax         ;Nie rozpoznano programu wic bd
                mov     std_out,#STD_OUT_SER    ;Wywietla cigawk
                lcall   print_crlf
                mov     R1,#0                   ;Wskanik na tekst nr 0
spr_rs_l1:      lcall   wys_txt_menu            ;wywietl tekst
                jc      spr_rs_l2               ;Jeli koniec tekstu to skocz
                inc     R1                      ;Nastpny tekst
                sjmp    spr_rs_l1               ;i ptla
spr_rs_l2:
                ljmp    spr_rs_exit             ;oraz wyjcie

;----------------------------------------------------------------------------
;Opis: Drukuje napis "Koniec wydruku" (na PRT lub RS) i czyci wywietlacz LCD
;
print_rs_end:   mov     dptr,#txt_rs_end
                lcall   print_text
lcd_drukowanie_end:
                lcall   curs_off
                ljmp    cls             ;<--- zastpuje RET


txt_rs_end:     BYTE    CR_ASCII,LF_ASCII
                BYTE    CR_ASCII,LF_ASCII
txt_koniec:     STRING  'Koniec'
                BYTE    CR_ASCII,LF_ASCII
                BYTE    CR_ASCII,LF_ASCII,0


;----------------------------------------------------------------------------
;Opis: Oblicza sum kontroln i zapisuje do eeprom,czyci lini statusu
;
generuj_sume_prefiksow:
                lcall   suma_tprefiks
                mov     a,suma_kontrolna
                lcall   write_eeprom
                ljmp    init_status             ;<--- Zastpuje RET

;----------------------------------------------------------------------------
;Opis: Oblicza sum kontroln tablicy prefiksw i porwnuje z zapisan
;      jeli rne ustawia znacznik STATUS_SUMA_PREFIKS
;      Po wyjciu z procedury DPTR wskazuje adres w eeprom komrki sumy kontrolnej
;      natomiast w "suma_kontrolna" znajduje si wyliczona suma kontrolna
;
suma_tprefiks:  mov     suma_kontrolna,#0               ;Inicjalizacja sumy kontrolnej
                mov     R2,#0                           ;Zerowanie licznika rekordw
suma_prefiks_1: lcall   wylicz_adres_prefiksu           ;Ustawienie na pocztek rekordu tablicy
                lcall   read_eeprom                     ;Czytaj bajt
                inc     dptr
                cjne    a,#END_PREFIKS,suma_prefiks_3   ;Czy Koniec tablicy prefiksw
                lcall   read_eeprom                     ;Czytaj sum kontroln
                cjne    a,suma_kontrolna,suma_prefiks_2 ;Porwnaj sum kontroln
                ret                                     ;Ok wic wyjcie
suma_prefiks_2: mov     a,#STATUS_SUMA_PREFIKSOW        ;le wic ustaw znacznik
                ljmp    ustaw_status            ;<--- Zastpuje RET
suma_prefiks_3: lcall   dodaj_sume                      ;Cig dalszy po "read_eeprom"
                mov     R7,#15                          ;Odczytaj dane do obliczenia sumy
suma_prefiks_4: lcall   read_eeprom                     ; tylko 15 poniewa 1 by ju odczytany
                inc     dptr
                lcall   dodaj_sume
                djnz    R7,suma_prefiks_4
                inc     R2                              ;Next nr rekordu
                sjmp    suma_prefiks_1

;----------------------------------------------------------------------------
;Opis: Oblicza sum kontroln i zapisuje do eeprom,czyci lini statusu
;
generuj_sume_taryf:
                lcall   suma_ttaryf
                mov     a,suma_kontrolna
                lcall   write_eeprom
                ljmp    init_status             ;<--- Zastpuje RET

;----------------------------------------------------------------------------
;Opis: Oblicza sum kontroln tablicy taryf i porwnuje z zapisan
;      jeli rne ustawia znacznik STATUS_SUMA_TARYF
;      Po wyjciu z procedury DPTR wskazuje adres w eeprom komrki sumy kontrolnej
;      natomiast w "suma_kontrolna" znajduje si wyliczona suma kontrolna
;
suma_ttaryf:    mov     suma_kontrolna,#0               ;Inicjalizacja sumy kontrolnej
                mov     R0,#0                           ;Zerowanie licznika rekordw
suma_taryf_1:   lcall   wylicz_adres_taryfy             ;Ustawienie na pocztek rekordu tablicy
                lcall   read_eeprom                     ;Czytaj bajt
                inc     dptr
                cjne    a,#END_TARYFA,suma_taryf_3      ;Czy Koniec tablicy taryf
                lcall   read_eeprom                     ;Czytaj sum kontroln
                cjne    a,suma_kontrolna,suma_taryf_2   ;Porwnaj sum kontroln
                ret                                     ;Ok wic wyjcie
suma_taryf_2:   mov     a,#STATUS_SUMA_TARYF            ;le wic ustaw znacznik
                ljmp    ustaw_status            ;<--- Zastpuje RET
suma_taryf_3:   lcall   dodaj_sume                      ;Cig dalszy po "read_eeprom"
                mov     R7,#7                           ;Odczytaj dane do obliczenia sumy
suma_taryf_4:   lcall   read_eeprom                     ; tylko 7 poniewa 1 by ju odczytany
                inc     dptr
                lcall   dodaj_sume
                djnz    R7,suma_taryf_4
                inc     R0                              ;Next nr rekordu
                sjmp    suma_taryf_1

;----------------------------------------------------------------------------
;Opis: Wczytuje taryfy z komputera do EEPROM
;
load_taryfy_rs: mov     dptr,#txt_load_tablice
                lcall   print_text
                mov     R0,#0                   ;Zerowanie licznika rekordw
load_tar_1:     lcall   wait_new_line           ;Czeka na now lini i czyta znak
                jnc     load_tar_0
                ljmp    print_tablice_overtime
load_tar_0:     cjne    a,#END_PLIK,load_tar_2  ;Jeli drugi "K" to koniec pliku
load_tar_end:   lcall   wylicz_adres_taryfy     ;Zapisz znacznik koniec tablicy
                mov     a,#END_TARYFA           ; (W R0 nr kolejnego rekordu
                                                ; poniewa przed "sjmp load_tar_1"
                                                ; znajduje si "inc R0)
                ljmp    write_eeprom            ; i zapisuje do EEPROM
                                ;<--- Zastpuje RET

load_tar_2:     cjne    a,#SNG_TARYFA,load_tar_1;Jeli nie "t" to czekaj dalej
                mov     a,R0                    ;Czy przekroczono liczb taryf ?
                cjne    a,#(taryfy_end-taryfy)/8-1,load_tar_3
                ljmp    load_tar_full           ; - przekoroczono liczb taryf sygnalizuj bd

load_tar_3:     mov     a,R0                    ;Wyswietla nr na terminalu
                lcall   print_dec_load
                lcall   wylicz_adres_taryfy     ;Na podstawie nr rekordu
                                                ; wylicza adres w EEPROM
                lcall   in_2ascii_rs            ;Pobiera nr taryfy
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM

                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_tar_syntax

                lcall   in_2ascii_rs            ;Pobiera godzin
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM

                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_tar_syntax
                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_tar_syntax

                lcall   in_2ascii_rs            ;Pobiera starszy okresu zaliczania
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM
                lcall   in_2ascii_rs            ;Pobiera modszy okresu zaliczania
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM
                lcall   in_rs                   ;Znak ","
                cjne    a,#",",load_tar_syntax
                lcall   in_2ascii_rs            ;Pobiera dziesitne okresu zaliczania
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM

                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_tar_syntax
                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_tar_syntax
                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_tar_syntax

                lcall   in_2ascii_rs            ;Pobiera starszy okresu zaliczania
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM
                lcall   in_2ascii_rs            ;Pobiera modszy okresu zaliczania
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM
                lcall   in_rs                   ;Znak ","
                cjne    a,#",",load_tar_syntax
                lcall   in_2ascii_rs            ;Pobiera dziesitne okresu zaliczania
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM

                inc     R0                      ;Next rekord
                ljmp    load_tar_1

;----------------------------------------------------------------------------
load_tar_syntax:
                lcall   print_rs_syntax
                ljmp    load_prefiks_err

;-----------------------
print_ok:       mov     dptr,#txt_ok
                ljmp    print_text                ;<--- zastpuje RET

txt_ok:         BYTE    CR_ASCII,LF_ASCII
                STRING  'OK'
                BYTE    CR_ASCII,LF_ASCII,0

;-----------------------
print_tablice_overtime:
                ljmp    print_overtime    ;<--- zastpuje RET

;-----------------------
load_tar_full:  lcall   print_tablice_full      ;Komunikat bdu
load_tar_err:   lcall   wylicz_adres_taryfy     ;Zapisz znacznik koniec tablicy
                mov     a,#END_TARYFA
                lcall   write_eeprom

wait_load_end:  lcall   in_rs                   ;Czekanie na koniec transmisji
                cjne    a,#END_PLIK,wait_load_end    ; czyli znak "K"
                ret

;----------------------------------------------------------------------------
;Opis: Wczytuje taryfy z komputera do EEPROM
;
load_prefiksy_rs:
                mov     dptr,#txt_load_tablice
                lcall   print_text
                mov     R2,#0                   ;Zerowanie licznika rekordw
load_pref_0:    lcall   wait_new_line           ;Czeka na now lini i czyta znak
                jc      print_tablice_overtime
load_pref_1:    cjne    a,#END_PLIK,load_pref_2 ;Jeli znak "K" to koniec pliku
load_pref_end:  lcall   wylicz_adres_prefiksu   ;Zapisz znacznik koniec tablicy
                                                ; (W R2 nr kolejnego rekordu
                                                ; poniewarz przed "sjmp load_pref_0"
                mov     a,#END_PREFIKS          ; znajduje si "inc R2)
                ljmp    write_eeprom            ; i zapisuje do EEPROM
                                        ;<--- Zastpuje RET

load_pref_2:    cjne    a,#SNG_PREFIKS,load_pref_0      ;Jeli nie "p" to czekaj dalej
                mov     a,R2                    ;Czy przekroczono liczb prefiksw ?
                cjne    a,#(prefiksy_end-prefiksy)/16-1,load_pref_3
                ljmp    load_prefiks_full       ; - przekoroczono liczb prefiks sygnalizuj bd

load_pref_3:    mov     a,R2                    ;Wyswietla nr na terminalu
                lcall   print_dec_load
                lcall   wylicz_adres_prefiksu   ;Na podstawie nr rekordu (w R2)
                                                ; wylicza adres w EEPROM
                lcall   in_2ascii_rs            ;Pobiera 2 cyfry prefiksu
                mov     R7,a                    ; i zapamituje w R7
                lcall   in_2ascii_rs            ;Pobiera 2 nastpne cyfry prefiksu
                mov     R6,a                    ; i zapamituje w R6
                lcall   in_2ascii_rs            ;Pobiera 2 nastpne cyfry prefiksu
                mov     R5,a                    ; i zapamituje w R5
                lcall   in_2ascii_rs            ;Pobiera 2 nastpne cyfry prefiksu
                mov     R4,a                    ; i zapamituje w R4
                lcall   in_2ascii_rs            ;Pobiera 2 nastpne cyfry prefiksu
                mov     R3,a                    ; i zapamituje w R3
                lcall   in_2ascii_rs            ;Pobiera 2 ostatnie cyfry prefiksu
                mov     R1,a                    ; i zapamituje w R1

                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_prefiks_syntax

                lcall   in_2ascii_rs            ;Pobiera nr prefiksu
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM

                mov     a,R7                    ;Odtwarza cyfry prefiksu
                lcall   write_eeprom            ; i zapisuje do EEPROM
                inc     dptr                    ; next adres w EEPROM
                mov     a,R6
                lcall   write_eeprom
                inc     dptr
                mov     a,R5
                lcall   write_eeprom
                inc     dptr
                mov     a,R4
                lcall   write_eeprom
                inc     dptr
                mov     a,R3
                lcall   write_eeprom
                inc     dptr
                mov     a,R1
                lcall   write_eeprom
                inc     dptr

                lcall   in_rs                   ;Znak spacji
                cjne    a,#" ",load_prefiks_syntax

                mov     R1,#9                   ;Maksymalna liczba znakw do pobrania
load_pref_4:    lcall   in_rs                   ;Pobiera znak
                cjne    a,#13,load_pref_5       ;Czy znak CR ?
                sjmp    load_pref_k
load_pref_5:    cjne    a,#10,load_pref_6       ;Czy znak LF ?
load_pref_k:    mov     a,#0                    ;Znacznik wczeniejszego koca tekstu
                lcall   write_eeprom            ; zapisuje znak do EEPROM
                sjmp    load_pref_7
load_pref_6:    lcall   write_eeprom            ; zapisuje znak do EEPROM
                inc     dptr                    ; next adres w EEPROM
                djnz    R1,load_pref_4          ;Czy max liczba znakw ?
                inc     R2                      ; tak wic next rekord
                ljmp    load_pref_0             ; i skok do czekania na CR+LF
load_pref_7:    mov     a,#0                    ;Dpopenienie reszty pamici znakami $00
                lcall   write_eeprom
                inc     dptr
                djnz    R1,load_pref_7          ;Czy dopeniono ?
                lcall   wait_no_crlf            ;Odczytano CR+LF wic czeka na
   ;???             jc      print_tablice_overtime  ; inny znak i wychodzi w procedury
                inc     R2                      ;Next rekord
                ljmp    load_pref_1

;-----------------------
load_prefiks_syntax:
                lcall   print_rs_syntax
                sjmp    load_prefiks_err

load_prefiks_full:
                lcall   print_tablice_full      ;Komunikat bdu
load_prefiks_err:
                lcall   wylicz_adres_prefiksu   ;Zapisz znacznik koniec tablicy
                mov     a,#END_PREFIKS
                lcall   write_eeprom
                ljmp    wait_load_end           ;Czeka na koniec transmisji

;----------------------------------------------------------------------------
;Wyswietla nr z ACC w postaci DEC 3 cyfry (przedtem kod CR)
;Zmienia: --
;
print_dec_load: push    B
                push    ACC
                mov     a,#CR_ASCII             ;Wyswietl nr na treminalu
                lcall   print_char
                pop     ACC                     ;konwersja liczby do dec
                lcall   hex2dec
                push    ACC
                mov     a,b
                lcall   print_nible
                pop     ACC
                lcall   print_hex
                pop     B
                ret

;----------------------------------------------------------------------------
print_err:      setb    LIGHT                   ;Wcz wywietlacz
                mov     dptr,#txt_err           ;Drukuje napis "Bd: "
                ljmp    print_text        ;<--- zastpuje RET

txt_err:        BYTE    CLS_ASCII
                STRING  'Bd: '
                BYTE    0

;-----------------------
print_tablice_full:
                lcall   print_err
                mov     dptr,#txt_tablice_full
                ljmp    print_text                ;<--- zastpuje RET

txt_tablice_full:
                STRING  'Dugo tablicy'
                BYTE    CR_ASCII,LF_ASCII,0

;-----------------------
txt_load_tablice:
                BYTE    CR_ASCII,LF_ASCII
                STRING  'Wczytuj tablic..'
                BYTE    CR_ASCII,LF_ASCII,0

;-----------------------
print_sortowanie:
                mov     dptr,#txt_sortowanie
                ljmp    print_text                ;<--- zastpuje RET

txt_sortowanie: BYTE    CLS_ASCII
                STRING  'Sortuj '
                BYTE    0

;----------------------------------------------------------------------------
;Opis: Czeka na znak kocza linii, wychodzi gdy drugi znak nie bdzie CR lub LF
;      czyli w ACC jest znak nasppny po CL,LF lub CR_LF
;wy: C (C=0 jest nowa linia, C=1 min czas)
;
wait_new_line:  lcall   in_rs                   ;Czeka na znak CR lub LF
                jc      wait_new_ln_overtime
                cjne    a,#CR_ASCII,wait_new_ln1
                sjmp    wait_no_crlf
wait_new_ln1:   cjne    a,#LF_ASCII,wait_new_line
wait_no_crlf:   lcall   in_rs                   ;Czy moe kolejny znak CR lub LF ?
                jc      wait_new_ln_overtime
                cjne    a,#CR_ASCII,wait_new_ln3
                sjmp    wait_no_crlf            ; tak CR wic odczytaj kolejny znak
wait_new_ln3:   cjne    a,#LF_ASCII,wait_new_ln4
                sjmp    wait_no_crlf            ; tak LF wic odczytaj kolejny znak

wait_new_ln4:   clr     C                       ;w ACC znak inny ni CR lub LF
                ret

wait_new_ln_overtime:
                setb    C
                ret

;;----------------------------------------------------------------------------
;;Opis: Sortuje tablice prefiksw. Najpierw prefiksy najkrdsze na kocu najdusze.
;;
;
sortuj_prefiksy:
        ret  ;??? Usunito poniewa wane aby prefiks pusty by pierwszy, reszt nie ma znaczenia
;                clr     EA                              ;Wyczenie przerwa (przyspieszenie)
;                lcall   licz_prefiksy                   ;Liczenie liczby prefiksw
;                mov     a,B                             ; jeli zero rekordw
;                jz      sort_prefiks_exit               ; to nie ma co sortowa
;                mov     R1,#0                           ;Licznik przej
;sort_prefiks_4:
;                setb    EA                              ;Wczenie irq na czas wydruku
;                lcall   print_sortowanie
;                mov     a,R1                            ;Wywietlenie nr przejcia
;                lcall   print_hex
;                mov     a,#"/"
;                lcall   print_char
;                mov     a,B                             ;Wywietlenie liczby rekordw (przej)
;                lcall   print_hex
;                clr     EA                              ; i znw wyczenie
;
;                mov     R2,#0                           ;Zerowanie licznika rekordw
;                clr     FL_ZMIANY                       ;Nie byo zamian rekordw
;sort_prefiks_5: lcall   reset_watchdog
;                lcall   cmp_prefiksy                    ;Porwnaj prefiksy
;                jnc     sort_prefiks_6                  ; zamie jeli trzeba
;                lcall   zamien_prefiksy
;                setb    FL_ZMIANY                       ;Nastpia zamiana
;sort_prefiks_6: inc     R2                              ;next rekord
;                mov     a,R2                            ;Sprawdzenie czy wszystkie rekordy
;                cjne    a,B,sort_prefiks_5
;                jnb     FL_ZMIANY,sort_prefiks_exit     ;Jeli w przejciu nie byo zamian
;                                                        ; to tablica jest posortowana i mona wyj
;                inc     R1                              ;next przejcie
;                mov     a,R1                            ;Sprawdzenie czy wszystkie przejcia
;                cjne    a,B,sort_prefiks_4
;sort_prefiks_exit:
;                setb    EA                              ;Wczenie przerwa
;                ret
;
;;----------------------------------------------------------------------------
;;Opis: Porwnuje prefiks wskazany w R2 z wskazanym w R2+1
;;we: R2 - rekord do zamiany
;;wy: C  - (C=0 jeli R2>R2+1, C=1 jeli R2<=R2+1)
;;Zmienia: Acc, R0, R6, R7, dptr
;;
;cmp_prefiksy:   push    RR2
;                push    B
;                lcall   len_prefiksu                    ;Zmierz dugo
;                mov     B,a                             ;zapamitaj w B
;                inc     R2
;                lcall   len_prefiksu                    ;Zmierz dugo kolejnego
;                cjne    a,B,*+3                         ;Ustaw C zalenie od wyniku
;                pop     B
;                pop     RR2
;                ret
;
;;----------------------------------------------------------------------------
;;Opis: Oblicza dugo cyfr prefiksu
;;we: R2  - rekord do zamiany
;;wy: Acc - dugo prefiksu
;;Zmienia: Acc, R0, R6, R7, dptr
;;
;len_prefiksu:   lcall   pref_do_buf
;        ;--------- W buforze mamy zaadowany cay rekord --------------
;                mov     R0,#buf_cyf_str+1               ;Bufor z nr
;                mov     R7,#6                           ;Liczba bajtw numeru
;                mov     R6,#0                           ;Dugo prefiksu
;len_pref_1:     mov     a,@R0                           ;odczytaj prefiks z bufora
;                rr      a                               ;Analizuj starszy pbajt
;                rr      a
;                rr      a
;                rr      a
;                anl     a,#$0F                          ;Jeli koniec prefiksu to wyjd
;                cjne    a,#CYFRA_EMPTY,len_pref_2
;len_pref_e:     mov     a,R6                            ;Dugo prefiksu do Acc
;                ret
;len_pref_2:     inc     R6                              ;Zwiksz licznik dlugoci prefiksu
;                mov     a,@R0                           ;odczytaj prefiks z bufora
;                anl     a,#$0F                          ;Analizuj modszy pbajt
;                cjne    a,#CYFRA_EMPTY,len_pref_3       ;Jeli koniec prefiksu to wyjd
;                sjmp    len_pref_e
;len_pref_3:     inc     R6                              ;Zwiksz licznik dlugoci prefiksu
;                inc     R0                              ;Next wskanik
;                djnz    R7,len_pref_1                   ;jeli ostatni bajt prefiksu
;                sjmp    len_pref_e                      ; to wyjd
;
;;----------------------------------------------------------------------------
;;Opis: Procedura zamienia midzy sob rekordy. Zamieniny zostaje rekord wskazany
;;      przez R2 z rekordem o numerze R2+1
;;we: R2 - rekord do zamiany
;;Zmienia: Acc, R0, R7, dptr
;;
;zamien_prefiksy:push    RR2
;                lcall   pref_do_buf                     ;W buforze mamy zaadowany cay rekord
;                inc     R2                              ;next rekord
;                lcall   wylicz_adres_prefiksu           ;W dptr adres rekordu wskazanego przez R2
;                mov     R7,#16                          ;Liczba bajtw w rekordzie
;                mov     R0,#buf_cyf_str                 ;Bufor z poprzednim rokordem
;zam_pref_2:     lcall   read_eeprom                     ;czytaj bajt
;                push    ACC                             ;zapamitaj
;                mov     a,@R0                           ;odczytaj bajt z bufora
;                lcall   write_eeprom                    ;i zapisz w to miejsce eeprom
;                pop     ACC                             ;odtwrz bajt
;                mov     @R0,a                           ;zapisz odczytany bufora
;                inc     R0                              ;wskanik na next bajt bufora
;                inc     dptr                            ;wskanik na next bajt eeprom
;                djnz    R7,zam_pref_2
;
;        ;--------- W buforze next rekord, w eeprom prev rekord --------
;                dec     R2                              ;prev rekord
;                lcall   wylicz_adres_prefiksu           ;W dptr adres rekordu wskazanego przez R2
;                mov     R7,#16                          ;Liczba bajtw w rekordzie
;                mov     R0,#buf_cyf_str                 ;Bufor z poprzednim rokordem
;zam_pref_3:     mov     a,@R0                           ;odczytaj bajt z bufora
;                lcall   write_eeprom                    ;i zapisz w to miejsce eeprom
;                inc     R0                              ;wskanik na next bajt bufora
;                inc     dptr                            ;wskanik na next bajt eeprom
;                djnz    R7,zam_pref_3
;                pop     RR2
;                ret
;
;----------------------------------------------------------------------------
;Opis: Sortuje tablice taryf od najmiejszej do najwikszej (klucze: nr taryfy, godzina)
;
sortuj_taryfy:  lcall   licz_taryfy                     ;Liczenie liczby taryf
                mov     a,B                             ; jeli zero rekordw
                jz      sort_taryfy_exit                ; to nie ma co sortowa
                mov     R1,#0                           ;Licznik przej

sort_taryfy_4:  lcall   print_sortowanie
                mov     a,R6                            ;Wywietlenie nr przejcia
                lcall   print_hex
                mov     a,#"/"
                lcall   print_char
                mov     a,B                             ;Wywietlenie liczby rekordw (przej)
                lcall   print_hex
                mov     R0,#0                           ;Zerowanie licznika rekordw
                clr     FL_ZMIANY                       ;Nie byo zamian rekordw
sort_taryfy_5: ;??? lcall   reset_watchdog
                lcall   cmp_taryfy                      ;Porwnaj taryfy
                jnc     sort_taryfy_6                   ; zamie jeli trzeba
                lcall   zamien_taryfy
                setb    FL_ZMIANY                       ;Nastpia zamiana
sort_taryfy_6:  inc     R0                              ;next rekord
                mov     a,R0                            ;Sprawdzenie czy wszystkie rekordy
                cjne    a,B,sort_taryfy_5
                jnb     FL_ZMIANY,sort_taryfy_exit      ;Jeli w przejciu nie byo zamian
                                                        ; to tablica jest posortowana i mona wyj
                inc     R6                              ;next przejcie
                mov     a,R6                            ;Sprawdzenie czy wszystkie przejcia
                cjne    a,B,sort_taryfy_4
sort_taryfy_exit:
                ret

;----------------------------------------------------------------------------
;Opis: Liczy liczb rekordw w tablicy taryf
;wy: B - liczba tary
;
licz_taryfy:    mov     R0,#0                           ;Zerowanie licznika rekordw
licz_taryfy_1: ;??? lcall   reset_watchdog
                lcall   wylicz_adres_taryfy             ;Ustawienie na pocztek rekordu tablicy
                lcall   read_eeprom                     ;Czytaj bajt
                cjne    a,#END_TARYFA,licz_taryfy_2     ;Czy Koniec tablicy
                sjmp    licz_taryfy_3
licz_taryfy_2:  inc     R0                              ;Next nr rekordu
                sjmp    licz_taryfy_1
licz_taryfy_3:  dec     R0
                mov     B,R0                            ;Zapamitanie liczby taryf
                mov     R6,#0                           ;Licznik przej
licz_taryfy_4:  ret

;----------------------------------------------------------------------------
;Opis: Porwnuje taryf wskazywan w R0 z wskazanym w R0+1
;we: R0 - rekord do zamiany
;wy: C  - (C=0 jeli R0>R0+1, C=1 jeli R0<=R0+1)
;Zmienia: Acc, R0, R1, R7, dptr
;
cmp_taryfy:     push    RR0
                push    B
                lcall   tar_do_buf                      ;pierwsza taryfa do bufora
                inc     R0
                lcall   wylicz_adres_taryfy
                mov     R1,#buf_cyf_str+1               ;Zapamitaj nr taryfy w B
                mov     a,@R1
                mov     B,a
                inc     dptr                            ;czytaj nr taryfy z eeprom
                lcall   read_eeprom
                clr     C                               ;Porwnaj modsze
                subb    a,B
                push    PSW                             ;zapamitaj znacznik C
                dec     R1                              ;Zapamitaj godzin w B
                mov     a,@R1
                mov     B,a
                lcall   dec_dptr                        ;czytaj godzin z eeprom
                lcall   read_eeprom
                pop     PSW                             ;odtworz znacznik C
                subb    a,B                             ;Porwnaj starsze

                pop     B
                pop     RR0
                ret

;----------------------------------------------------------------------------
;zmiejszenie o jeden (DEC) wskanika DPTR
;
dec_dptr:	push	ACC
		dec	DPL
                mov	a,DPL
		cjne	a,#$ff,dec_dptr_1
		dec	DPH
		pop	ACC
                ret
dec_dptr_1:	pop	ACC
		ret

;----------------------------------------------------------------------------
;Opis: Procedura zamienia midzy sob rekordy. Zamieniny zostaje rekord wskazany
;      przez R0 z rekordem o numerze R0+1
;we: R0 - rekord do zamiany
;Zmienia: Acc, R1, R7, dptr
;
zamien_taryfy:  push    RR0
                lcall   tar_do_buf
        ;--------- W buforze mamy zaadowany cay rekord --------------
                inc     R0                              ;next rekord
                lcall   wylicz_adres_taryfy             ;W dptr adres rekordu wskazanego przez R0
                mov     R7,#7                           ;Liczba bajtw w rekordzie
                mov     R1,#buf_cyf_str                 ;Bufor z poprzednim rokordem
zam_tar_2:      lcall   read_eeprom                     ;czytaj bajt
                push    ACC                             ;zapamitaj
                mov     a,@R1                           ;odczytaj bajt z bufora
                lcall   write_eeprom                    ;i zapisz w to miejsce eeprom
                pop     ACC                             ;odtwrz bajt
                mov     @R1,a                           ;zapisz odczytany bufora
                inc     R1                              ;wskanik na next bajt bufora
                inc     dptr                            ;wskanik na next bajt eeprom
                djnz    R7,zam_tar_2
        ;--------- W buforze next rekord, w eeprom prev rekord --------
                dec     R0                              ;prev rekord
                lcall   wylicz_adres_taryfy             ;W dptr adres rekordu wskazanego przez R0
                mov     R7,#7                           ;Liczba bajtw w rekordzie
                mov     R1,#buf_cyf_str                 ;Bufor z poprzednim rokordem
zam_tar_3:      mov     a,@R1                           ;odczytaj bajt z bufora
                lcall   write_eeprom                    ;i zapisz w to miejsce eeprom
                inc     R1                              ;wskanik na next bajt bufora
                inc     dptr                            ;wskanik na next bajt eeprom
                djnz    R7,zam_tar_3
                pop     RR0
                ret

;----------------------------------------------------------------------------
;Opis: Kopuje tayf wskazany przez R0 do bufora
;we: R0 - nr rekordu
;Zmienia: Acc, R0, R7, dptr
;
tar_do_buf:     lcall   wylicz_adres_taryfy             ;W dptr adres rekordu wskazanego przez R0
                mov     R7,#8                           ;Liczba bajtw w rekordzie
                mov     R1,#buf_cyf_str                 ;Bufor na dane rokordu
zam_tar_1:      lcall   read_eeprom                     ;czytaj bajt
                mov     @R1,a                           ;zapisz do bufora
                inc     R1                              ;wskanik na next bajt bufora
                inc     dptr                            ;wskanik na next bajt eeprom
                djnz    R7,zam_tar_1
                ret

;----------------------------------------------------------------------------
;Opis; Generuje komunikat, e opcja wyczona z kompilacji
;
kompile_error:  lcall   print_err
                mov     dptr,#txt_wylaczona_kompilacja
                lcall   print_text
                ljmp    wait_error

txt_wylaczona_kompilacja:
                STRING  'Wyczone!'
                BYTE    END_ASCII

;----------------------------------------------------------------------------
wait_error:     lcall   curs_on         ;Migaj kursorem
                clr     EA
                mov     a,#30           ;Czekaj 3 sekundy
wait_err_l1:    lcall   wait_err_delay
                lcall   reset_watchdog
                djnz    ACC,wait_err_l1
                mov     a,#30           ;Czekaj 3 sekundy (lub restart przez watchdog)
wait_err_l2:    lcall   wait_err_delay
                djnz    ACC,wait_err_l2
                ljmp    $0000           ;Restart (jeli nie ma watchdog'a)

wait_err_delay: mov     R7,#10          ;100ms
                mov     R6,#100         ;10ms
wait_err_delay1:lcall   lcd_d100us
                djnz    R6,wait_err_delay1
                djnz    R7,wait_err_delay1
                ret

;----------------------------------------------------------------------------
;Opis: Sprawdza wersj hardware (sprawdzajc obecno US9 typu PCF8574
;
hardware:       clr     FL_HARDWARE
                clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
                clr     EX0                             ; poniewarz na irq wystpuj
                                                        ; cykle dostpu do IIC
                lcall   iic_start                       ;Odczyt danej z PIO
                mov     a,#PIO_WRITE
                lcall   iic_write
                jc      hard_v1
                setb    FL_HARDWARE
hard_v1:        lcall   iic_stop
                setb    ET0
                setb    EX0
                ret

;----------------------------------------------------------------------------
;Obsuga WatchDog'a
;
reset_watchdog: push    ACC
                cpl     WATCHDOG                        ;Obsuga zewntrznego WatchDog'a
                nop
                cpl     WATCHDOG
 IF WDG55
                mov     WDTRST,#$1E                     ;Reset watchdoga'a
                mov     WDTRST,#$E1
 ENDI
                pop     ACC
                ret

;----------------------------------------------------------------------------
;Inicjalizacja WatchDog'a
;
init_watchdog:
 IF WDG55
                mov     a,AUXR                          ;ustawienie pinu reset jako wejscie
                setb    Acc+DISRTO                      ; (nie ma impulsu gdy wygeneruje go WDG)
                mov     AUXR,a
                mov     WDTRST,#$1E                     ;Init watchdoga'a
                mov     WDTRST,#$E1
 ENDI
                ret

;----------------------------------------------------------------------------
;Opis: Procedura edycji tablicy prefiksw
;
set_prefiksy:   clr     FL_ZMIANY                       ;Zaznacz, e nie byo zmian
 IF TABLICE_TEL
                lcall   licz_prefiksy                   ;Liczy prefiksy, wynik w B
set_prefiksy_0: mov     R2,#0
set_pref_print: lcall   cls                             ;Wywietl prefiks R0
                lcall   curs_off
                lcall   print_pref_NR_R2                ;Drukuje nr w prefiksie
                jc      set_prefiksy_0                  ; jeli ostatni to wywietl pierwszy
                lcall   print_crlf                      ;Drukuj Opis
                inc     dptr
                lcall   print_nazwa_prefiksu_2

set_pref_wait:  lcall   wait_cyfra                      ;Czeka na reakcj
                jb      F0,set_pref_quit                ;Jeli odorzona suchawka to wyjcie
                jc      set_pref_wait
                cjne    a,#CYFRA_DEL,set_pref_1         ;"0" to DEL
                setb    FL_ZMIANY                       ;Zaznacz, e byy zmiany
                lcall   del_prefiks
                sjmp    set_prefiksy_0                  ;Wywietl pierwszy prefiks

set_pref_1:     cjne    a,#CYFRA_NEXT,set_pref_2        ;"1" to next
                inc     R2
                sjmp    set_pref_print

set_pref_2:     cjne    a,#CYFRA_PREV,set_pref_3        ;"2" to prev
                dec     R2                              ;poprzdni rekord
                mov     a,R2                            ;sprawd czy przekroczono zakres
                cjne    a,#$FF,set_pref_print           ; nie wic wywietl next
                mov     R2,B                            ; tak wic wywietl ostatni rekord
                sjmp    set_pref_print

set_pref_3:     cjne    a,#CYFRA_JUMP,set_pref_4        ;"3" to skok do dowolnego prefiksu
                lcall   nr_rekordu
                mov     R2,a
                cjne    a,B,*+3                         ;czy przekroczono tablic ?
                jc      set_pref_print                  ; nie wic wywietl
                mov     R2,B
                sjmp    set_pref_print

set_pref_4:     cjne    a,#CYFRA_EDIT,set_pref_5        ;"4" to edycja
                setb    FL_ZMIANY                       ;Zaznacz, e byy zmiany
                lcall   edytuj_prefiks                  ;Skocz do edycji
                sjmp    set_pref_print

set_pref_5:     cjne    a,#CYFRA_ADD,set_pref_6         ;"5" to dodaj prefiks
                setb    FL_ZMIANY                       ;Zaznacz, e byy zmiany
                inc     B                               ;Dodaj prefiks
                mov     a,B                             ;czy przekroczono zakres ?
                cjne    a,#(prefiksy_end-prefiksy)/16-1,*+3
                jnc     set_prefiksy_0                  ; tak wic skocz
                mov     R2,B                            ; nie wic edytuj
                lcall   edytuj_prefiks
                push    RR2                             ;Ustaw nastpny prefiks jako pusty
                inc     R2
                lcall   wylicz_adres_prefiksu           ;w dptr adres prefiksu
                mov     a,#END_PREFIKS
                lcall   write_eeprom
                pop     RR2
                sjmp    set_pref_print
set_pref_6:
set_pref_7:     cjne    a,#CYFRA_PRINT,set_pref_8       ;"7" to wydruk
                push    RR2                             ;zapamitaj nr prefiksu
                push    B
                lcall   print_prefiksy
                pop     B
                pop     RR2
                ljmp    set_pref_print
set_pref_8:
set_pref_9:     cjne    a,#CYFRA_EXIT,set_pref_wait     ;"9" to wyjcie, Inna cyfra do skok do menu
                jnb     FL_ZMIANY,set_pref_quit         ;Wyjcie z tablicy jeli nie wprowadzono zmian
                lcall   sortuj_prefiksy                 ;Sortowanie
set_pref_quit:  ljmp    generuj_sume_prefiksow          ;Zapisanie sumy kontrolnej
                                        ;<--- Zastpuje RET

;----------------------------------------------------------------------------
;Opis: Kasuje rekord prefiksu wskazywany przez R2
;
del_prefiks:    mov     dptr,#txt_del                   ;Napis na LCD
                lcall   print_text
                mov     a,R2                            ;czy ostatni rekord ?
                cjne    a,B,set_pref_del                ; - nie wic kopiuj
                sjmp    set_pref_del2                   ; - tak wic wstaw znacznik END_PREFISK
set_pref_del:  ;??? lcall   reset_watchdog
                lcall   copy_prefiksy                   ;Przesunicie w d prefiksu
                inc     R2                              ;next prefiks
                mov     a,R2                            ;czy ostatni ?
                cjne    a,B,set_pref_del                ; - nie wic kopiuj next
set_pref_del2:  mov     R2,B                            ; - tak wic wstaw znacznik END_PREFISK
                lcall   wylicz_adres_prefiksu           ;w dptr adres prefiksu
                mov     a,#END_PREFIKS
                ljmp    write_eeprom            ;<--- Zastpuje RET

txt_del:        BYTE    CLS_ASCII
                STRING  'Kasuj..'
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Kopiuje prefiks wskazywany przez R2+1 w miejsce R2
;we: R2 - rekord do skopiowania
;wy: C  - (C=0 jeli R2>R2+1, C=1 jeli R2<=R2+1)
;Zmienia: Acc, R0, R6, R7, dptr
;
copy_prefiksy:  push    RR2
                inc     R2                              ;rekord nr R2+1
                lcall   pref_do_buf                     ;W buforze mamy zaadowany cay rekord
                dec     R2                              ;rekord nr R2
                lcall   wylicz_adres_prefiksu           ;W dptr adres rekordu wskazanego przez R2
                mov     R7,#16                          ;Liczba bajtw w rekordzie
                mov     R0,#buf_cyf_str                 ;Bufor z poprzednim rekordem
copy_pref_2:    mov     a,@R0                           ;odczytaj bajt z bufora
                lcall   write_eeprom                    ;i kopiowanie to miejsce eeprom
                inc     R0                              ;wskanik na next bajt bufora
                inc     dptr                            ;wskanik na next bajt eeprom
                djnz    R7,copy_pref_2
                pop     RR2
                ret

;----------------------------------------------------------------------------
;Opis: Liczy liczb prefiksw
;wy: B - liczba prefiksw
;
licz_prefiksy:  mov     R2,#0                           ;Zerowanie licznika rekordw
sort_prefiks_1: ;???lcall   reset_watchdog
                lcall   wylicz_adres_prefiksu           ;Ustawienie na pocztek rekordu tablicy
                lcall   read_eeprom                     ;Czytaj bajt
                cjne    a,#END_PREFIKS,sort_prefiks_2   ;Czy Koniec tablicy prefiksw
                sjmp    sort_prefiks_3
sort_prefiks_2: inc     R2                              ;Next nr rekordu
                sjmp    sort_prefiks_1
sort_prefiks_3: dec     R2
                mov     B,R2                            ;Zapamitanie liczby prefiksw
                ret

;----------------------------------------------------------------------------
;Opis: Kopuje prefiks wskazany przez R2 do bufora
;we: R2 - nr rekordu
;Zmienia: Acc, R0, R7, dptr
;
pref_do_buf:    lcall   wylicz_adres_prefiksu           ;W dptr adres rekordu wskazanego przez R2
                mov     R7,#16                          ;Liczba bajtw w rekordzie
                mov     R0,#buf_cyf_str                 ;Bufor na dane rokordu
zam_pref_1:     lcall   read_eeprom                     ;czytaj bajt
                mov     @R0,a                           ;zapisz do bufora
                inc     R0                              ;wskanik na next bajt bufora
                inc     dptr                            ;wskanik na next bajt eeprom
                djnz    R7,zam_pref_1
                ret

;----------------------------------------------------------------------------
;Wpisuje do eeprom prefiks zawarty w R2
;
edytuj_prefiks:
        ;--- Wpisanie nr prefiksu ---
                lcall   curs_on
                mov     dptr,#txt_nr_prefiksu           ;Komunikat
                lcall   print_text
                lcall   wylicz_adres_prefiksu           ;w dptr adres prefiksu
                inc     dptr                            ;ustaw wskanik na cyfry prefiksu
                mov     poz_wys,#$40                    ;Pierwotna pozycja kursora na LCD
                mov     R6,#6                           ;Liczba bajtw do wpisania
edytuj_pref_1:  lcall   wait_bajt                       ;Czekaj na pierwsze cyfry prefiksu
                jb      F0,edytuj_pref_end              ; odorzenie suchawki to wyjcie
                cjne    a,#RETURN_DTMF SHL 4 OR RETURN_DTMF,edytuj_pref_11   ;Jeli kod RETURN to nacinito
                                                        ; # jako pierwszy
edytuj_pref_10: mov     a,#(CYFRA_EMPTY SHL 4) OR CYFRA_EMPTY
                lcall   write_eeprom                    ; wypenij reszt kodem pustych znakw
                inc     dptr
                djnz    R6,edytuj_pref_10
                sjmp    edytuj_pref_13
edytuj_pref_11: mov     R5,a                            ;Zapamitaj bajt
                anl     a,#$0F                          ;Sprawd tylko modszy nible
                cjne    a,#RETURN_DTMF,edytuj_pref_12   ;Jeli kod RETURN tylko na modszym
                                                        ; # nacisito jako drugi znak
                mov     a,R5                            ; zapisz kod putej cyfry na modszym
                orl     a,#CYFRA_EMPTY
                lcall   write_eeprom
                inc     dptr
                djnz    R6,edytuj_pref_10               ; i wypenij reszt
                sjmp    edytuj_pref_13
edytuj_pref_12: mov     a,R5                            ;odtwrz bajt z R5
                lcall   write_eeprom
                inc     dptr
                djnz    R6,edytuj_pref_1
edytuj_pref_13:
        ;--- Zapamitanie taryfy ---
                mov     dptr,#txt_tar_pref
                lcall   print_text
                lcall   wylicz_adres_prefiksu           ;w dptr adres prefiksu
                mov     poz_wys,#7                      ;Pozycja kursora
                lcall   wait_bajt                       ;Czekaj na cyfry prefiksu
                jb      F0,edytuj_pref_end              ; odorzenie suchawki to wyjcie
                lcall   write_eeprom

        ;--- Wpisanie komentarza prefiksu ---
                mov     dptr,#txt_kom_pref
                lcall   print_text
                lcall   wylicz_adres_prefiksu           ;w dptr adres prefiksu
                inc     dptr                            ;Pominicie taryfy
                inc     dptr                            ; i cyfr prefiksu
                inc     dptr
                inc     dptr
                inc     dptr
                inc     dptr
                inc     dptr
                mov     poz_wys,#$40                    ;Pierwotna pozycja kursora na LCD
                mov     R6,#9                           ;Liczba bajtw do wpisania
edytuj_pref_2:  lcall   wait_ascii                      ;Czekaj na litery komentarza prefiksu
                jb      F0,edytuj_pref_end              ; odorzenie suchawki to wyjcie
                cjne    a,#RETURN_DTMF SHL 4 OR RETURN_DTMF,edytuj_pref_3    ;Czy wcinito "#" - RETURN
                mov     a,#$00                          ; tak wic zapisz znak noca tekstu
                lcall   write_eeprom
                sjmp    edytuj_pref_end
edytuj_pref_3:  lcall   write_eeprom
                inc     dptr
                djnz    R6,edytuj_pref_2
edytuj_pref_end:ret

txt_nr_prefiksu:BYTE    CLS_ASCII
                        ;1234567890123456
                STRING  'Wprowad prefiks'
                BYTE    END_ASCII

txt_tar_pref:   BYTE    CLS_ASCII
                STRING  'Taryfa'
                BYTE    END_ASCII

txt_kom_pref:   BYTE    CLS_ASCII
                STRING  'Komentarz'
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Czeka na liter wysan przez tarcz numerow (lub RS)
;we: ACC - pozycja kursora
;wy: ACC - odczytany znak
;      C - status (C=0 wybrano liter, C=1 min czas)
;     F0 - status (F0=1 gdy odoono suchawk (lub nacinito ESC przy RS))
;
END_TAB_DTMF    equ     $FF                             ;Staa koca tablicy DTMF
;
wait_ascii:     push    DPH                             ;Ochrona rejestrw
                push    DPL
                push    B
wait_ascii_1:   lcall   wait_bajt_noecho                ;czeka na bajt
                jb      F0,wait_ascii_exit
                cjne    a,#RETURN_DTMF SHL 4 OR RETURN_DTMF,wait_ascii_2   ;Jeli kod RETURN
                sjmp    wait_ascii_exit                 ; to wyjcie
wait_ascii_2:   mov     B,a                             ;Zapamitaj bajt DTMF
                mov     dptr,#tab_dtmf_ascii
wait_ascii_5:   clr     a                               ;pobranie elementu
                movc    a,@a+dptr
                cjne    a,#END_TAB_DTMF,wait_ascii_6    ;Jeli koniec tablicy
                sjmp    wait_ascii_1                    ; to skacz do ponownego pobrania
                                                        ; bajtu z klawiatury
wait_ascii_6:   cjne    a,B,wait_ascii_4                ;Czy porwnanie ok
                inc     dptr                            ; tak wic
                clr     a                               ; pobranie znaku po konwersji
                movc    a,@a+dptr                       ; wywietlenie na LCD
                lcall   print_char                      ; i wyjcie
                sjmp    wait_ascii_exit
wait_ascii_4:   inc     dptr                            ; nie wic next element
                inc     dptr
                sjmp    wait_ascii_5
wait_ascii_exit:pop     B
                pop     DPL
                pop     DPH
                ret

tab_dtmf_ascii: BYTE    $0B," "                 ;Pena tablica w Ep 10/94 s. 19
                BYTE    $00,"0"
                BYTE    $10,"1"
                BYTE    $20,"2"
                BYTE    $30,"3"
                BYTE    $40,"4"
                BYTE    $50,"5"
                BYTE    $60,"6"
                BYTE    $70,"7"
                BYTE    $80,"8"
                BYTE    $90,"9"
                BYTE    $21,"A"
                BYTE    $22,"B"
                BYTE    $23,"C"
                BYTE    $31,"D"
                BYTE    $32,"E"
                BYTE    $33,"F"
                BYTE    $41,"G"
                BYTE    $42,"H"
                BYTE    $43,"I"
                BYTE    $51,"J"
                BYTE    $52,"K"
                BYTE    $53,"L"
                BYTE    $61,"M"
                BYTE    $62,"N"
                BYTE    $63,"O"
                BYTE    $71,"P"
                BYTE    $72,"R"
                BYTE    $73,"S"
                BYTE    $81,"T"
                BYTE    $82,"U"
                BYTE    $83,"V"
                BYTE    $91,"W"
                BYTE    $92,"X"
                BYTE    $93,"Y"
                BYTE    $02,"Q"
                BYTE    $03,"Z"
                BYTE    END_TAB_DTMF

;----------------------------------------------------------------------------
;Opis: Czeka na nr rekordu do ktrego ma skoczy
;wy: ACC - nr rekordu
;
nr_rekordu:     lcall   curs_on
                mov     dptr,#txt_nr_rekordu
                lcall   print_text
                mov     poz_wys,#11
                lcall   wait_bajt
                jb      F0,nr_rek_exit
                lcall   bcd1bin                         ;Konwersja z BCD na Hex
nr_rek_exit:    ret

txt_nr_rekordu: BYTE    CLS_ASCII
                STRING  'Nr rekordu'
                BYTE    END_ASCII
 ELSE
                ljmp    kompile_error                   ;Wyczone z kompilacja
 ENDI

;----------------------------------------------------------------------------
;Podprogram 1-bajtowej konwersji BCD->BIN
;Wejscie: Acc - Upakowane BCD
;Wyjcie: Acc - NKB
;Zmienia: Acc
bcd1bin:        push    B                               ;Zapamitaj rejestry
                push    RR7
                push    RR6

		mov     B,#0
                mov     R7,a
		swap    a
		anl     a,#0fh
		jz      bcd1bin1
		mov     R6,a
		clr     C
bcd1bin2:
		mov     a,B
		addc    a,#10
		mov     B,a
		djnz    R6,bcd1bin2
bcd1bin1:
		mov     a,R7
		anl     a,#0fh
		add     a,B

                pop     B
                pop     RR6
                pop     RR7
		ret

;----------------------------------------------------------------------------
;Opis: Procedura edycji tablicy taryf
;
set_taryfy:     
 IF TABLICE_TEL=YES
                clr     FL_ZMIANY                       ;Zaznacz, e nie byo zmian
                lcall   licz_taryfy                     ;Liczy taryfy,wynik w B
set_taryfa_0:   mov     R0,#0
set_taryfa_print:
                lcall   cls                             ;Wywietl taryf nr R0
                lcall   curs_off
                lcall   print_tar_R0                    ;Drukuje taryf nr R0
                jc      set_taryfa_0                    ; jeli ostatnia to wywietla pierwsz
set_taryfa_wait:lcall   wait_cyfra                      ;czeka na reakcj
                jb      F0,set_taryfa_quit              ;Jeli odorzona suchawka to wyjcie
                jc      set_taryfa_wait

                cjne    a,#CYFRA_DEL,set_taryfa_1       ;"0" to DEL
                setb    FL_ZMIANY                       ;Zaznacz, e byy zmiany
                lcall   del_taryfa
                sjmp    set_taryfa_print

set_taryfa_1:   cjne    a,#CYFRA_NEXT,set_taryfa_2      ;"1" to next
                inc     R0
                sjmp    set_taryfa_print

set_taryfa_2:   cjne    a,#CYFRA_PREV,set_taryfa_3      ;"2" to prev
                dec     R0                              ;poprzedni rekord
                mov     a,R0                            ;sprawd czy przekroczono zakres
                cjne    a,#$FF,set_taryfa_print         ;- nie wic wywietl
                mov     R0,B                            ;- tak wic wywietl ostatni rekord
                sjmp    set_taryfa_print

set_taryfa_3:   cjne    a,#CYFRA_JUMP,set_taryfa_4      ;"3" to skok do dowolnego rekordu
                lcall   nr_rekordu
                mov     R0,a
                cjne    a,B,*+3                         ;Czy przekroczono tablic ?
                jc      set_taryfa_print                ;- nie wic skocz
                mov     R0,B                            ;- tak wic ustaw ostatni
                sjmp    set_taryfa_print

set_taryfa_4:   cjne    a,#CYFRA_EDIT,set_taryfa_5      ;"4" to edycja
                setb    FL_ZMIANY                       ;Zaznacz, e byy zmiany
                lcall   edytuj_taryfe                   ;Skocz do edycji
                sjmp    set_taryfa_print

set_taryfa_5:   cjne    a,#CYFRA_ADD,set_taryfa_6       ;"5" to dodaj taryf
                setb    FL_ZMIANY                       ;Zaznacz, e byy zmiany
                inc     B                               ;Dodaj taryf
                mov     a,B                             ;czy przekroczono zakres ?
                cjne    a,#(taryfy_end-taryfy)/8-1,*+3
                jnc     set_taryfa_0                    ;- tak wic skocz
                mov     R0,B                            ;- nie wic edytuj
                lcall   edytuj_taryfe                   ;Skocz do edycji
                push    RR0                             ;Ustaw nastpn taryf jako pust
                inc     R0
                lcall   wylicz_adres_taryfy             ;w dptr adres taryfy
                mov     a,#END_TARYFA
                lcall   write_eeprom
                pop     RR0
                sjmp    set_taryfa_print
set_taryfa_6:
set_taryfa_7:   cjne    a,#CYFRA_PRINT,set_taryfa_8     ;"7" to wydruk
                push    RR0                             ;Ochrona nr prefiksu
                push    B
                lcall   print_taryfy
                pop     B
                pop     RR0
                sjmp    set_taryfa_print

set_taryfa_8:
set_taryfa_9:   cjne    a,#CYFRA_EXIT,set_taryfa_wait   ;"9" to wyjcie, inna cyfra to skok do menu
                jnb     FL_ZMIANY,set_taryfa_quit       ;Wyjcie z tablicy jeli nie wprowadzono zmian
                lcall   sortuj_taryfy                   ;Sortowanie
set_taryfa_quit:ljmp    generuj_sume_taryf              ;Zapisanie sumy kontrolnej
                                        ;<--- Zastpuje RET
;----------------------------------------------------------------------------
;Opis: Wywietla taryf na LCD
;we: R0 - nr taryfy
;wy: C  - (C=0 ok, C=1 koniec taryf)
;
print_tar_R0:   lcall   wylicz_adres_taryfy             ;Oblicza adres tablicy taryf w EEPROm
                lcall   read_eeprom                     ;Pobierz bajt
                cjne    a,#END_TARYFA,print_tar_R0_2    ;Sprawd czy konic tablicy
                setb    C                               ; - tak koniec wic wyjd
                ret
print_tar_R0_2: push    ACC                             ;Zapamitaj taryf
                mov     a,#"t"                          ;Drukuje napis ": t"
                lcall   print_char
                pop     ACC                             ;Drukuj taryf
                lcall   print_hex
                lcall   print_spc                       ;Drukuj godzin
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex

                lcall   print_spc                       ;Drukuj okres zaliczania
                inc     dptr
                lcall   read_eeprom
                lcall   print_nible                     ;najstarsze zero olewamy
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex
                mov     a,#","
                lcall   print_char
                inc     dptr
                lcall   read_eeprom
                lcall   print_hex
        ;        lcall   print_spc               ;Drukuj okres zaliczania
        ;        inc     dptr                    ; dla dni witecznych
        ;        lcall   read_eeprom
        ;        lcall   print_nible             ;najstarsze zero olewamy
        ;        inc     dptr
        ;        lcall   read_eeprom
        ;        lcall   print_hex
        ;        mov     a,#","
        ;        lcall   print_char
        ;        inc     dptr
        ;        lcall   read_eeprom
        ;        lcall   print_hex
                clr     C
                ret


;----------------------------------------------------------------------------
;Opis: Wpisuje do eeprom taryf o nr zawartym w R0
;
edytuj_taryfe:  lcall   curs_on
                mov     dptr,#txt_set_tar1
                lcall   print_text
                lcall   wylicz_adres_taryfy             ;W dptr adres taryfy
                mov     poz_wys,#$40                    ;Pierwotna pozycja kursora na LCD
                lcall   wait_bajt                       ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
                inc     dptr                            ;W dptr adres godziny taryfy
                mov     poz_wys,#$44                    ;Pierwotna pozycja kursora na LCD
                lcall   wait_bajt                       ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
                inc     dptr                            ;W dptr najstarszy okresu
                mov     poz_wys,#$49                    ;Pierwotna pozycja kursora na LCD
                lcall   wait_nible                      ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
                inc     dptr                            ;W dptr redni okresuzaliczania
                lcall   wait_bajt                       ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
                mov     a,#","                          ;Wydruk kropki dziesitnej
                lcall   print_char
                inc     dptr                            ;W dptr najmodszy okresu
                lcall   wait_bajt                       ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom

                push    DPH                             ;Ochrona adresu eepromu
                push    DPL
                mov     dptr,#txt_set_tar2
                lcall   print_text
                pop     DPL
                pop     DPH
                inc     dptr                            ;W dptr najstarszy okresu zaliczania
                lcall   wait_nible                      ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
                inc     dptr                            ;W dptr redni okresuzaliczania
                lcall   wait_bajt                       ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
                mov     a,#","                          ;Wydruk kropki dziesitnej
                lcall   print_char
                inc     dptr                            ;W dptr najmodszy okresu
                lcall   wait_bajt                       ;Czekan na cyfr
                jb      F0,edytuj_taryfe_end            ;Odlorzenie suchawki to wyjcie
                lcall   write_eeprom
edytuj_taryfe_end:
                ret

txt_set_tar1:   BYTE    CLS_ASCII
                        ;0123456789012345
                STRING  'Tar Godz Okres'
                        ;00  00   000.00
                BYTE    END_ASCII

txt_set_tar2:   BYTE    CLS_ASCII
                STRING  'Wolne dni '
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Kopiuje taryf wskazywan przez R0+1 w miejsce R0
;we: R0 - rekord do skopiowania
;Zmienia: Acc, R1, R6, R7, dptr
;
copy_taryfa:    push    RR0                             ;Ochrona nr taryfy
                inc     R0                              ;Nr rekordu R0+1
                lcall   tar_do_buf                      ;W buforze mamy zaadowany cayrekors
                dec     R0                              ;Nr prefiksu R0
                lcall   wylicz_adres_taryfy             ;W dptr adres rekordu wskazanego przez R0
                mov     R7,#8                           ;Liczba bajtw w rekordzie
                mov     R1,#buf_cyf_str                 ;Bufor z wczytanym rekordem
copy_tar_2:     mov     a,@R1                           ;Odczytaj bajt z bufora
                lcall   write_eeprom                    ; i kopiowanie do eeprom
                inc     R1                              ;Wskanik na next bajt bufora
                inc     dptr                            ;Wskanik na next bajt eeprom
                djnz    R7,copy_tar_2
                pop     RR0
                ret

;----------------------------------------------------------------------------
;Opis: Kasuje rekord taryfywskazywany przez R0
;
del_taryfa:     mov     dptr,#txt_del                   ;Napis na LCD
                lcall   print_text
                mov     a,R0                            ;czy ostatni rekord ?
                cjne    a,B,del_taryfa_1                ; - nie wic kopiuj
                sjmp    del_taryfa_2                    ; - tak wic wstaw znacznik END_PREFISK
del_taryfa_1:  ;??? lcall   reset_watchdog
                lcall   copy_taryfa                     ;Przesunicie w d prefiksu
                inc     R0                              ;next prefiks
                mov     a,R0                            ;czy ostatni ?
                cjne    a,B,del_taryfa_1                ; - nie wic kopiuj next
del_taryfa_2:   mov     R0,B                            ; - tak wic wstaw znacznik END_PREFISK
                lcall   wylicz_adres_taryfy             ;w dptr adres prefiksu
                mov     a,#END_TARYFA
                ljmp    write_eeprom            ;<--- Zastpuje RET

 ELSE
                ljmp    kompile_error                   ;Wyczone z kompilacja
 ENDI

;----------------------------------------------------------------------------
;Opis: Czeka na kod dostpu, wyjdzie jeli bdzie prawidowy lub odoy si suchawk
;wy: F0 - (F0=1 odorzono suchawk)
;    C  - (C=0 kod ok, C=1 ly kod)
;
wait_kod:       lcall   curs_on
                mov     dptr,#txt_kod           ;Napis na LCD
                lcall   print_text

                lcall   wait_bajt               ;Czeka na kod
                jb      F0,wait_kod_exit        ;Jei odorzono suchawk to wychodzi
                mov     B,a                     ;zapamitaj kod1 w B
                lcall   wait_bajt               ;Czeka na drugi kod
                jb      F0,wait_kod_exit        ;Jei odorzono suchawk to wychodzi
                cjne    a,kod2,wait_kod_zly     ;Porwnaj kod2 jeli rona to wyjd z C=1
                mov     a,B                     ;Odtworz kod1
                cjne    a,kod1,wait_kod_zly     ;Porwnaj kod1 jeli rona to wyjd z C=1
                clr     C                       ;Kody poprawne
                ret
wait_kod_zly:   setb    C
wait_kod_exit:  ret

txt_kod:        BYTE    CLS_ASCII
                STRING  'Kod '
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Opis: Wprowadza kod dostpu, nastpnie prosi o powtrzenie, jeli ok zapsiuje do eeprom
;
ustaw_kod:      lcall   curs_on
                mov     dptr,#txt_kod           ;Napis na LCD
                lcall   print_text
                lcall   wait_bajt               ;Czeka na kod
                jb      F0,ustaw_kod_exit       ;Jei odorzono suchawk to wychodzi
                mov     R7,a                    ;Zapamituje kod1a w R7
                lcall   wait_bajt               ;Czeka na kod
                jb      F0,ustaw_kod_exit       ;Jei odorzono suchawk to wychodzi
                mov     R6,a                    ;Zapamituje kod2a w R6
                mov     dptr,#txt_kod_ponownie  ;Napis na LCD
                lcall   print_text
                lcall   wait_bajt               ;Czeka na kod1b
                jb      F0,ustaw_kod_exit       ;Jei odorzono suchawk to wychodzi
                mov     R5,a                    ;Zapamituje kod1b w R5
                lcall   wait_bajt               ;Czeka na kod2b
                jb      F0,ustaw_kod_exit       ;Jeli odorzono suchawk to wychodzi
                mov     B,R6                    ;Jeli wprowadzono rzne kod2 to ponownie
                cjne    a,B,ustaw_kod
                mov     a,R7
                mov     B,R5                    ;Jeli wprowadzono rzne kod1 to ponownie
                cjne    a,B,ustaw_kod
                mov     kod1,R7                 ;Wprowadzono zgodne wic zapis kpdow do RAM
                mov     kod2,R6                 ; i do eeprom
                lcall   write_konfig
ustaw_kod_exit: ret

txt_kod_ponownie:
                BYTE    CLS_ASCII
                STRING  'Ponownie '
                BYTE    END_ASCII

;----------------------------------------------------------------------------
;Jeli wyjcie na drukark do wysya kod FEED
;
auto_feed:      mov     a,std_out
                cjne    a,#STD_OUT_PRT,auto_feed_exit
                mov     dptr,#txt_feed
                lcall   print_text
auto_feed_exit: ret

txt_feed:       BYTE    CR_ASCII,LF_ASCII,FEED_ASCII,END_ASCII

;----------------------------------------------------------------------------
;Opis: Oblicza zajto bufora i generuje status "Zostao 10%bufora" i "Bufor peny"
;
zajetosc_bufora:lcall   oblicz_licznik          ;Oblicza stan licznika wynik W R2, R3
                mov     a,R2                    ;Sprawd czy liczba rekordw=pojemno bufora
                cjne    a,max_rekord_l,sprawdz_90
                mov     a,R3
                cjne    a,max_rekord_h,sprawdz_90
                mov     a,#STATUS_BUFOR_FULL    ;tak - komunikat o przepenieniu bufora
                ljmp    ustaw_status    ;<--- Zastpuje RET
sprawdz_90:     mov     DPL,max_rekord_l        ;Sprawd czy bufor zajty w 90%
                mov     DPH,max_rekord_h
                mov     B,#3                    ;max rekord dzielimy przez 8
spr_90_l1:      mov     a,DPH                   ; do daje 12,5% pojemnoci bufora
                rr      a                       ; wynik w dptr
                mov     DPH,a
                mov     a,DPL
                rrc     a
                mov     DPL,a
                djnz    B,spr_90_l1
                clr     C                       ;Te 12% odejmujemy od pojemnoci bufora
                mov     a,max_rekord_l          ; co da warto prawie 80% pojemnoci
                subb    a,DPL                   ; wynik w R4, R5
                mov     R4,a
                mov     a,max_rekord_h
                subb    a,DPH
                mov     R5,a
                clr     C                       ;Sprawd czy liczba rekordw
                mov     a,R2                    ; wiksza od 80% pojemnoci
                subb    a,R4
                mov     a,R3
                subb    a,R5
                jc      spr_90_nie
                mov     a,#STATUS_BUFOR_90      ;tak - komunikat o przepenieniu bufora
                ljmp    ustaw_status    ;<--- Zastpuje RET
spr_90_nie:     ret

;----------------------------------------------------------------------------
;
;
ZNNR:           equ     8                       ;Liczba cyfr nr do wywietlenia
;
print_ostatnie: lcall   szukaj_free_rekord
prn_ost_0:      lcall   cls                     ;Wydruk rekordu
                lcall   prev_rekord             ;Kolejny rekord
                lcall   get_rejestr             ;Miesic
                jnc     prn_ost_1               ; jeli ostatni
                mov     dptr,#txt_koniec        ; wydrukuj komunikat
                lcall   print_text              ; czekaj 2 sekundy i wyjd
                mov     a,#20
                ljmp    delay_100ms      ;<--- Zastpuje RET
prn_ost_1:
 IF MAREK=NO                            ;Dla MARKA nie wywietlamy miesiaca
                lcall   print_hex               ; wywietl miesic
                mov     a,#"/"
                lcall   print_char
 ENDI
                lcall   get_rejestr             ;Dzie
                lcall   print_hex
                lcall   print_spc
                lcall   get_rejestr             ;Godzina
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                lcall   get_rejestr             ;Minuta
                lcall   print_hex
                lcall   print_spc

                lcall   print_crlf              ;Wybrany numer
 IF MAREK=YES                           ;Dla MARKA wywietlamy cay bufor cyfr numeru
                mov     R7,#12/2
prn_ost_2:      lcall   get_rejestr             ; pobranie z eeprom
                lcall   print_hex_spec__        ; i na lcd
                djnz    R7,prn_ost_2
 ELSE
                mov     R7,#ZNNR/2
prn_ost_2:      lcall   get_rejestr             ; pobranie z eeprom
                lcall   print_hex_spec__        ; i na lcd
                djnz    R7,prn_ost_2            ; jeli zmieci si na lcd to powtrz
                mov     R7,#(buf_cyf_end-buf_cyf_str)/2-(ZNNR/2)
prn_ost_3:      lcall   get_rejestr             ;pobierz cyfry ktre nie uka si na LCD
                anl     a,#$F0                  ; sprzwd czy koniec nr czy nie
                cjne    a,#CYFRA_EMPTY SHL 4,prn_ost_31
                mov     a,#" "                  ; koniec nr wic znak spacji
                sjmp    prn_ost_32
prn_ost_31:     mov     a,#">"                  ; nie koniec nr wic znak ">"
prn_ost_32:     mov     B,a                     ; zapamitaj znak do wywietlenia w B
                djnz    R7,prn_ost_33           ;Czy cay bufor?
                sjmp    prn_ost_34              ; - tak wic skocz
prn_ost_33:     lcall   get_rejestr             ; - nie wic pobieraj kolejne
                djnz    R7,prn_ost_33
prn_ost_34:
 ENDI

 IF MAREK=YES                           ;Dla MARKA wywietlamy czas rozmowy "mm/ss" w pierwzej linii
                lcall   get_rejestr             ;Czas rozmowy - godziny
                mov     a,#10
                lcall   curs_set
                lcall   get_rejestr             ;Czas rozmowy - minuty
                lcall   print_hex
                mov     a,#":"
                lcall   print_char
                lcall   get_rejestr             ;Czas rozmowy - sekundy
                lcall   print_hex
 ELSE                                   ; dla pozostaych niewywietlamy czasu rozmowy ale musimy zdj rejestry
                lcall   get_rejestr             ;Czas rozmowy - godziny
                lcall   get_rejestr             ;Czas rozmowy - minuty
                lcall   get_rejestr             ;Czas rozmowy - sekundy
 ENDI

                mov     a,B                     ;odtwrz znak do wywietlenia (">" lub " ")
 IF MAREK=NO                            ;Dla MARKA niewywietlamy znaku ">"
                lcall   print_char
                lcall   print_spc
 ENDI

 IF MAREK=YES                           ;Dla MARKA koszt rozmowy wywietlamy jako sztan licznika
                mov     a,#$40+13
                lcall   curs_set
                lcall   get_rejestr             ; starszy licznika
                lcall   print_nible
                lcall   get_rejestr             ; modszy licznika
                lcall   print_hex
 ELSE
                lcall   get_rejestr             ; starszy licznika
                mov     R5,a
                lcall   get_rejestr             ; modszy licznika
                mov     R4,a
                mov     R7,#0
                mov     R6,#0
                mov     B,#5                    ; liczba cyfr do wywietlenia
                lcall   print_cena_licznika     ; Przeliczamy i wywietlamy jako kasa
 ENDI

prn_ost_4:    ;???  lcall   reset_watchdog          ;Czeka a przycisk bdzie puszczony
                jnb     PROGRAM,prn_ost_4
                mov     B,#50                   ;Czekaj 5 sekund
prn_ost_5:      lcall   wait_100ms
                jb      PROGRAM,prn_ost_6
                ljmp    prn_ost_0               ; jeli nacinito przycisku to skocz
prn_ost_6:      djnz    B,prn_ost_5             ; jeli nie i min czas to wyjd
                ret

;----------------------------------------------------------------------------
;>>>>>>>>>> Skanowanie magistral IIC, adresy wywietla na LCD <<<<<<<<<
;
skan_iic:       lcall   cls                             ;Wyczy wywietlacz
                mov     R0,#00h                         ;Najwyszy adres (256)
scan_iic_loop:  mov     a,R0
                lcall   test_adr_iic                    ;Czy ukad odpowiada ?
                jnc     scan_iic_loop1
                mov     a,R0                            ; tak wic wywietl adres na LCD
                lcall   print_hex
                mov     a,#" "                          ; i zrb odstp
                lcall   print_char
scan_iic_loop1  dec     R0                              ;Next adres
                djnz    R0,scan_iic_loop                ;Czy ostatni ?
                mov     a,#"e"                          ; tak wic oznacz, e ostatni
                lcall   print_char
skan_end:       lcall   reset_watchdog
                sjmp    skan_end

test_adr_iic:   lcall	iic_start
		lcall	iic_write
		jc	test_iic_niema		;Sprawdzenie czy ACK
		lcall	iic_stop
                setb    C                       ;C=1 - ukad odpowiedzia
                ret
test_iic_niema: lcall   iic_stop
                clr     C                       ;C=0 - ukad nieodpowiedzia
                ret

;----------------------------------------------------------------------------
;Opis: Ustawia standard rejestratora
;
set_standard:
 IF INIT_TABLICE
                lcall   curs_on
                mov     dptr,#txt_clr_konfig    ;Wywietlenie pytania na LCD
                lcall   print_text
                lcall   wait_cyfra_01           ;Czekanie na cyfr 1 lub 0
                jb      F0,set_std_exit         ;Jeli odoona suchawka pomi
                jc      set_std_0               ; jeli "1" skocz
set_std_exit:   ret
set_std_0:      mov     dptr,#txt_napewno       ;Wywietlenie pytania na LCD
                lcall   print_text
                lcall   wait_cyfra_01           ;Czekanie na cyfr 1 lub 0
                jb      F0,set_std_exit         ;Jeli odoona suchawka pomi
                jc      set_std_1               ; jeli "1" skocz
                ret                             ; jeli nie wyjd
set_std_1:      mov     dptr,#txt_init
                lcall   print_text
                mov     kryterium_rozmowy,#POLARYZACJA
                mov     cena_zl,#$00
                mov     cena_gr,#$35
                mov     cena_vat,#$22
                mov     prt_pl,#BEZ_PL
                mov     ser_pl,#BEZ_PL
 IF SAA1064=YES ;--- dla SAA1064 wydruk na serial ---
                mov     printer_device,#SERIAL_PRINTER
 ELSE
                mov     printer_device,#PARALLEL_PRINTER
 ENDI
                mov     kod1,#$11
                mov     kod2,#$11
                lcall   write_konfig

                ;--------------- Prefiksy ------------------
                mov     R2,#0                           ;Zerowanie licznika rekordw
                lcall   wylicz_adres_prefiksu           ;w dptr adres w eeprom prefiksu
                mov     R4,DPL
                mov     R5,DPH
                mov     dptr,#std_pref_start    ;??? Szukanie od tego miejsca tekstu "StdPre"
                                                ;     i mamy pocztek tablicy
                mov     R6,DPL
                mov     R7,DPH
set_std_2:    ;???  lcall   reset_watchdog
                mov     DPL,R6                          ;Pobranie elementu z tablicy
                mov     DPH,R7
                clr     A
                movc    a,@a+dptr
                inc     dptr
                mov     R6,DPL
                mov     R7,DPH
                mov     DPL,R4                          ;Zapisanie do eeprom
                mov     DPH,R5
                lcall   write_eeprom
                inc     dptr
                mov     R4,DPL
                mov     R5,DPH
        ;??? Jakim sposobem trzeba obliczy koniec tablicy
                cjne    R6,#LOW  std_pref_end,set_std_2 ;Porwnanie czy koniec tablicy
                cjne    R7,#HIGH std_pref_end,set_std_2
                lcall   generuj_sume_prefiksow          ;Wygenerowanie sumy kontrolnej

                ;--------------- Taryfy ------------------
                mov     R0,#0                           ;Zerowanie licznika rekordw
                lcall   wylicz_adres_taryfy             ;w dptr adres w eeprom taryfy
                mov     R4,DPL
                mov     R5,DPH
                mov     dptr,#std_tar_start     ;??? Szukanie od tego miejsca tekstu "StdPre"
                                                ;     i mamy pocztek tablicy
                mov     R6,DPL
                mov     R7,DPH
set_std_3:    ;???  lcall   reset_watchdog
                mov     DPL,R6                          ;Pobranie elementu z tablicy
                mov     DPH,R7
                clr     A
                movc    a,@a+dptr
                inc     dptr
                mov     R6,DPL
                mov     R7,DPH
                mov     DPL,R4                          ;Zapisanie do eeprom
                mov     DPH,R5
                lcall   write_eeprom
                inc     dptr
                mov     R4,DPL
                mov     R5,DPH
        ;??? Jakim sposobem trzeba obliczy koniec tablicy
                cjne    R6,#LOW  std_tar_end,set_std_3  ;Porwnanie czy koniec tablicy
                cjne    R7,#HIGH std_tar_end,set_std_3
                lcall   generuj_sume_taryf              ;Wygenerowanie sumy kontrolnej
                lcall   print_ok
                ret


txt_init:       BYTE    CLS_ASCII
                STRING  'Init..'
                BYTE    END_ASCII

;??? Tablice musz znale si na kocu pamici programu (za programem)

;                       nr godz okres BCD    okres BCD
;                               zwyke dni   witeczne
                STRING  'StdTar'                                ;Znacznik pocztka tablicy
std_tar_start:  BYTE    $00,$00,DAR,$00,$00, DAR,$00,$00        ; 1 Taryfa 00       - Bezpatna
                BYTE    $01,$00,JED,$00,$00, JED,$00,$00        ; 2 Taryfa 01       - Jednokrotna
                BYTE    $02,$08,$01,$80,$00, $03,$60,$00        ; 3 Taryfa 02 od  8 - co 180.00 sek
                BYTE    $02,$22,$03,$60,$00, $03,$60,$00        ; 4 Taryfa 02 od 22 - co 360.00 sek
                BYTE    $03,$00,$00,$60,$00, $00,$60,$00        ; 5 Taryfa 03       - co  60.00 sek
                BYTE    $04,$08,$00,$43,$50, $00,$58,$00        ; 6 Taryfa 04 od  8 - co  33.70 sek
                BYTE    $04,$18,$00,$87,$00, $00,$87,$00        ; 7 Taryfa 04 od 18 - co  45.00 sek
                BYTE    $06,$00,$00,$31,$10, $00,$31,$10        ; 9 Taryfa 06       - co  13.50 sek
                BYTE    $07,$00,$00,$08,$70, $00,$08,$70        ;10 Taryfa 07       - co   8.10 sek
                BYTE    $08,$00,$00,$04,$36, $00,$04,$36        ;11 Taryfa 08       - co   3.16 sek
                BYTE    $09,$08,$00,$12,$40, $00,$16,$60        ;12 Taryfa 09 od  8 - co  11.60 sek
                BYTE    $09,$18,$00,$16,$60, $00,$16,$60        ;13 Taryfa 09 od 18 - co  15.40 sek
                BYTE    $09,$22,$00,$24,$90, $00,$24,$90        ;14 Taryfa 09 od 22 - co  23.10 sek
                BYTE    $10,$00,$00,$12,$50, $00,$12,$50        ;15 Taryfa 10       - co  11.60 sek
                BYTE    $11,$00,$00,$11,$20, $00,$11,$20        ;16 Taryfa 11       - co  10.40 sek
                BYTE    $12,$00,$00,$10,$30, $00,$10,$30        ;17 Taryfa 12       - co   9.58 sek
                BYTE    $13,$00,$00,$09,$32, $00,$09,$32        ;18 Taryfa 13       - co   8.66 sek
                BYTE    $14,$00,$00,$08,$30, $00,$08,$30        ;19 Taryfa 14       - co   7.72sek
                BYTE    $15,$00,$00,$05,$04, $00,$05,$04        ;20 Taryfa 15       - co   4.66 sek
                BYTE    $16,$00,$00,$02,$80, $00,$02,$80        ;21 Taryfa 16       - co   2.60 sek
                BYTE    $17,$08,$01,$80,$00, $03,$60,$00        ;22 Taryfa 17 od  8 - co 180.00 sek
                BYTE    $17,$18,$03,$60,$00, $03,$60,$00        ;23 Taryfa 17 od 18 - co 360.00 sek
                BYTE    $19,$08,$00,$43,$50, $00,$58,$00        ;22 Taryfa 19 od  8 - co 180.00 sek
                BYTE    $19,$18,$00,$87,$00, $00,$87,$00        ;23 Taryfa 19 od 22 - co 360.00 sek
                BYTE    $20,$08,$00,$43,$50, $00,$58,$00        ;22 Taryfa 20 od  8 - co 180.00 sek
                BYTE    $20,$18,$00,$87,$00, $00,$87,$00        ;23 Taryfa 20 od 22 - co 360.00 sek
                BYTE    $21,$08,$00,$43,$50, $00,$58,$00        ;22 Taryfa 21 od  8 - co 180.00 sek
                BYTE    $21,$18,$00,$87,$00, $00,$87,$00        ;23 Taryfa 21 od 22 - co 360.00 sek
                BYTE    END_TARYFA
std_tar_end:

                STRING  'StdPre'                                ;Znacznik pocztka tablicy
;??? Prefiks pusty musi by pierwszy
std_pref_start: BYTE    $02                                     ;Taryfa 1bajt
                BYTE    $ff,$ff,$ff,$ff,$ff,$ff                 ;numer  6bajtw (12 cyfr)
                STRING  'M/M      '                             ;text   9bajtw (9 liter)
                BYTE    $04                          		;Taryfa
                BYTE    $0f,$ff,$ff,$ff,$ff,$ff                 ;0
                STRING  'M/M      '

		BYTE    $02                          		;Taryfa         
                BYTE    $19,$ff,$ff,$ff,$ff,$ff                 ;19
                STRING  'AUS      '                             
		BYTE    $02                          		;Taryfa         
                BYTE    $11,$ff,$ff,$ff,$ff,$ff                 ;11
                STRING  'AUS      '                             
                BYTE    $00                          		;Taryfa
                BYTE    $99,$ff,$ff,$ff,$ff,$ff                 ;99
                STRING  'Alarmowy '
                BYTE    $00                          		;Taryfa
                BYTE    $98,$ff,$ff,$ff,$ff,$ff                 ;98
                STRING  'Alarmowy '
                BYTE    $00                          		;Taryfa
                BYTE    $11,$2f,$ff,$ff,$ff,$ff                 ;112
                STRING  'Alarmowy '
                BYTE    $01                          		;Taryfa
                BYTE    $11,$8f,$ff,$ff,$ff,$ff                 ;118
                STRING  'Uslugi   '
                BYTE    $01                          		;Taryfa
                BYTE    $11,$6f,$ff,$ff,$ff,$ff                 ;116
                STRING  'Uslugi   '
                
		BYTE    $02                          		;Taryfa O          
                BYTE    $05,$4f,$ff,$ff,$ff,$ff                 ;054
                STRING  'Lokalna  '                             
		BYTE    $02                          		;Taryfa O          
                BYTE    $03,$9f,$ff,$ff,$ff,$ff                 ;039
                STRING  'Lokalna  '                             
		BYTE    $02                          		;Taryfa N          
                BYTE    $54,$ff,$ff,$ff,$ff,$ff                 ;54
                STRING  'Lokalna  '                             
		BYTE    $02                          		;Taryfa N          
                BYTE    $39,$ff,$ff,$ff,$ff,$ff                 ;39
                STRING  'Lokalna  '                             
                
                BYTE    $09                          		;Taryfa O
                BYTE    $05,$00,$ff,$ff,$ff,$ff                 ;050
                STRING  'GSM-Idea '
                BYTE    $09                          		;Taryfa O
                BYTE    $05,$01,$ff,$ff,$ff,$ff                 ;050
                STRING  'GSM-Idea '
                BYTE    $09                          		;Taryfa O
                BYTE    $06,$0f,$ff,$ff,$ff,$ff                 ;060
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa O
                BYTE    $06,$4f,$ff,$ff,$ff,$ff                 ;064
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa O
                BYTE    $06,$6f,$ff,$ff,$ff,$ff                 ;066
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa O
                BYTE    $06,$9f,$ff,$ff,$ff,$ff                 ;069
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa O
                BYTE    $07,$2f,$ff,$ff,$ff,$ff                 ;072
                STRING  'GSM-Plus  '
                BYTE    $09                          		;Taryfa O
                BYTE    $07,$8f,$ff,$ff,$ff,$ff                 ;078
                STRING  'GSM-Plus  '
                BYTE    $09                          		;Taryfa O
                BYTE    $79,$ff,$ff,$ff,$ff,$ff                 ;079
                STRING  'GSM-Play  '
                BYTE    $09                          		;Taryfa O
                BYTE    $09,$0f,$ff,$ff,$ff,$ff                 ;090
                STRING  'Centertel'
                BYTE    $09                          		;Taryfa N
                BYTE    $50,$ff,$ff,$ff,$ff,$ff                 ;50
                STRING  'GSM-Idea '
                BYTE    $09                          		;Taryfa N
                BYTE    $51,$ff,$ff,$ff,$ff,$ff                 ;51
                STRING  'GSM-Idea '
                BYTE    $09                          		;Taryfa N
                BYTE    $69,$ff,$ff,$ff,$ff,$ff                 ;60
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa N
                BYTE    $64,$ff,$ff,$ff,$ff,$ff                 ;64
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa N
                BYTE    $66,$ff,$ff,$ff,$ff,$ff                 ;66
                STRING  'GSM      '
                BYTE    $09                          		;Taryfa N
                BYTE    $69,$ff,$ff,$ff,$ff,$ff                 ;69
                STRING  'GSM      '                
                BYTE    $09                          		;Taryfa N
                BYTE    $72,$ff,$ff,$ff,$ff,$ff                 ;72
                STRING  'GSM-Plus  '
                BYTE    $09                          		;Taryfa N
                BYTE    $78,$ff,$ff,$ff,$ff,$ff                 ;78
                STRING  'GSM-Plus  '
                BYTE    $09                          		;Taryfa N
                BYTE    $79,$ff,$ff,$ff,$ff,$ff                 ;79
                STRING  'GSM-Play  '
                BYTE    $09                          		;Taryfa N
                BYTE    $90,$ff,$ff,$ff,$ff,$ff                 ;90
                STRING  'Centertel'

                BYTE    $09                          		;Taryfa O
                BYTE    $07,$0f,$ff,$ff,$ff,$ff                 ;090
                STRING  'Audiotele'
                BYTE    $00                          		;Taryfa O
                BYTE    $08,$00,$ff,$ff,$ff,$ff                 ;0800
                STRING  'Audiotele'
                BYTE    $02                          		;Taryfa O
                BYTE    $08,$0f,$ff,$ff,$ff,$ff                 ;080
                STRING  'Audiotele'
                BYTE    $09                          		;Taryfa N
                BYTE    $70,$ff,$ff,$ff,$ff,$ff                 ;90
                STRING  'Audiotele'
                BYTE    $00                          		;Taryfa N
                BYTE    $80,$0f,$ff,$ff,$ff,$ff                 ;800
                STRING  'Audiotele'
                BYTE    $02                          		;Taryfa N
                BYTE    $80,$ff,$ff,$ff,$ff,$ff                 ;80
                STRING  'Audiotele'

                BYTE    $16                          		;Taryfa N
                BYTE    $00,$ff,$ff,$ff,$ff,$ff                 ;00
                STRING  'Zagranica'
                BYTE    END_PREFIKS
std_pref_end:

 ELSE
                ljmp    kompile_error                   ;Wyczone z kompilacja
 ENDI

;;----------------------------------------------------------------------------
;;Opis: Startuje zapis strony do eeprom, i zapisuje jeden bajt do bufora eeprom
;;we: ACC  - dana do zapisu
;;    DPTR - adres bajtu w eeprom
;;wy: --
;;zmienia: --
;;
;str_wr_eeprom_16:
;                push    ACC
;                clr     ET0                             ;Przerwanie T0 i EX0 jest wyczane
;                clr     EX0                             ; poniewarz na irq wystpuj
;                                                        ; cykle dostpu do IIC
;                lcall   iic_start
;                mov     a,#EEPROM_WRITE
;                lcall   iic_write
;                jc      error_eeprom
;                mov     a,DPH
;                lcall   iic_write
;                mov     a,DPL
;str_wr_ee1:     lcall   iic_write
;                pop     ACC                             ;Odtwrz ACC
;                ret
;
;;----------------------------------------------------------------------------
;;Opis: Zapisuje bajt do bufora eeprom
;;      bajt jest zapisany pod kolejny adres w eeprom (nie trzeba zwiksza dptr)
;;we: ACC  - dana do zapisu
;;
;wr_eeprom_16:   push    ACC
;                sjmp    str_wr_ee1
;
;;----------------------------------------------------------------------------
;;Opis: Zapisuje bajt do bufora eeprom i koczy transmisj (uruchamia zapis)
;;      wyjcie nastpi po zapisaniu caego bufora
;;      bajt jest zapisany pod kolejny adres w eeprom  (nie trzeba zwiksza dptr)
;;we: ACC  - dana do zapisu
;;
;end_eeprom_16:  push    ACC                             ; i znw zapamitaj
;                lcall   iic_write                       ;Zapisz dan
;                lcall   iic_stop
;                mov     a,#EEPROM_READ                  ;czekaj na koniec zapisu bajtu
;                lcall   iic_wait
;                setb    ET0
;                setb    EX0
;                pop     ACC
;                ret
;
;
;----------------------------------------------------------------------------
;Do testowania DCF
;
;test:   lcall test_error   ;???
;        lcall test_bufor
;        ret
;
;test_error:
;        jb    FL_ERR_DCF,test_error_yes
;        ret
;test_error_yes:
;        push    std_out                         ;Zapamitaj std_out
;        mov     std_out,#STD_OUT_SER            ;Ustaw urzdzenie wyjciowe
;        mov   a,#"e"
;        lcall print_char
;        pop     std_out                         ;odtwrz std_out
;        ret
;
;test_bufor:
;        jb    FL_OK_DCF,test_bufor_ok
;        ret
;test_bufor_ok:
;        push    std_out                         ;Zapamitaj std_out
;        mov     std_out,#STD_OUT_SER            ;Ustaw urzdzenie wyjciowe
;        clr   FL_OK_DCF
;        lcall print_crlf
;        mov   a,dcf_start
;        lcall print_hex
;
;        lcall print_spc
;        mov   a,dcf_b1
;        lcall print_hex
;
;        lcall print_spc
;        mov   a,dcf_b2
;        lcall print_hex
;
;        lcall print_spc
;        mov   a,dcf_b3
;        lcall print_hex
;
;        lcall print_spc
;        mov   a,dcf_b4
;        lcall print_hex
;
;        lcall print_spc
;        mov   a,dcf_end
;        lcall print_hex
;
;
;
;        lcall print_crlf
;        mov   a,pam1
;        lcall print_hex
;
;        lcall print_spc
;        mov   a,pam2
;        lcall print_hex
;
;        pop     std_out                         ;odtwrz std_out
;        ret
;
;----------------------------------------------------------------------------
end_program:

;============================================================================
;=    Tablice taryf i kierunkw umieszczone w zewntrznym EEPROM            =
;============================================================================
                org     $0000
ee_versja:                                      ;Wersja pliku konfiguracji
                org     *+1
ee_kryterium_rozmowy:                           ;Kryterium rozmowy
                org     *+1
ee_cena_gr:                                     ;Cena impulsu - grosze
                org     *+1
ee_cena_zl:                                     ;Cena impulsu - zote
                org     *+1
ee_cena_vat:                                    ;Wielko podatku
                org     *+1
ee_kod1:                                        ;Kod dostpu (pierwsze 2 cyfry)
                org     *+1
ee_kod2:                                        ;Kod dostpu (kolejne 2 cyfry)
                org     *+1
ee_ser_pl:                                      ;Polskie znaki dla RS
                org     *+1
ee_prt_pl:                                      ;Polskie znaki dla drukarki
                org     *+1
ee_printer_device:                              ;Typ drukarki
                org     *+1
ee_bright_led:                                  ;Jasno wywietlaczy LED
                org     *+1
ee_suma:                                        ;Suma kontrolna

;---------------------------------
                org     $0010
taryfy:
                org     *+(50*8)
taryfy_end:

;---------------------------------
prefiksy:
                org     *+(250*16)
prefiksy_end:

;---------------------------------
bufor:

;----------------------------------------------------------------------------
;Wzr rekordu:
;               BYTE    $01,$30,$12,$15                     ;Data/Godzina          4bajty
;               BYTE    $01,$03,$35,$42,$80,$28             ;Wybrany nr            6bajtw
;               BYTE    $00,$15,$32                         ;Czas trwania rozmowy  3bajty
;               BYTE    $01,$25                             ;Stan licznika         2bajty
;               BYTE    SUMA_KONTROLNA                      ;Suma kontrolna        1bajt
;                                                                          RAZEM: 16bajtw
;       Next    BYTE    END_REJESTR
;
;----------------------------------------------------------------------------

